//---------------------------------------------------
// VS[h
//---------------------------------------------------

#pragma once

#include "sceneBase.h"


#include "stageCamera.h"

#include "interFace.h"
#include "timer.h"
#include "nageru.h"

#include "field.h"

#include "effect.h"

#include "sound.h"

class CVSMode : public CSceneBase
{
private:
	CStageCamera camera;

	fk_RectTexture		bgTex[6] ;
	fk_Model			bgModel[6] ;

	fk_Vector nageruPos, enemyPos;

	CInterFace interFace;
	CTimer	timer;
	CNageru nageru_p1;
	CNageru nageru_p2;

	CField field;
	unsigned int standBlockID;
	unsigned int throwBlockID;
	unsigned int hitThrowBlockID;
	fk_Vector blockSpd;
	fk_Vector zeroSpd;
	
	CEffect	effect_p1;
	CEffect	effect_p2;
	int repairID[10];
	int dammyID[10];
	

	CSound sound;

	enum DirectionStatus{
	DIRECTION_UP = 0,
	DIRECTION_DOWN,
	DIRECTION_LEFT,
	DIRECTION_RIGHT
	};

	DirectionStatus directionStatus;

	enum Ino_MotionStatus
	{
		INO_STOP = -1,
		INO_STAND,	//0 _ij
		INO_RUSH,	//1 Aj}XbV
		INO_THROW,	//2 Aj}X[
		INO_REPAIR,	//3 Aj}yA
		INO_CURE,	//4 Aj}LA
	};

	Ino_MotionStatus ino_motionStatus;

	int cursorNum;

	static const int maxLife = 150;

public:
	CVSMode();
	~CVSMode();

	void	init();
	bool	onPeriod();

	void loadBG();
};
