//---------------------------------------------------
// 
//---------------------------------------------------

#include "cInput.h"

CInput::CInput()
{
	for( int i=0 ; i<INPUT_MAX ; i++ )
	{
		keyDataBefore[i] = keyDataNow[i] = false ;
		padDataBefore[0][i] = padDataNow[0][i] = false ;
		padDataBefore[1][i] = padDataNow[1][i] = false ;
	}
}

CInput::~CInput()
{
	fInput.uninit();
}

/*
 ̃NXg߂̏
 */
void CInput::init( Fl_Window *lw , fk_Window *kw )
{
	// fkut_Inputg
	if( fInput.init( fl_display , fl_xid( lw ) ) == S_OK )
	{
		isInit = true ;
	}
	else
	{
		isInit = false ;
		fl_alert( "fkut_Input init error." );
	}

	window = kw ;
	inputCodeInit();
	loadCode( "keyConfig.dat" );
	update();
	update();
}

/*
 R[hftHgɐݒ
 */
void CInput::inputCodeInit()
{
	keyCode[INPUT_1]	  = 'z' ;
	keyCode[INPUT_2]	  = 'x' ;
	keyCode[INPUT_3]	  = 'c' ;
	keyCode[INPUT_4]	  = 'v' ;
	keyCode[INPUT_5]	  = ' ' ;
	keyCode[INPUT_START]  = 'p' ;
	keyCode[INPUT_SELECT] = 's' ;
	for( int i=0 ; i<2 ; i++ )
	{
		padCode[i][INPUT_1]		 = 0 ;
		padCode[i][INPUT_2]		 = 1 ;
		padCode[i][INPUT_3]		 = 2 ;
		padCode[i][INPUT_4]		 = 3 ;
		padCode[i][INPUT_5]		 = 4 ;
		padCode[i][INPUT_START]	 = 5 ;
		padCode[i][INPUT_SELECT] = 6 ;
	}
}

/*
 R[hݒǂݍ
 */
void CInput::loadCode( const char* pass )
{
	std::ifstream txt( pass );
	if( txt.fail() )
	{
		fl_alert( "read error [%s]" , pass );
		return ;
	}
	// ǂݍ݊Jn
	for( int i=0 ; i<INPUT_MAX-4 ; i++ )
	{
		txt >> keyCode[i] ;
		// '!'' 'ɕϊ
		if( keyCode[i] == '!' )
		{
			keyCode[i] = ' ' ;
		}
		txt >> padCode[0][i] ;
		txt >> padCode[1][i] ;
	}
	txt.close();
}

/*
 R[hݒ菑
 */
void CInput::saveCode( const char* pass )
{
	std::ofstream txt( pass );
	if( txt.fail() )
	{
		fl_alert( "read error [%s]" , pass );
		return ;
	}
	// ݊Jn
	for( int i=0 ; i<INPUT_MAX-4 ; i++ )
	{
		// ' ''!'őp
		if( keyCode[i] == ' ' )
		{
			txt << '!' << " " ;
		}
		else
		{
			txt << keyCode[i] << " " ;
		}
		txt << padCode[0][i] << " " << padCode[1][i] << std::endl ;
	}
	txt.close();
}

/*
 R[h̐ݒiL[{[hj
 */
void CInput::setKeyCode( int key , char newCode )
{
	if( key >= 0 && key < INPUT_MAX-4 )
	{
		keyCode[key] = newCode ;
	}
}

/*
 R[h̐ݒipbhj
 */
void CInput::setPadCode( int pad , int button , int newCode )
{
	if( ( pad == 0 || pad == 1 ) || ( button >= 0 && button < INPUT_MAX-4 ) )
	{
		padCode[pad][button] = newCode ;
	}
}

/*
 ͎tƃf[^XV
 */
void CInput::update()
{
	// ݂̃f[^ߋ̃f[^ɓ]
	for( int i=0 ; i<INPUT_MAX ; i++ )
	{
		keyDataBefore[i] = keyDataNow[i] ;
		padDataBefore[0][i] = padDataNow[0][i] ;
		padDataBefore[1][i] = padDataNow[1][i] ;
	}

	// L[{[h̓͏XV
	for( int i=0 ; i<7 ; i++ )
	{
		keyDataNow[i] = window->getKeyStatus( keyCode[i] );
	}
	keyDataNow[7]  = window->getSpecialKeyStatus( FK_UP );
	keyDataNow[8]  = window->getSpecialKeyStatus( FK_RIGHT );
	keyDataNow[9]  = window->getSpecialKeyStatus( FK_DOWN );
	keyDataNow[10] = window->getSpecialKeyStatus( FK_LEFT );

	// pbhXeBbN̓͏XV
	if( isInit )
	{
		fInput.update();
		padInputData[0] = fInput.getInputStatus( 1 );
		padInputData[1] = fInput.getInputStatus( 2 );
		for( int i=0 ; i<2 ; i++ )
		{
			for( int j=0 ; j<7 ; j++ )
			{
				if( padCode[i][j] < 32 )
				{
					padDataNow[i][j] = padInputData[i].button[padCode[i][j]] ;
				}
			}
			padDataNow[i][7]  = padInputData[i].up ;
			padDataNow[i][8]  = padInputData[i].right ;
			padDataNow[i][9]  = padInputData[i].down ;
			padDataNow[i][10] = padInputData[i].left ;
		}
		stick[0].leftX = padInputData[0].x[0] ;
		stick[0].leftY = padInputData[0].y[0] ;
		stick[0].rightX = padInputData[0].x[1] ;
		stick[0].rightY = padInputData[0].y[1] ;
		stick[1].leftX = padInputData[1].x[0] ;
		stick[1].leftY = padInputData[1].y[0] ;
		stick[1].rightX = padInputData[1].x[1] ;
		stick[1].rightY = padInputData[1].y[1] ;
	}
}

/*
 ͔iꂽj
 */
bool CInput::checkDown( int key , int dev )
{
	if( dev%2 == 1 &&  padDataNow[0][key] && !padDataBefore[0][key] )
	{
		return true ;
	}
	if( dev%4 >= 2 &&  padDataNow[1][key] && !padDataBefore[1][key] )
	{
		return true ;
	}
	return ( dev%8 >= 4 &&  keyDataNow[key] && !keyDataBefore[key] ) ;
}

/*
 ͔iꂽj
 */
bool CInput::checkUp( int key , int dev )
{
	if( dev%2 == 1 && !padDataNow[0][key] &&  padDataBefore[0][key] )
	{
		return true ;
	}
	if( dev%4 >= 2 && !padDataNow[1][key] &&  padDataBefore[1][key] )
	{
		return true ;
	}
	return ( dev%8 >= 4 && !keyDataNow[key] &&  keyDataBefore[key] ) ;
}

/*
 ͔iĂŒj
 */
bool CInput::checkPress( int key , int dev )
{
	if( dev%2 == 1 &&  padDataNow[0][key] )
	{
		return true ;
	}
	if( dev%4 >= 2 &&  padDataNow[1][key] )
	{
		return true ;
	}
	return ( dev%8 >= 4 &&  keyDataNow[key] ) ;
}

/*
 XeBbNXiisPlayerOne=true1PAfalse2Pj
 */
inputStickType CInput::checkStick( bool isPlayerOne )
{
	return stick[( isPlayerOne ? 0 : 1 )] ;
}
