//---------------------------------------------------
// 
//---------------------------------------------------

#include "cInput.h"

CInput::CInput()
{
	for( int i=0 ; i<INPUT_MAX ; i++ )
	{
		keyDataBefore[i] = keyDataNow[i] = false ;
		padDataBefore[0][i] = padDataNow[0][i] = false ;
		padDataBefore[1][i] = padDataNow[1][i] = false ;
	}
}

CInput::~CInput()
{
	fInput.uninit();
}

/*
 ̃NXg߂̏
 */
void CInput::init( Fl_Window *lw , fk_Window *kw )
{
	// fkut_Inputg
	if( fInput.init( fl_display , fl_xid( lw ) ) == S_OK )
	{
		padNum = (int)fInput.getJoyCount();
		if( padNum > 2 ) padNum = 2 ;
	}
	else
	{
		padNum = 0 ;
		fl_alert( "fkut_Input init error" );
	}

	window = kw ;
	inputCodeInit();
	loadCode( "keyConfig.dat" );
	update();
	update();
}

/*
 R[hftHgɐݒ
 */
void CInput::inputCodeInit()
{
	keyCode[INPUT_1]	  = 'z' ; // XbV
	keyCode[INPUT_2]	  = 'x' ; // X[
	keyCode[INPUT_3]	  = 'c' ; // Wv
	keyCode[INPUT_4]	  = 'v' ; // tg
	keyCode[INPUT_5]	  = ' ' ; // Aj}
	keyCode[INPUT_6]	  = 'a' ; // J
	keyCode[INPUT_START]  = 'p' ; // |[Y
	keyCode[INPUT_SELECT] = 's' ; // wv
	for( int i=0 ; i<2 ; i++ )
	{
		padCode[i][INPUT_1]		 = 0 ; // 
		padCode[i][INPUT_2]		 = 3 ; // 
		padCode[i][INPUT_3]		 = 2 ; // ~
		padCode[i][INPUT_4]		 = 1 ; // 
		padCode[i][INPUT_5]		 = 7 ; // R1
		padCode[i][INPUT_6]		 = 11 ; // EXeBbN
		padCode[i][INPUT_START]	 = 8 ; // START
		padCode[i][INPUT_SELECT] = 9 ; // SELECT
	}
}

/*
 R[hݒǂݍ
 */
void CInput::loadCode( const char* pass )
{
	std::ifstream txt( pass );
	if( txt.fail() )
	{
		fl_alert( "read error [%s]" , pass );
		return ;
	}
	// ǂݍ݊Jn
	for( int i=0 ; i<INPUT_MAX-4 ; i++ )
	{
		txt >> keyCode[i] ;
		// '!'' 'ɕϊ
		if( keyCode[i] == '!' )
		{
			keyCode[i] = ' ' ;
		}
		txt >> padCode[0][i] ;
		txt >> padCode[1][i] ;
	}
	txt.close();
}

/*
 R[hݒ菑
 */
void CInput::saveCode( const char* pass )
{
	std::ofstream txt( pass );
	if( txt.fail() )
	{
		fl_alert( "read error [%s]" , pass );
		return ;
	}
	// ݊Jn
	for( int i=0 ; i<INPUT_MAX-4 ; i++ )
	{
		// ' ''!'őp
		if( keyCode[i] == ' ' )
		{
			txt << '!' << " " ;
		}
		else
		{
			txt << keyCode[i] << " " ;
		}
		txt << padCode[0][i] << " " << padCode[1][i] << std::endl ;
	}
	txt.close();
}

/*
 R[h̐ݒiL[{[hj
 */
void CInput::setKeyCode( int key , char newCode )
{
	if( key >= 0 && key < INPUT_MAX-4 )
	{
		keyCode[key] = newCode ;
	}
}

/*
 R[h̐ݒipbhj
 */
void CInput::setPadCode( int pad , int button , int newCode )
{
	if( ( pad == 0 || pad == 1 ) || ( button >= 0 && button < INPUT_MAX-4 ) )
	{
		padCode[pad][button] = newCode ;
	}
}

/*
 ͎tƃf[^XV
 */
void CInput::update()
{
	// ݂̃f[^ߋ̃f[^ɓ]
	for( int i=0 ; i<INPUT_MAX ; i++ )
	{
		keyDataBefore[i] = keyDataNow[i] ;
		padDataBefore[0][i] = padDataNow[0][i] ;
		padDataBefore[1][i] = padDataNow[1][i] ;
	}

	// L[{[h̓͏XV
	for( int i=0 ; i<8 ; i++ )
	{
		keyDataNow[i] = window->getKeyStatus( keyCode[i] , false );
	}
	keyDataNow[INPUT_UP]  = window->getSpecialKeyStatus( FK_UP , false );
	keyDataNow[INPUT_RIGHT]  = window->getSpecialKeyStatus( FK_RIGHT , false );
	keyDataNow[INPUT_DOWN]  = window->getSpecialKeyStatus( FK_DOWN , false );
	keyDataNow[INPUT_LEFT] = window->getSpecialKeyStatus( FK_LEFT , false );

	// pbhXeBbN̓͏XV
	if( padNum != 0 )
	{
		fInput.update();
	}
	for( int i=0 ; i<2 ; i++ )
	{
		if( i < padNum )
		{
			padInputData[i] = fInput.getInputStatus( i );
			for( int j=0 ; j<8 ; j++ )
			{
				if( padCode[i][j] > -1 && padCode[i][j] < 32 )
				{
					padDataNow[i][j] = padInputData[i].button[padCode[i][j]] ;
				}
			}
			padDataNow[i][INPUT_UP]  = padInputData[i].up ;
			padDataNow[i][INPUT_RIGHT]  = padInputData[i].right ;
			padDataNow[i][INPUT_DOWN]  = padInputData[i].down ;
			padDataNow[i][INPUT_LEFT] = padInputData[i].left ;
			stick[i].leftX = padInputData[i].x[0] ;
			stick[i].leftY = padInputData[i].y[0] ;
			stick[i].rightX = padInputData[i].x[1] ;
			stick[i].rightY = padInputData[i].y[1] ;
		}
		else
		{
			for( int j=0 ; j<INPUT_MAX ; j++ )
			{
				padDataNow[i][j]	= false ;
			}
			stick[i].leftX = stick[i].leftY = stick[i].rightX = stick[i].rightY = 0 ;
		}
	}
	/*fk_Window::printf( "%d,%d,%d,%d,%d,%d,%d\n" ,
		padDataNow[0][0] ,
		padDataNow[0][1] ,
		padDataNow[0][2] ,
		padDataNow[0][3] ,
		padDataNow[0][4] ,
		padDataNow[0][5] ,
		padDataNow[0][6] );*/
}

/*
 ͔iꂽj
 */
bool CInput::checkDown( int key , int dev )
{
	if( dev%2 == 1 &&  padDataNow[0][key] && !padDataBefore[0][key] )
	{
		return true ;
	}
	if( dev%4 >= 2 &&  padDataNow[1][key] && !padDataBefore[1][key] )
	{
		return true ;
	}
	return ( dev%8 >= 4 &&  keyDataNow[key] && !keyDataBefore[key] ) ;
}

/*
 ͔iꂽj
 */
bool CInput::checkUp( int key , int dev )
{
	if( dev%2 == 1 && !padDataNow[0][key] &&  padDataBefore[0][key] )
	{
		return true ;
	}
	if( dev%4 >= 2 && !padDataNow[1][key] &&  padDataBefore[1][key] )
	{
		return true ;
	}
	return ( dev%8 >= 4 && !keyDataNow[key] &&  keyDataBefore[key] ) ;
}

/*
 ͔iĂŒj
 */
bool CInput::checkPress( int key , int dev )
{
	if( dev%2 == 1 &&  padDataNow[0][key] )
	{
		return true ;
	}
	if( dev%4 >= 2 &&  padDataNow[1][key] )
	{
		return true ;
	}
	return ( dev%8 >= 4 &&  keyDataNow[key] ) ;
}

/*
 XeBbNXiisPlayerOne=true1PAfalse2Pj
 */
inputStickType CInput::checkStick( bool isPlayerOne )
{
	return stick[( isPlayerOne ? 0 : 1 )] ;
}
