//---------------------------------------------------
// 
//---------------------------------------------------

#pragma once

#include "common.h"
#include "../FKUT/Input.h"
#include <Fl/x.h>

enum inputButtonType
{
	INPUT_1 ,
	INPUT_2 ,
	INPUT_3 ,
	INPUT_4 ,
	INPUT_5 ,
	INPUT_6 ,
	INPUT_START ,
	INPUT_SELECT ,
	INPUT_UP ,
	INPUT_RIGHT ,
	INPUT_DOWN ,
	INPUT_LEFT ,
	INPUT_MAX ,
};

struct inputStickType
{
	short	leftX , leftY , rightX , rightY ;
};

enum device
{
	PAD1 = 1 ,
	PAD2 = 2 ,
	KEY  = 4 ,
};

class CInput
{
private:
	fk_Window		*window ;
	fkut_Input		fInput ;
	fkut_InputInfo	padInputData[2] ;
	int				padNum ;

	char	keyCode[INPUT_MAX-4] ;
	bool	keyDataBefore[INPUT_MAX] ;
	bool	keyDataNow[INPUT_MAX] ;
	int		padCode[2][INPUT_MAX-4] ;
	bool	padDataBefore[2][INPUT_MAX] ;
	bool	padDataNow[2][INPUT_MAX] ;
	inputStickType	stick[2] ;

public:
	CInput();
	~CInput();

	void	init( Fl_Window *lw , fk_Window *kw );
	void	inputCodeInit();
	void	loadCode( const char* pass );
	void	saveCode( const char* pass );
	void	setKeyCode( int key , char newCode );
	void	setPadCode( int pad , int button , int newCode );
	void	update();

	bool	checkDown( int key , int dev = KEY | PAD1 );
	bool	checkUp( int key , int dev = KEY | PAD1 );
	bool	checkPress( int key , int dev = KEY | PAD1 );
	inputStickType	checkStick( bool isPlayerOne = true );

};
