//---------------------------------------------------
// GtFNg֌Wf[^x[X
//---------------------------------------------------

#include "effectDB.h"

CEffectDB::CEffectDB()
{
}

CEffectDB::~CEffectDB()
{
}

/*
 fk_ScenẽAhXZbg
 */
void CEffectDB::setAddress( fk_Scene *s )
{
	scene = s ;
}

/*
 GtFNg쐬
 */
void CEffectDB::createEffect( std::string name , std::string pass , int argXnum , int argYnum )
{
	if( findEffect( name ) )
	{
		return ;
	}
	effect.insert( std::make_pair( name , new effectBase ) );
	effectIte = effect.find( name );
	(*effectIte).second->model = new fk_Model ;
	(*effectIte).second->texture = new fk_RectTexture ;
	(*effectIte).second->material = new fk_Material ;
	if( !(*effectIte).second->texture->readPNG( pass ) )
	{
		deleteEffect( name );
		return ;
	}
	(*effectIte).second->model->setShape( (*effectIte).second->texture );
	(*effectIte).second->model->setMaterial( *((*effectIte).second->material) );
	(*effectIte).second->Xnum = argXnum ;
	(*effectIte).second->Ynum = argYnum ;
	setFrame( name , 0 );
}
void CEffectDB::createEffectBlack( std::string name , std::string pass , int argXnum , int argYnum )
{
	if( findEffect( name ) )
	{
		return ;
	}
	effect.insert( std::make_pair( name , new effectBase ) );
	effectIte = effect.find( name );
	(*effectIte).second->model = new CFkt ;
	(*effectIte).second->texture = new fk_RectTexture ;
	(*effectIte).second->material = new fk_Material ;
	if( !(*effectIte).second->texture->readPNG( pass ) )
	{
		deleteEffect( name );
		return ;
	}
	(*effectIte).second->model->setShape( (*effectIte).second->texture );
	(*effectIte).second->model->setMaterial( *((*effectIte).second->material) );
	(*effectIte).second->Xnum = argXnum ;
	(*effectIte).second->Ynum = argYnum ;
	setFrame( name , 0 );
}

/*
 GtFNg폜
 */
void CEffectDB::deleteEffect( std::string name )
{
	if( findEffect( name ) )
	{
		scene->removeModel( (*effectIte).second->model );
		delete (*effectIte).second->model ;
		delete (*effectIte).second->texture ;
		delete (*effectIte).second->material ;
		delete (*effectIte).second ;
		(*effectIte).second = NULL ;
		effect.erase( name );
	}
}

/*
 SGtFNg폜
 */
void CEffectDB::deleteEffectAll()
{
	for( effectIte = effect.begin() ; effectIte != effect.end() ; effectIte ++ )
	{
		scene->removeModel( (*effectIte).second->model );
		delete (*effectIte).second->model ;
		delete (*effectIte).second->texture ;
		delete (*effectIte).second ;
		(*effectIte).second = NULL ;
	}
	effect.clear();
}

/*
 w肳ꂽÕGtFNgtrue
 */
bool CEffectDB::findEffect( std::string name )
{
	effectIte = effect.find( name );
	return ( effectIte != effect.end() ) ;
}

/*
 GtFNgAj[V邽߂̃t[w肷
 */
void CEffectDB::setFrame( std::string name , int frame )
{
	if( findEffect( name ) )
	{
		int Xnum = (*effectIte).second->Xnum , Ynum = (*effectIte).second->Ynum ;
		if( frame >= 0 )
		{
			frame %= Xnum * Ynum ;
			(*effectIte).second->texture->setTextureCoord(
				(frame%Xnum)*(1.0/Xnum) , 1.0-(frame/Ynum)*(1.0/Ynum) ,
				((frame%Xnum)+1)*(1.0/Xnum) , 1.0-((frame/Ynum)+1)*(1.0/Ynum) );
		}
	}
}

/*
 GtFNg̃TCYݒ肷
 */
void CEffectDB::setSize( std::string name , double x , double y )
{
	if( findEffect( name ) )
	{
		(*effectIte).second->texture->setTextureSize( x , y );
	}
}

/*
 GtFNggEki0.0ȉ̒lw肷Ɗgk͖j
 */
void CEffectDB::setScale( std::string name , double x , double y )
{
	if( x <= 0.0 || y <= 0.0 )
	{
		return ;
	}
	if( findEffect( name ) )
	{
		double texX = (*effectIte).second->texture->getTextureSize().x ;
		double texY = (*effectIte).second->texture->getTextureSize().y ;
		(*effectIte).second->texture->setTextureSize( texX*x , texY*y );
	}
}

/*
 GtFNg̓xݒ肷i0.0`1.0AȊO̒l͖j
 */
void CEffectDB::setAlpha( std::string name , double a )
{
	if( a <= -0.1 || a >= 1.1 )
	{
		return ;
	}
	if( findEffect( name ) )
	{
		(*effectIte).second->material->setAlpha( a );
		(*effectIte).second->model->setMaterial( *((*effectIte).second->material) );
	}
}

/*
 w肵fƐeq֌W
 */
void CEffectDB::setParent( std::string name , fk_Model *model )
{
	if( findEffect( name ) )
	{
		(*effectIte).second->model->setParent( model );
	}
}

/*
 eq֌W
 */
void CEffectDB::deleteParent( std::string name )
{
	if( findEffect( name ) )
	{
		(*effectIte).second->model->deleteParent();
	}
}

/*
 J̕Ɍ
 */
void CEffectDB::focusCamera( std::string name , fk_Model *camera )
{
	if( findEffect( name ) )
	{
		(*effectIte).second->model->glFocus( camera->getInhPosition() );
		(*effectIte).second->model->loFocus( 0.0 , 0.0 , 0.1 );
	}
}

/*
 fk_Scene::entryModelƓAGtFNgo^
 */
void CEffectDB::entryEffect( std::string name )
{
	if( findEffect( name ) )
	{
		scene->entryModel( (*effectIte).second->model );
	}
}

/*
 fk_Scene::removeModelƓAGtFNg
 */
void CEffectDB::removeEffect( std::string name )
{
	if( findEffect( name ) )
	{
		scene->removeModel( (*effectIte).second->model );
	}
}

/*
 O[oWŎwn_ֈړ
 */
void CEffectDB::glMoveTo( std::string name , double x , double y , double z )
{
	if( findEffect( name ) )
	{
		(*effectIte).second->model->glMoveTo( x , y , z );
	}
}

void CEffectDB::glMoveTo( std::string name , fk_Vector v )
{
	glMoveTo( name , v.x , v.y , v.z );
}

/*
 O[oWŎwʈړ
 */
void CEffectDB::glTranslate( std::string name , double x , double y , double z )
{
	if( findEffect( name ) )
	{
		(*effectIte).second->model->glTranslate( x , y , z );
	}
}

void CEffectDB::glTranslate( std::string name , fk_Vector v )
{
	glTranslate( name , v.x , v.y , v.z );
}

/*
 [JWŎwʈړ
 */
void CEffectDB::loTranslate( std::string name , double x , double y , double z )
{
	if( findEffect( name ) )
	{
		(*effectIte).second->model->loTranslate( x , y , z );
	}
}

void CEffectDB::loTranslate( std::string name , fk_Vector v )
{
	loTranslate( name , v.x , v.y , v.z );
}

/*
 O[oWŏœ_w
 */
void CEffectDB::glFocus( std::string name , double x , double y , double z )
{
	if( findEffect( name ) )
	{
		(*effectIte).second->model->glFocus( x , y , z );
	}
}

void CEffectDB::glFocus( std::string name , fk_Vector v )
{
	glFocus( name , v.x , v.y , v.z );
}

/*
 [JWŏœ_w
 */
void CEffectDB::loFocus( std::string name , double x , double y , double z )
{
	if( findEffect( name ) )
	{
		(*effectIte).second->model->loFocus( x , y , z );
	}
}

void CEffectDB::loFocus( std::string name , fk_Vector v )
{
	loFocus( name , v.x , v.y , v.z );
}

void CEffectDB::setRendMode(std::string name)
{
	(*effectIte).second->texture->setTextureMode(FK_TEX_REPLACE);
	(*effectIte).second->texture->setTexRendMode(FK_TEX_REND_SMOOTH);
}
