//---------------------------------------------------
// tB[hubN
//---------------------------------------------------

#include "field.h"

CField::CField()
{
	base.loadObjectData( "dat/model/field/cube4_green.mqo" );
	base.loadJointData( "dat/model/field/floorcube.fkc" );
	for( int i=0 ; i<2 ; i++ )
	{
		stand[i].loadObjectData( "dat/model/field/floorcube_red.mqo" );
		stand[i].loadJointData( "dat/model/field/floorcube.fkc" );
		standID[i] = -1 ;
	}
	for( int i=0 ; i<12 ; i++ )
	{
		attack[i].loadObjectData( "dat/model/field/throwcube.mqo" );
		attack[i].loadJointData( "dat/model/field/floorcube.fkc" );
		attackID[i] = -1 ;
	}
	shadowMaterial.setDiffuse( 0.0 , 0.0 , 0.0 );
	shadowMaterial.setAmbient( 0.0 , 0.0 , 0.0 );
	shadowMaterial.setAlpha( 0.8 );
	for( int i=0 ; i<2 ; i++ )
	{
		shadow[i].makeCircle( 8 , 0.1 );
		shadowModel[i].setShape( &shadow[i] );
		shadowModel[i].setMaterial( shadowMaterial );
		shadowModel[i].glVec( 0.0 , -1.0 , 0.0 );
	}
}

CField::~CField()
{
}

/*
 fk_Scenẽ|C^Zbg
 */
void CField::setAddress( fk_Scene *s )
{
	scene = s ;
}

/*
 tB[h̏
 */
void CField::deleteField()
{
	unsigned int	size = field.size();
	
	for( unsigned int i=0 ; i<size ; i++ )
	{
		field[i]->mc->removeScene( scene );
		delete field[i]->obb ;
		delete field[i]->mc ;
		delete field[i] ;
	}
	field.clear();
	for( int i=0 ; i<2 ; i++ )
	{
		stand[i].removeScene( scene );
	}
	for( int i=0 ; i<12 ; i++ )
	{
		attack[i].removeScene( scene );
	}
	for( int i=0 ; i<2 ; i++ )
	{
		scene->removeModel( &shadowModel[i] );
	}
}

/*
 VO[hp̃tB[hf[^̓ǂݍ݁iplayerPosɎ̏WAenemyPosɓG̏Wj
 */
void CField::loadSingleFieldData( int num , fk_Vector *playerPos , fk_Vector *enemyPos )
{
	char	fileName[64] ;

	sprintf_s( fileName , 64 , "SingleModeField%d.dat" , num );
	loadFieldData( fileName , playerPos , enemyPos );
}

/*
 Xe[WGfB^[ōtB[hf[^̓ǂݍ݁ip1Pos1P̏WAp2Pos2P̏Wj
 */
void CField::loadEditFieldData( int num , fk_Vector *p1Pos , fk_Vector *p2Pos )
{
	char	fileName[64] ;

	sprintf_s( fileName , 64 , "StageEditField%d.dat" , num );
	loadFieldData( fileName , p1Pos , p2Pos );
}

/*
 tB[hf[^̓ǂݍ
 */
void CField::loadFieldData( std::string pass , fk_Vector *pos1 , fk_Vector *pos2 )
{
	int		txtX , txtY , txtZ ;

	std::ifstream txt( pass.c_str() );
	if( txt.fail() )
	{
		return ;
	}
	txt >> txtX ;
	txt >> txtY ;
	txt >> txtZ ;
	pos1->set( (txtX-FIELD_X_MAX/2)*FIELD_BLOCKSIZE_X ,
		(txtY-FIELD_Y_MAX/2)*FIELD_BLOCKSIZE_Y + 10.0 ,
		(txtZ-FIELD_Z_MAX/2)*FIELD_BLOCKSIZE_Z );
	txt >> txtX ;
	txt >> txtY ;
	txt >> txtZ ;
	pos2->set( (txtX-FIELD_X_MAX/2)*FIELD_BLOCKSIZE_X ,
		(txtY-FIELD_Y_MAX/2)*FIELD_BLOCKSIZE_Y + 10.0 ,
		(txtZ-FIELD_Z_MAX/2)*FIELD_BLOCKSIZE_Z );
	while( !txt.eof() && (signed int)field.size() < FIELD_BLOCK_MAX )
	{
		txt >> txtX ;
		txt >> txtY ;
		txt >> txtZ ;
		field.push_back( new blockBase );
		field.back()->obb = new fkut_OBB ;
		field.back()->mc = new CMotionCharactor ;
		field.back()->posNTR.set( (txtX-FIELD_X_MAX/2)*FIELD_BLOCKSIZE_X ,
			(txtY-FIELD_Y_MAX/2)*FIELD_BLOCKSIZE_Y ,
			(txtZ-FIELD_Z_MAX/2)*FIELD_BLOCKSIZE_Z );
		field.back()->pos = field.back()->posNTR ;
		field.back()->spd.set( 0.0 , 0.0 , 0.0 );
		field.back()->state = 1 ;
		field.back()->obb->setBlockSize( FIELD_BLOCKSIZE_X , FIELD_BLOCKSIZE_Y , FIELD_BLOCKSIZE_Z );
		field.back()->obb->setModel( field.back()->mc->getBaseModel() );
		field.back()->mc->cloneCharactor( &base );
		//field.back()->mc->loadObjectData( "dat/model/field/cube4_green.mqo" );
		//field.back()->mc->loadJointData( "dat/model/field/floorcube.fkc" );
		field.back()->mc->getBaseModel()->glMoveTo( field.back()->pos );
		field.back()->mc->entryScene( scene );
	}
	txt.close();
}

/*
 ԂubN̔zu
 */
void CField::setStandBlock( unsigned int blockID , int charaID )
{
	if( blockID < field.size() && charaID >= 0 && charaID <= 1 )
	{
		if( standID[charaID] != -1 )
		{
			field[standID[charaID]]->mc->entryScene( scene );
		}
		field[blockID]->mc->removeScene( scene );
		stand[charaID].getBaseModel()->glMoveTo( field[blockID]->posNTR + fk_Vector( 0.0 , FIELD_BLOCKSIZE_Y/2.0+2.0 , 0.0 ) );
		stand[charaID].entryScene( scene );
		standID[charaID] = blockID ;
	}
}

/*
 ԂubN̍폜
 */
void CField::removeStandBlock( int charaID )
{
	if( standID[charaID] != -1 && charaID >= 0 && charaID <= 1 )
	{
		field[standID[charaID]]->mc->entryScene( scene );
		stand[charaID].removeScene( scene );
		standID[charaID] = -1 ;
	}
}

/*
 FubN̔zu
 */
void CField::setAttackBlock( unsigned int blockID )
{
	if( blockID < field.size() )
	{
		for( int i=0 ; i<12 ; i++ )
		{
			if( attackID[i] == -1 )
			{
				attack[i].getBaseModel()->glMoveTo( field[blockID]->pos + fk_Vector( 0.0 , FIELD_BLOCKSIZE_Y/2.0+2.0 , 0.0 ) );
				attack[i].entryScene( scene );
				attackID[i] = blockID ;
				return ;
			}
		}
	}
}

/*
 FubN̍폜
 */
void CField::removeAttackBlock( unsigned int blockID )
{
	for( int i=0 ; i<12 ; i++ )
	{
		if( attackID[i] == blockID )
		{
			attack[i].removeScene( scene );
			attackID[i] = -1 ;
			return ;
		}
	}
}

/*
 tB[hubN̍XV
 */
void CField::update()
{
	unsigned int	size = field.size();

	for( unsigned int i=0 ; i<size ; i++ )
	{
		switch( field[i]->state )
		{
		case 0: // IďĂ
			//field[i]->mc->removeScene( scene );
			break ;
		case 1: // tB[hɕʂɂ
/*			if( i != standID )
			{
				field[i]->mc->entryScene( scene );
			}
			else
			{
				field[i]->mc->removeScene( scene );
			}
*/			break ;
		case 2: // NɎグĂ
			field[i]->mc->removeScene( scene );
			break ;
		case 3: // Nɓꂽ
			field[i]->pos += field[i]->spd ;
			field[i]->mc->getBaseModel()->glMoveTo( field[i]->pos );
			field[i]->mc->getBaseModel()->loFocus( 0.8 , 0.0 , -1.0 );
//			field[i]->mc->removeScene( scene );
			for( int j=0 ; j<12 ; j++ )
			{
				if( i == attackID[j] )
				{
					attack[j].getBaseModel()->glMoveTo( field[i]->pos + fk_Vector( 0.0 , FIELD_BLOCKSIZE_Y/2.0+2.0 , 0.0 ) );
					attack[j].getBaseModel()->glVec( field[i]->mc->getBaseModel()->getInhVec() );
				}
			}
			break ;
		default:
			field[i]->state = 0 ;
			break ;
		}
	}
}

/*
 ubNグ
 */
void CField::blockLift( unsigned int blockID )
{
	if( blockID < field.size() )
	{
		field[blockID]->state = 2 ;
		field[blockID]->mc->removeScene( scene );
	}
}

/*
 ubN𓊂
 */
void CField::blockThrow( unsigned int blockID , fk_Vector pos , fk_Vector spd )
{
	if( blockID < field.size() )
	{
		field[blockID]->state = 3 ;
		field[blockID]->pos = pos ;
		field[blockID]->spd = spd ;
		field[blockID]->mc->removeScene( scene );
		setAttackBlock( blockID );
	}
}

void CField::blockThrow( unsigned int blockID , fk_Vector pos , double spdX , double spdY , double spdZ )
{
	blockThrow( blockID , pos , fk_Vector( spdX , spdY , spdZ ) );
}

void CField::blockThrow( unsigned int blockID , double posX , double posY , double posZ , fk_Vector spd )
{
	blockThrow( blockID , fk_Vector( posX , posY , posZ ) , spd );
}

void CField::blockThrow( unsigned int blockID , double posX , double posY , double posZ , double spdX , double spdY , double spdZ )
{
	blockThrow( blockID , fk_Vector( posX , posY , posZ ) , fk_Vector( spdX , spdY , spdZ ) );
}

/*
 ubNł
 */
void CField::blockLost( unsigned int blockID , int liftID )
{
	liftCacheBase	l ;

	if( blockID < field.size() )
	{
		field[blockID]->state = 0 ;
		removeAttackBlock( blockID );
		l.liftID = liftID ;
		l.blockID = blockID ;
		liftCache.push_back( l );
	}
}

/*
 ubN𕜊
 */
void CField::blockRevival( int liftID , int* revivalBlockIDArray )
{
	unsigned int	size = liftCache.size() , rest = 10 ;

	for( unsigned int i=0 ; i<size ; i++ )
	{
		if( liftCache[i].liftID == liftID )
		{
			field[liftCache[i].blockID]->pos = field[liftCache[i].blockID]->posNTR ;
			field[liftCache[i].blockID]->spd.set( 0.0 , 0.0 , 0.0 );
			field[liftCache[i].blockID]->mc->getBaseModel()->glMoveTo( field[liftCache[i].blockID]->pos );
			field[liftCache[i].blockID]->mc->getBaseModel()->glVec( 1.0 , 0.0 , 0.0 );
			field[liftCache[i].blockID]->mc->getBaseModel()->glUpvec( 0.0 , 1.0 , 0.0 );
			field[liftCache[i].blockID]->mc->entryScene( scene );
			field[liftCache[i].blockID]->state = 1 ;
			revivalBlockIDArray[(10-rest)] = liftCache[i].blockID ;
			liftCache.erase( liftCache.begin()+i );
			i -- ;
			size -- ;
			rest -- ;
			if( rest <= 0 )
			{
				break ;
			}
		}
	}
}

/*
 ubNƂ̓蔻iԂl̓ubNIDAnĂ+1000AĂȂ9999j
 */
unsigned int CField::checkCollision( fkut_OBB *obb , fk_Vector *spd , int blockState )
{
	fk_Vector		spdXZ , spdY , back , refV ;
	unsigned int	size = field.size() , hitID = 9999 ;
	bool			standFlag = false ;

	spdXZ.set( spd->x , 0.0 , spd->z );
	spdY.set( 0.0 , spd->y , 0.0 );
	// XZ
	for( int i=0 ; i<5 ; i++ )
	{
		back.init();
		for( unsigned int i=0 ; i<size ; i++ )
		{
			if( field[i]->state == blockState )
			{
				if( field[i]->obb->checkVSMovingOBB( *obb , spdXZ+back , refV ) )
				{
					back += -refV ;
					if( hitID == 9999 )
					{
						hitID = i ;
					}
				}
			}
		}
		if( abs( back.y ) > 0.0 )
		{
			standFlag = true ;
		}
		spdXZ += back ;
		if( back.isZero() )
		{
			break ;
		}
	}
	// Y
	for( int i=0 ; i<5 ; i++ )
	{
		back.init();
		for( unsigned int i=0 ; i<size ; i++ )
		{
			if( field[i]->state == blockState )
			{
				if( field[i]->obb->checkVSMovingOBB( *obb , spdY+back , refV ) )
				{
					back += -refV ;
					if( hitID == 9999 )
					{
						hitID = i ;
					}
				}
			}
		}
		if( abs( back.y ) > 0.0 )
		{
			standFlag = true ;
		}
		spdY += back ;
		if( back.isZero() )
		{
			break ;
		}
	}

	// x
	*spd = spdXZ + spdY ;

	return hitID + (int)standFlag*1000 ;
}

/*
 ëʒuݒ
 */
void CField::setShadow( bool is1P , fk_Vector modelPos , double radius )
{
	int				num = !(is1P) ;
	unsigned int	size = field.size();
	fk_Vector		shadowPos , blockPos ;

	shadowPos.set( 0.0 , -1000.0 , 0.0 );
	if( radius != -0.1 )
	{
		shadow[num].setRadius( radius );
	}
	for( unsigned int i=0 ; i<size ; i++ )
	{
		if( field[i]->state == 1 )
		{
			blockPos = field[i]->pos ;
			if( fabs( blockPos.x-modelPos.x ) <= FIELD_BLOCKSIZE_X/2.0
				&& fabs( blockPos.z-modelPos.z ) <= FIELD_BLOCKSIZE_Z/2.0
				&& blockPos.y > shadowPos.y && blockPos.y < modelPos.y )
			{
				shadowPos = blockPos ;
			}
		}
	}
	shadowPos.x = modelPos.x ;
	shadowPos.y += FIELD_BLOCKSIZE_Y+2.0 ;
	shadowPos.z = modelPos.z ;
	shadowModel[num].glMoveTo( shadowPos );
	scene->entryModel( &shadowModel[num] );
}

/*
 ubN̏Ԃ擾
 */
int CField::getState( unsigned int blockID )
{
	if( blockID < field.size() )
	{
		return field[blockID]->state ;
	}
	return -1 ;
}

/*
 ubN̈ʒu擾
 */
fk_Vector CField::getPos( unsigned int blockID )
{
	if( blockID < field.size() )
	{
		return field[blockID]->pos ;
	}
	return fk_Vector( 0.0 , 0.0 , 0.0 );
}

/*
 ubN̓蔻擾
 */
fkut_OBB* CField::getOBB( unsigned int blockID )
{
	if( blockID < field.size() )
	{
		return field[blockID]->obb ;
	}
	return NULL ;
}

/*
 ubÑf擾
 */
fk_Model* CField::getModel( unsigned int blockID )
{
	if( blockID < field.size() )
	{
		return field[blockID]->mc->getBaseModel();
	}
	return NULL ;
}

/*
 ԂubNubNID擾
 */
int CField::getStandBlockID( int charaID )
{
	if( charaID >= 0 && charaID <= 1 )
	{
		return standID[charaID] ;
	}
	return -1 ;
}
