//---------------------------------------------------
// tB[hubN
//---------------------------------------------------

#pragma once

#include "common.h"

class CField
{
private:
	fk_Scene			*scene ;
	CMotionCharactor	base , stand[2] , attack[12] ;
	int					standID[2] , attackID[12] ;
	struct blockBase
	{
		int					state ;
		fk_Vector			pos , posNTR , spd ;
		fkut_OBB			*obb ;
		CMotionCharactor	*mc ;
	};
	std::vector<blockBase*>		field ;
	struct liftCacheBase
	{
		int		liftID , blockID ;
	};
	std::vector<liftCacheBase>	liftCache ;
	fk_Circle	shadow[2] ;
	fk_Model	shadowModel[2] ;
	fk_Material	shadowMaterial ;

public:
	CField();
	~CField();

	void	setAddress( fk_Scene *s );
	void	deleteField();
	void	loadSingleFieldData( int num , fk_Vector *playerPos , fk_Vector *enemyPos );
	void	loadEditFieldData( int num , fk_Vector *p1Pos , fk_Vector *p2Pos );
	void	loadFieldData( std::string pass , fk_Vector *pos1 , fk_Vector *pos2 );
	void	setStandBlock( unsigned int blockID , int charaID );
	void	removeStandBlock( int charaID );
	void	setAttackBlock( unsigned int blockID );
	void	removeAttackBlock( unsigned int blockID );
	void	update();
	void	blockLift( unsigned int blockID );
	void	blockThrow( unsigned int blockID , fk_Vector pos , fk_Vector spd );
	void	blockThrow( unsigned int blockID , fk_Vector pos ,  double spdX , double spdY , double spdZ );
	void	blockThrow( unsigned int blockID , double posX , double posY , double posZ , fk_Vector spd );
	void	blockThrow( unsigned int blockID , double posX , double posY , double posZ , double spdX , double spdY , double spdZ );
	void	blockLost( unsigned int blockID , int liftID );
	void	blockRevival( int liftID , int* revivalBlockIDArray );
	unsigned int	checkCollision( fkut_OBB *obb , fk_Vector *spd , int blockState );
	void		setShadow( bool is1P , fk_Vector modelPos , double radius = -0.1 );
	int			getState( unsigned int blockID );
	fk_Vector	getPos( unsigned int blockID );
	fkut_OBB*	getOBB( unsigned int blockID );
	fk_Model*	getModel( unsigned int blockID );
	int			getStandBlockID( int charaID);

};
