//---------------------------------------------------
// C^[tFCX
//---------------------------------------------------

#include "interFace.h"

CInterFace::CInterFace()
{
	drawHelp = true;

	p1_status.anima = 0.0;
	p1_status.combo = 0;
	p1_status.lifeRate = 1.0;
	p1_status.lifeRate_prev = 1.0;
	p1_status.stock = 0;
	p1_status.prevCombo = false;
	p1_status.moveCombo = 0;
	p1_status.posXCombo = 0;

	p2_status.anima = 0.0;
	p2_status.combo = 0;
	p2_status.lifeRate = 1.0;
	p2_status.lifeRate_prev = 1.0;
	p2_status.stock = 0;
	p2_status.prevCombo = false;
	p2_status.moveCombo = 0;
	p2_status.posXCombo = 0;
}

CInterFace::~CInterFace()
{
}

void CInterFace::setGraph(CDatabase *DB)
{
	DB->graphDB.setImage( "p1_icon_bg", "dat/graph/maingame/p_icon_bg.png" );
	DB->graphDB.setImage( "p2_icon_bg", "dat/graph/maingame/e_icon_bg.png" );

	DB->graphDB.setImage( "help_act", "dat/graph/maingame/help_act.png" );
	DB->graphDB.setImage( "help_anima2", "dat/graph/maingame/help_anima2.png" );
	DB->graphDB.setImage( "help_anima3", "dat/graph/maingame/help_anima3.png" );

	//DB->graphDB.setImage( "nageru_icon", "dat/graph/maingame/nageru_icon.png" );
	DB->graphDB.setImage( "nageru_icon", "dat/graph/maingame/nageru_icon_p1_0.8.png" );
	//DB->graphDB.setImage( "rockking_icon", "dat/graph/maingame/rocking_icon.png" );
	DB->graphDB.setImage( "rocking_icon", "dat/graph/maingame/rocking_icon_p2_0.8.png" );
	DB->graphDB.setImage( "nageru_p2_icon", "dat/graph/maingame/nageru_icon_p2_0.8.png" );

	DB->graphDB.setImage( "p1_glayflame", "dat/graph/maingame/glayflame.png" );
	DB->graphDB.setImage( "p2_glayflame", "dat/graph/maingame/glayflame.png" );

	DB->graphDB.setImage( "p1_number_combo1", "dat/graph/maingame/number_combo.png" );
	DB->graphDB.setImage( "p1_number_combo2", "dat/graph/maingame/number_combo.png" );
	DB->graphDB.setImage( "p2_number_combo1", "dat/graph/maingame/number_combo.png" );
	DB->graphDB.setImage( "p2_number_combo2", "dat/graph/maingame/number_combo.png" );
	DB->graphDB.setImage( "p1_graph_combo", "dat/graph/maingame/combo.png" );
	DB->graphDB.setImage( "p2_graph_combo", "dat/graph/maingame/combo.png" );

	DB->graphDB.setImage( "number_time1", "dat/graph/maingame/number_time.png" );
	DB->graphDB.setImage( "number_time2", "dat/graph/maingame/number_time.png" );
	DB->graphDB.setImage( "number_time3", "dat/graph/maingame/number_time.png" );
	DB->graphDB.setImage( "number_time4", "dat/graph/maingame/number_time.png" );
	DB->graphDB.setImage( "number_time5", "dat/graph/maingame/number_time.png" );
	DB->graphDB.setImage( "coron1", "dat/graph/maingame/coron.png" );
	DB->graphDB.setImage( "coron2", "dat/graph/maingame/coron.png" );

	DB->graphDB.setImage( "p1_HPgauge_flame", "dat/graph/maingame/HPgauge_flame.png" );
	DB->graphDB.setImage( "p2_HPgauge_flame", "dat/graph/maingame/HPgauge_flame.png" );
	DB->graphDB.setImage( "p1_HPgauge", "dat/graph/maingame/HPgauge.png" );
	DB->graphDB.setImage( "p2_HPgauge", "dat/graph/maingame/HPgauge.png" );

	DB->graphDB.setImage( "p1_stockgauge_flame", "dat/graph/maingame/stockgauge_flame.png" );
	DB->graphDB.setImage( "p2_stockgauge_flame", "dat/graph/maingame/stockgauge_flame.png" );
	DB->graphDB.setImage( "p1_stockgauge", "dat/graph/maingame/stockgauge.png" );
	DB->graphDB.setImage( "p2_stockgauge", "dat/graph/maingame/stockgauge.png" );

	DB->graphDB.setImage( "p1_animagauge_flame", "dat/graph/maingame/animagauge_flame.png" );
	DB->graphDB.setImage( "p2_animagauge_flame", "dat/graph/maingame/animagauge_flame.png" );
	DB->graphDB.setImage( "p1_animagauge", "dat/graph/maingame/animagauge.png" );
	DB->graphDB.setImage( "p2_animagauge", "dat/graph/maingame/animagauge.png" );
	//DB->graphDB.setImage( "p1_animagauge_full", "dat/graph/maingame/fire.png" );
	//DB->graphDB.setImage( "p2_animagauge_full", "dat/graph/maingame/fire.png" );
}

void CInterFace::updateGraph(CDatabase *DB)
{
	DB->graphDB.setPositionLT( "p1_icon_bg", -400, -25 );
	DB->graphDB.setPositionLT( "p2_icon_bg", (400-350) , -25 );

	if(drawHelp == true )
	{
	DB->graphDB.setPositionLT( "help_act", -WINDOW_WIDTH/2.0, WINDOW_HEIGHT/2.0);
	DB->graphDB.setPositionLT( "help_anima2", WINDOW_WIDTH/2.0-200, WINDOW_HEIGHT/2.0);
	DB->graphDB.setPositionLT( "help_anima3", WINDOW_WIDTH/2.0-200, WINDOW_HEIGHT/2.0);
	}


	/*
	//LACR@DFt[
	*/
	DB->graphDB.setPositionLT( "nageru_icon", -400 , -65 );
	DB->graphDB.setPositionLT( "rocking_icon", (400-(350*0.8) ), -65 );
	DB->graphDB.setPositionLT( "nageru_p2_icon", (400-(350*0.8) ), -65 );

	DB->graphDB.setPositionLT( "p1_glayflame", (-400+85 ), (-225+95) );
	DB->graphDB.setPositionLT( "p2_glayflame", (400-85-15) , (-225+95) );


	/*
	//CtQ[W
	*/
	p1_status.lifeRate;
	p2_status.lifeRate;
	int calcP1HP;
	int calcP2HP;

	if(p1_status.lifeRate_prev - p1_status.lifeRate >= 0)calcP1HP = 1;
	else calcP1HP = -1;

	if(p2_status.lifeRate_prev - p2_status.lifeRate >= 0)calcP2HP = 1;
	else calcP2HP = -1;

	if(p1_status.lifeRate_prev != p1_status.lifeRate)
	{
		p1_status.lifeRate_prev -= 0.01*calcP1HP;
		if(p1_status.lifeRate_prev - p1_status.lifeRate < 0.01 && p1_status.lifeRate_prev - p1_status.lifeRate > -0.01 )
		{
			p1_status.lifeRate_prev = p1_status.lifeRate;
		}
		if(p1_status.lifeRate_prev < 0 )
		{
			p1_status.lifeRate_prev = 0;
		}
	}
	if(p2_status.lifeRate_prev != p2_status.lifeRate)
	{
		p2_status.lifeRate_prev -= 0.01*calcP2HP;
		if(p2_status.lifeRate_prev - p2_status.lifeRate < 0.01 && p2_status.lifeRate_prev - p2_status.lifeRate > -0.01 )
		{
			p2_status.lifeRate_prev = p2_status.lifeRate;
		}
		if(p2_status.lifeRate_prev < 0 )
		{
			p2_status.lifeRate_prev = 0;
		}
	}

	DB->graphDB.setPositionLT( "p1_HPgauge_flame", (-400+100) , (-225+80) );
	DB->graphDB.setPositionLT( "p2_HPgauge_flame", (400-100-168) , (-225+80) );

	DB->graphDB.setSpriteArea( "p1_HPgauge", 0, 0, (168*p1_status.lifeRate_prev+(p1_status.lifeRate_prev==0 ? 8.1 : 0.0)) , 20 );
	DB->graphDB.setSpriteArea( "p2_HPgauge", (168-(168*p2_status.lifeRate_prev)) , 0, (168*p2_status.lifeRate_prev+(p2_status.lifeRate_prev==0 ? 8.1 : 0.0)) , 20 );

	DB->graphDB.setPositionLT( "p1_HPgauge", (-400+100) , (-225+80) );
	DB->graphDB.setPositionLT( "p2_HPgauge", (400-100-(168.0*p2_status.lifeRate_prev)+(p2_status.lifeRate_prev==0 ? 200.0 : 0.0)) , (-225+80) );

	/*
	//XgbNQ[W
	*/
	DB->graphDB.setPositionLT( "p1_stockgauge_flame", (-400+100) , (-225+55) );
	DB->graphDB.setPositionLT( "p2_stockgauge_flame", (400-100-165) , (-225+55) );

	DB->graphDB.setSpriteArea("p1_stockgauge", 0, 0, (p1_status.stock*(165.0/6)+(p1_status.stock==0 ? 8.1 : 0.0)) , 20);
	DB->graphDB.setSpriteArea("p2_stockgauge", 0, 0, (p2_status.stock*(165.0/6)+(p2_status.stock==0 ? 8.1 : 0.0)) , 20);

	DB->graphDB.setPositionLT( "p1_stockgauge", (-400+100) , (-225+55) );
	DB->graphDB.setPositionLT( "p2_stockgauge", (400-100-165+(165-p2_status.stock*(165.0/6))) , (-225+55) );


	/*
	//Aj}Q[W
	*/
	DB->graphDB.setPositionLT("p1_animagauge_flame", (-400+100) , (-225+20) );
	DB->graphDB.setPositionLT("p2_animagauge_flame", (400-100-168) , (-225+20) );

	DB->graphDB.setSpriteArea("p1_animagauge", 0, 0, (168*p1_status.anima+(p1_status.anima==0 ? 8.1 : 0.0)) , 20);
	DB->graphDB.setSpriteArea("p2_animagauge", (168-(168*p2_status.anima)) , 0, (168*p2_status.anima+(p2_status.anima<=0.05 ? 8.1 : 0.0)) , 20);

	DB->graphDB.setPositionLT( "p1_animagauge",(-400+100) , (-225+20) );
	DB->graphDB.setPositionLT( "p2_animagauge",(400-100-(168.0*p2_status.anima))-(p2_status.anima<=0.05 ? 8.1 : 0.0) , (-225+20) );

	/*
	if(p1_status.anima >= 1.0 )
	{
	DB->graphDB.setSpriteArea( "p1_animagauge_full", 0.0, 0.0, 584/3, 331/6 );
	DB->graphDB.setSpriteArea( "p2_animagauge_full", 0.0, 0.0, 584/3, 331/6 );
	}
	if(p2_status.anima >= 1.0 )
	{
	DB->graphDB.setPositionLT( "p1_animagauge_full", (-400+100) , (-225+20) );
	DB->graphDB.setPositionLT( "p2_animagauge_full", (400-100-180) , (-225+20) );
	}
	*/

	/*
	//R{
	*/
	if( p1_status.combo > 1)//R{QȏɂȂ
	{
		if(p1_status.prevCombo == false)
		{
			if(p1_status.moveCombo < 20)
			{
				p1_status.posXCombo = p1_status.moveCombo;
			}
			else
			{
				p1_status.prevCombo = true;
				p1_status.moveCombo = 0;
			}
			p1_status.moveCombo += 4;
		}
		else
		{
			p1_status.posXCombo = 20;
		}
		DB->graphDB.setPositionLT("p1_graph_combo", (-258-p1_status.posXCombo), -65.0);
		DB->graphDB.entryImage( "p1_graph_combo" );
		if( p1_status.combo > 9)
		{
			DB->graphDB.setSpriteArea( "p1_number_combo1", 0+((p1_status.combo%10)*20), 0, 20, 30);
			DB->graphDB.setPositionLT( "p1_number_combo1", (-278.0-p1_status.posXCombo) , -60.0 );
			DB->graphDB.entryImage("p1_number_combo1");
			p1_status.combo /= 10;

			DB->graphDB.setSpriteArea( "p1_number_combo2",0+(p1_status.combo*20), 0, 20, 30);
			DB->graphDB.setPositionLT( "p1_number_combo2", (-298.0-p1_status.posXCombo) , -60.0 );
			DB->graphDB.entryImage("p1_number_combo2");
		}
		else
		{
			DB->graphDB.setSpriteArea( "p1_number_combo1", 0+((p1_status.combo%10)*20), 0, 20, 30);
			DB->graphDB.setPositionLT( "p1_number_combo1", (-278.0-p1_status.posXCombo) , -60.0 );
			DB->graphDB.entryImage("p1_number_combo1");
		}

	}
	else
	{
		p1_status.prevCombo = false;
		DB->graphDB.removeImage("p1_number_combo1");
		DB->graphDB.removeImage("p1_number_combo2");
		DB->graphDB.removeImage("p1_graph_combo");
	}

	if( p2_status.combo > 1)//R{QȏɂȂ
	{
		if(p2_status.prevCombo == false)
		{
			if(p2_status.moveCombo < 20)
			{
				p2_status.posXCombo = p1_status.moveCombo;
			}
			else
			{
				p2_status.prevCombo = true;
				p2_status.moveCombo = 0;
			}
			p2_status.moveCombo += 4;
		}
		else
		{
			p2_status.posXCombo = 20;
		}
		DB->graphDB.setPositionLT("p2_graph_combo", (318-p2_status.posXCombo), -65.0);
		DB->graphDB.entryImage( "p2_graph_combo" );
		if( p2_status.combo > 9)
		{
			DB->graphDB.setSpriteArea( "p2_number_combo1", 0+((p2_status.combo%10)*20), 0, 20, 30);
			DB->graphDB.setPositionLT( "p2_number_combo1", (298.0-p2_status.posXCombo) , -60.0 );
			DB->graphDB.entryImage("p2_number_combo1");
			p2_status.combo /= 10;

			DB->graphDB.setSpriteArea( "p2_number_combo2",0+(p2_status.combo*20), 0, 20, 30);
			DB->graphDB.setPositionLT( "p2_number_combo2", (278.0-p2_status.posXCombo) , -60.0 );
			DB->graphDB.entryImage("p2_number_combo2");
		}
		else
		{
			DB->graphDB.setSpriteArea( "p2_number_combo1", 0+((p2_status.combo%10)*20), 0, 20, 30);
			DB->graphDB.setPositionLT( "p2_number_combo1", (298.0-p2_status.posXCombo) , -60.0 );
			DB->graphDB.entryImage("p2_number_combo1");
		}

	}
	else
	{
		p2_status.prevCombo = false;
		DB->graphDB.removeImage("p2_number_combo1");
		DB->graphDB.removeImage("p2_number_combo2");
		DB->graphDB.removeImage("p2_graph_combo");
	}

	/*
	//
	*/
	int minute = 0 ;
	while( time >= 6000 && minute < 9 )
	{
		time -= 6000 ;
		minute ++ ;
	}
	if( time >= 6000 )
	{
		time = 5999 ;
	}

	DB->graphDB.setSpriteArea("number_time1", 0+((minute)*20), 0, 20, 30 );
	DB->graphDB.setSpriteArea("number_time2", 0+(int(time)%10)*20, 0, 20, 30 );
	time /= 10;
	DB->graphDB.setSpriteArea("number_time3", 0+(int(time)%10)*20, 0, 20, 30 );
	time /= 10;
	DB->graphDB.setSpriteArea("number_time4", 0+(int(time)%10)*20, 0, 20, 30 );
	time /= 10;
	DB->graphDB.setSpriteArea("number_time5", 0+(int(time)%10)*20, 0, 20, 30 );
	DB->graphDB.setPositionLT( "number_time1", -220 +155, -180.0);
	DB->graphDB.setPositionLT( "number_time2", -100 +155, -180.0);
	DB->graphDB.setPositionLT( "number_time3", -120 +155, -180.0);
	DB->graphDB.setPositionLT( "number_time4", -160 +155, -180.0);
	DB->graphDB.setPositionLT( "number_time5", -180 +155, -180.0);

	DB->graphDB.setPositionLT( "coron1", -15.0-20.0 , -180.0);
	DB->graphDB.setPositionLT( "coron2", 5.0+20.0 , -180.0);
}

bool CInterFace::getHelp()
{
	return drawHelp;
}

void CInterFace::setHelp(CDatabase *DB, bool flag)
{
	drawHelp = flag;
	if(drawHelp == true )
	{
		DB->graphDB.entryImage( "help_act");
		DB->graphDB.entryImage( "help_anima2");
		DB->graphDB.entryImage( "help_aniam3");
	}
	else
	{
		DB->graphDB.removeImage( "help_act");
		DB->graphDB.removeImage( "help_anima2");
		DB->graphDB.removeImage( "help_anima3");
	}

}

void CInterFace::setTime(double argTime)
{
	time = argTime;
}

void CInterFace::setP1_LifeRate(int p1_life , int  p1_lifeMax)
{
	p1_status.lifeRate = (double)p1_life / (double)p1_lifeMax;
}

void CInterFace::setP2_LifeRate(int p2_life , int  p2_lifeMax)
{
	p2_status.lifeRate = (double)p2_life / (double)p2_lifeMax;
} 

void CInterFace::setP1_Stock(int argP1_stock)
{
	p1_status.stock = argP1_stock;
}

void CInterFace::setP2_Stock(int argP2_stock)
{
	p2_status.stock = argP2_stock;
}

void CInterFace::setP1_Anima(double argP1_anima)
{
	p1_status.anima = argP1_anima;
}

void CInterFace::setP2_Anima(double argP2_anima)
{
	p2_status.anima = argP2_anima;
}

void CInterFace::setP1_Combo(int argP1_combo)
{
	p1_status.combo = argP1_combo;
}

void CInterFace::setP2_Combo(int argP2_combo)
{
	p2_status.combo = argP2_combo;
}

void CInterFace::removeNageru_P2_Icon(CDatabase *DB)
{
	DB->graphDB.removeImage("nageru_p2_icon");
}

void CInterFace::removeRocking_P2_Icon(CDatabase *DB)
{
	DB->graphDB.removeImage("rocking_icon");
}

void CInterFace::deleteImage(CDatabase *DB)
{
	DB->graphDB.deleteImage( "p1_animagauge" );
	DB->graphDB.deleteImage( "p2_animagauge" );
	DB->graphDB.deleteImage( "p1_animagauge_flame" );
	DB->graphDB.deleteImage( "p2_animagauge_flame" );

	DB->graphDB.deleteImage( "p1_icon_bg");
	DB->graphDB.deleteImage( "p2_icon_bg" );

	DB->graphDB.deleteImage( "p1_glayflame");
	DB->graphDB.deleteImage( "p2_glayflame");
	DB->graphDB.deleteImage( "help_act");
	DB->graphDB.deleteImage( "help_anima1" );
	DB->graphDB.deleteImage( "help_anima2" );
	DB->graphDB.deleteImage( "help_anima3" );
	DB->graphDB.deleteImage( "p1_HPgauge" );
	DB->graphDB.deleteImage( "p2_HPgauge" );
	DB->graphDB.deleteImage( "p1_HPgauge_flame" );
	DB->graphDB.deleteImage( "p2_HPgauge_flame" );

	DB->graphDB.deleteImage( "nageru_icon" );
	DB->graphDB.deleteImage( "rocking_icon" );

	DB->graphDB.deleteImage( "p1_number_combo1" );
	DB->graphDB.deleteImage( "p1_number_combo2" );
	DB->graphDB.deleteImage( "p2_number_combo1" );
	DB->graphDB.deleteImage( "p2_number_combo2" );
	DB->graphDB.deleteImage( "p1_graph_combo" );
	DB->graphDB.deleteImage( "p2_graph_combo" );
	DB->graphDB.deleteImage( "number_time1" );
	DB->graphDB.deleteImage( "number_time2" );
	DB->graphDB.deleteImage( "number_time3" );
	DB->graphDB.deleteImage( "number_time4" );
	DB->graphDB.deleteImage( "number_time5" );
	DB->graphDB.deleteImage( "coron1" );
	DB->graphDB.deleteImage( "coron2" );

	DB->graphDB.deleteImage( "p1_stockgauge" );
	DB->graphDB.deleteImage( "p2_stockgauge" );
	DB->graphDB.deleteImage( "p1_stockgauge_flame" );
	DB->graphDB.deleteImage( "p2_stockgauge_flame" );
}