//---------------------------------------------------
// f֌Wf[^x[X
//---------------------------------------------------

#include "modelDB.h"

CModelDB::CModelDB()
{
}

CModelDB::~CModelDB()
{
	deleteModelAll();
}

/*
 fk_ScenẽAhXZbg
 */
void CModelDB::setAddress( fk_Scene *s )
{
	scene = s ;
}

/*
 f쐬
 */
void CModelDB::createModel( std::string name )
{
	if( findModel( name ) )
	{
		return ;
	}
	model.insert( std::make_pair( name , new modelBase ) );
	modelIte = model.find( name );
	(*modelIte).second->model = new fk_Model ;
	(*modelIte).second->block = new fk_Block ;
	(*modelIte).second->obb = new fkut_OBB ;
	(*modelIte).second->material = new fk_Material ;
	(*modelIte).second->mc = new CMotionCharactor ;
	(*modelIte).second->model->setShape( (*modelIte).second->block );
	(*modelIte).second->model->setMaterial( *((*modelIte).second->material) );
	(*modelIte).second->obb->setModel( (*modelIte).second->model );
	(*modelIte).second->mc->getBaseModel()->setParent( (*modelIte).second->model , true );
}

/*
 f폜
 */
void CModelDB::deleteModel( std::string name )
{
	if( findModel( name ) )
	{
		(*modelIte).second->mc->getBaseModel()->deleteParent( true );
		(*modelIte).second->mc->removeScene( scene );
		(*modelIte).second->model->deleteChildren( true );
		(*modelIte).second->model->deleteParent( true );
		scene->removeModel( (*modelIte).second->model );
		delete (*modelIte).second->material ;
		delete (*modelIte).second->mc ;
		delete (*modelIte).second->obb ;
		delete (*modelIte).second->block ;
		delete (*modelIte).second->model ;
		delete (*modelIte).second ;
		(*modelIte).second = NULL ;
		model.erase( name );
	}
}

/*
 Sf폜
 */
void CModelDB::deleteModelAll()
{
	for( modelIte = model.begin() ; modelIte != model.end() ; modelIte ++ )
	{
		(*modelIte).second->mc->getBaseModel()->deleteParent( true );
		(*modelIte).second->mc->removeScene( scene );
		(*modelIte).second->model->deleteChildren( true );
		(*modelIte).second->model->deleteParent( true );
		scene->removeModel( (*modelIte).second->model );
		delete (*modelIte).second->material ;
		delete (*modelIte).second->mc ;
		delete (*modelIte).second->obb ;
		delete (*modelIte).second->block ;
		delete (*modelIte).second->model ;
		delete (*modelIte).second ;
		(*modelIte).second = NULL ;
	}
	model.clear();
}

/*
 w肳ꂽÕftrue
 */
bool CModelDB::findModel( std::string name )
{
	modelIte = model.find( name );
	return ( modelIte != model.end() ) ;
}

/*
 fk_Scene::entryModelƓAfo^
 */
void CModelDB::entryModel( std::string name )
{
	if( findModel( name ) )
	{
		scene->entryModel( (*modelIte).second->model );
	}
}

/*
 fk_Scene::removeModelƓAf
 */
void CModelDB::removeModel( std::string name )
{
	if( findModel( name ) )
	{
		scene->removeModel( (*modelIte).second->model );
	}
}

/*
 CMotionCharactor::entrySceneƓA[Vo^
 */
void CModelDB::entryMotionCharactor( std::string name )
{
	if( findModel( name ) )
	{
		(*modelIte).second->mc->entryScene( scene );
	}
}

/*
 CMotionCharactor::removeSceneƓA[V
 */
void CModelDB::removeMotionCharactor( std::string name )
{
	if( findModel( name ) )
	{
		(*modelIte).second->mc->removeScene( scene );
	}
}

/*
 f̃|C^擾i݂ȂOw肷ƁAx㗎\̂ŒӁj
 */
fk_Model* CModelDB::getModel( std::string name )
{
	if( findModel( name ) )
	{
		return (*modelIte).second->model ;
	}
	fl_alert( "not found [%s]" , name );
	return NULL ;
}

/*
 OBB̃|C^擾i݂ȂOw肷ƁAx㗎\̂ŒӁj
 */
fkut_OBB* CModelDB::getOBB( std::string name )
{
	if( findModel( name ) )
	{
		return (*modelIte).second->obb ;
	}
	fl_alert( "not found [%s]" , name );
	return NULL ;
}

/*
 O[oWŎwn_ֈړ
 */
void CModelDB::glMoveTo( std::string name , double x , double y , double z )
{
	if( findModel( name ) )
	{
		(*modelIte).second->model->glMoveTo( x , y , z );
	}
}

void CModelDB::glMoveTo( std::string name , fk_Vector v )
{
	glMoveTo( name , v.x , v.y , v.z );
}

/*
 O[oWŎwʈړ
 */
void CModelDB::glTranslate( std::string name , double x , double y , double z )
{
	if( findModel( name ) )
	{
		(*modelIte).second->model->glTranslate( x , y , z );
	}
}

void CModelDB::glTranslate( std::string name , fk_Vector v )
{
	glTranslate( name , v.x , v.y , v.z );
}

/*
 [JWŎwʈړ
 */
void CModelDB::loTranslate( std::string name , double x , double y , double z )
{
	if( findModel( name ) )
	{
		(*modelIte).second->model->loTranslate( x , y , z );
	}
}

void CModelDB::loTranslate( std::string name , fk_Vector v )
{
	loTranslate( name , v.x , v.y , v.z );
}

/*
 O[oWŏœ_w
 */
void CModelDB::glFocus( std::string name , double x , double y , double z )
{
	if( findModel( name ) )
	{
		(*modelIte).second->model->glFocus( x , y , z );
	}
}

void CModelDB::glFocus( std::string name , fk_Vector v )
{
	glFocus( name , v.x , v.y , v.z );
}

/*
 [JWŏœ_w
 */
void CModelDB::loFocus( std::string name , double x , double y , double z )
{
	if( findModel( name ) )
	{
		(*modelIte).second->model->loFocus( x , y , z );
	}
}

void CModelDB::loFocus( std::string name , fk_Vector v )
{
	loFocus( name , v.x , v.y , v.z );
}

/*
 f̓蔻TCYw肷
 */
void CModelDB::setBlockSize( std::string name , double x , double y , double z )
{
	if( findModel( name ) )
	{
		(*modelIte).second->block->setBlockSize( x , y , z );
		(*modelIte).second->obb->setBlockSize( x , y , z );
	}
}

/*
 f̓蔻݂̂wʂ炷
 */
void CModelDB::setHitMargin( std::string name , double x , double y , double z )
{
	if( findModel( name ) )
	{
		(*modelIte).second->mc->getBaseModel()->glTranslate( x , y , z );
	}
}

/*
 efݒ肷
 */
void CModelDB::setParent( std::string name , fk_Model *m )
{
	if( findModel( name ) )
	{
		(*modelIte).second->model->setParent( m , true );
	}
}

void CModelDB::setParent( std::string name , std::string nameParent )
{
	if( findModel( nameParent ) )
	{
		setParent( name , (*modelIte).second->model );
	}
}

/*
 ef֌W
 */
void CModelDB::deleteParent( std::string name )
{
	if( findModel( name ) )
	{
		(*modelIte).second->model->deleteParent( true );
	}
}

/*
 qfݒ肷
 */
void CModelDB::setChild( std::string name , fk_Model *m )
{
	if( findModel( name ) )
	{
		m->setParent( (*modelIte).second->model , true );
	}
}

void CModelDB::setChild( std::string name , std::string nameChild )
{
	if( findModel( nameChild ) )
	{
		setChild( name , (*modelIte).second->model );
	}
}

/*
 qf֌W
 */
void CModelDB::deleteChildren( std::string name )
{
	if( findModel( name ) )
	{
		(*modelIte).second->model->deleteChildren( true );
	}
}

/*
 w肵fOBBŏՓ˔s
 */
bool CModelDB::checkCollision( std::string name , fkut_OBB *obb , fk_Vector *spd )
{
	fk_Vector	spdXZ , spdY , back , refV ;
	bool		hitFlag = false ;

	if( findModel( name ) )
	{
		spdXZ.set( spd->x , 0.0 , spd->z );
		spdY.set( 0.0 , spd->y , 0.0 );
		// XZ
		for( int i=0 ; i<5 ; i++ )
		{
			back.init();
			if( (*modelIte).second->obb->checkVSMovingOBB( *obb , spdXZ+back , refV ) )
			{
				back += -refV ;
				hitFlag = true ;
			}
			spdXZ += back ;
			if( back.isZero() )
			{
				break ;
			}
		}
		// Y
		for( int i=0 ; i<5 ; i++ )
		{
			back.init();
			if( (*modelIte).second->obb->checkVSMovingOBB( *obb , spdY+back , refV ) )
			{
				back += -refV ;
				hitFlag = true ;
			}
			spdY += back ;
			if( back.isZero() )
			{
				break ;
			}
		}

		// x
		*spd = spdXZ + spdY ;

		return hitFlag ;
	}
	return false ;
}

/*
 w肵̃fŏՓ˔s
 */
bool CModelDB::checkCollision( std::string name , std::string name2 , fk_Vector *spd )
{
	if( findModel( name2 ) )
	{
		return checkCollision( name , (*modelIte).second->obb , spd );
	}
	return false ;
}

/*
 f̊gUːFw肷
 */
void CModelDB::setDiffuseColor( std::string name , double r , double g , double b )
{
	if( findModel( name ) )
	{
		(*modelIte).second->material->setDiffuse( r , g , b );
	}
}

/*
 f̊ːFw肷
 */
void CModelDB::setAmbientColor( std::string name , double r , double g , double b )
{
	if( findModel( name ) )
	{
		(*modelIte).second->material->setAmbient( r , g , b );
	}
}

/*
 f̓xw肷
 */
void CModelDB::setAlpha( std::string name , double a )
{
	if( findModel( name ) )
	{
		(*modelIte).second->material->setAlpha( a );
	}
}

/*
 MQOt@CFKCt@Cǂݍ
 */
bool CModelDB::readMotionFile( std::string name , std::string mqoPass , std::string fkcPass )
{
	if( findModel( name ) )
	{
		if( !(*modelIte).second->mc->loadObjectData( mqoPass ) )
		{
			fl_alert( "read error [%s]" , mqoPass.c_str() );
			return false ;
		}
		if( !(*modelIte).second->mc->loadJointData( fkcPass ) )
		{
			fl_alert( "read error [%s]" , fkcPass.c_str() );
			return false ;
		}
		return true ;
	}
	return false ;
}

/*
 Aj[Vt@Cǂݍ
 */
bool CModelDB::readAnimationFile( std::string name , std::string pass )
{
	if( findModel( name ) )
	{
		if( !(*modelIte).second->mc->loadMotionData( pass ) )
		{
			fl_alert( "read error [%s]" , pass.c_str() );
			return false ;
		}
		return true ;
	}
	return false ;
}

/*
 CMotionCharactor::playMotionƓA[VĐ
 */
void CModelDB::playMotion( std::string name , int motionID )
{
	if( findModel( name ) )
	{
		(*modelIte).second->mc->playMotion( motionID );
	}
}

/*
 CMotionCharactor::isMotionFinishedƓA[V̍ŌȂtrue
 */
bool CModelDB::isMotionFinished( std::string name , int motionID )
{
	if( findModel( name ) )
	{
		if( (*modelIte).second->mc->isMotionFinished( motionID ) )
		{
			return true ;
		}
	}
	return false ;
}

/*
 CMotionCharactor::setNowFrameƓA[Vwt[Ɉړ
 */
void CModelDB::setNowFrame( std::string name , int motionID , int frame )
{
	if( findModel( name ) )
	{
		(*modelIte).second->mc->setNowFrame( motionID , frame );
	}
}

/*
 CMotionCharactor::getNowFrameƓA[Ṽt[擾
 */
int CModelDB::getNowFrame( std::string name , int motionID )
{
	if( findModel( name ) )
	{
		return (*modelIte).second->mc->getNowFrame( motionID );
	}
	return -1 ;
}
