//---------------------------------------------------
// f֌Wf[^x[X
//---------------------------------------------------

#pragma once

#include "common.h"

class CModelDB
{
private:
	fk_Scene	*scene ;

	struct modelBase
	{
		fk_Model			*model ;
		fk_Block			*block ;
		fkut_OBB			*obb ;
		fk_Material			*material ;
		CMotionCharactor	*mc ;
	};

	std::map<std::string , modelBase*>				model ;
	std::map<std::string , modelBase*>::iterator	modelIte ;

public:
	CModelDB();
	~CModelDB();

	void	setAddress( fk_Scene *s );
	void	createModel( std::string name );
	void	deleteModel( std::string name );
	void	deleteModelAll();
	bool	findModel( std::string name );
	void	entryModel( std::string name );
	void	removeModel( std::string name );
	void	entryMotionCharactor( std::string name );
	void	removeMotionCharactor( std::string name );
	fk_Model*	getModel( std::string name );
	fkut_OBB*	getOBB( std::string name );
	void	glMoveTo( std::string name , double x , double y , double z );
	void	glMoveTo( std::string name , fk_Vector v );
	void	glTranslate( std::string name , double x , double y , double z );
	void	glTranslate( std::string name , fk_Vector v );
	void	loTranslate( std::string name , double x , double y , double z );
	void	loTranslate( std::string name , fk_Vector v );
	void	glFocus( std::string name , double x , double y , double z );
	void	glFocus( std::string name , fk_Vector v );
	void	loFocus( std::string name , double x , double y , double z );
	void	loFocus( std::string name , fk_Vector v );
	void	setBlockSize( std::string name , double x , double y , double z );
	void	setHitMargin( std::string name , double x , double y , double z );
	void	setParent( std::string name , fk_Model *m );
	void	setParent( std::string name , std::string nameParent );
	void	deleteParent( std::string name );
	void	setChild( std::string name , fk_Model *m );
	void	setChild( std::string name , std::string nameChild );
	void	deleteChildren( std::string name );
	bool	checkCollision( std::string name , fkut_OBB *obb , fk_Vector *spd );
	bool	checkCollision( std::string name , std::string name2 , fk_Vector *spd );
	void	setDiffuseColor( std::string name , double r , double g , double b );
	void	setAmbientColor( std::string name , double r , double g , double b );
	void	setAlpha( std::string name , double a );
	bool	readMotionFile( std::string name , std::string mqoPass , std::string fkcPass );
	bool	readAnimationFile( std::string name , std::string pass );
	void	playMotion( std::string name , int motionID );
	bool	isMotionFinished( std::string name , int motionID );
	void	setNowFrame( std::string name , int motionID , int frame );
	int		getNowFrame( std::string name , int motionID );

};
