//---------------------------------------------------
// iQ
//---------------------------------------------------


#include "nageru.h"

CNageru::CNageru()
{
	nageru.setSize(10.0, 45.0, 10.0);
	nageruModel.setShape(&nageru);
	nageruModel.setMaterial(Blue);
	nageruModel.setSmoothMode(true);

	nageruModel.glMoveTo(0.0, 45.0, 0.0);//vCW

	//vC[f̈ʒuֈړ
	parentLiftBlockModel.glMoveTo(nageruModel.getPosition());

	//parentLiftBlockModel𒆐SɘZp``悤ɔzu
	liftBlockModel[0].glMoveTo(parentLiftBlockModel.getPosition().x, 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z-(20.0));
	liftBlockModel[1].glMoveTo(parentLiftBlockModel.getPosition().x+(17.3), 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z-(10.0));
	liftBlockModel[2].glMoveTo(parentLiftBlockModel.getPosition().x+(17.3), 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z+(10.0));
	liftBlockModel[3].glMoveTo(parentLiftBlockModel.getPosition().x, 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z+(20.0));
	liftBlockModel[4].glMoveTo(parentLiftBlockModel.getPosition().x-(17.3), 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z+(10.0));
	liftBlockModel[5].glMoveTo(parentLiftBlockModel.getPosition().x-(17.3), 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z-(10.0));

	for(int i = 0; i < 6; i++ )
	{
		liftBlock[i].setSize(8.0, 8.0, 8.0);
		liftBlockModel[i].setMaterial(Purple);
		liftBlockModel[i].setShape(&liftBlock[i]);
		liftBlockModel[i].setParent( &parentLiftBlockModel, true);
		isLiftBlockID[i] = 9999;
	}

	for(int i=0; i<6; i++ )
	{
		isThrowBlockID[i] = 9999;
		throwBlockDistance[i] = -1;
	}

	for(int i=0; i<6; i++ )
	{
		isVSThrowBlockID[i] = 999;
	}

	statusBase.lifeMax = 20;
	statusBase.life = statusBase.lifeMax;
	statusBase.stock = 0;
	statusBase.anima = 0.0;
	statusBase.combo = 0;

	motionStatus = NAGERU_STOP;
	damageMotionCount = -1;

	attack.setSize(50.0, 50.0, 50.0);
	attackModel.setShape(&attack);
	attackModel.setMaterial(White);
	attackOBB.setBlockSize(50.0, 50.0, 50.0);
	attackOBB.setModel(&attackModel);

	movingBase.acc = 0.0;
	movingBase.back = 0.0;
	movingBase.norm = 0.0;
	movingBase.pos = 0.0;
	movingBase.refV = 0.0;
	movingBase.spd = 0.0;
	movingBase.vec = 0.0;
	movingBase.view = 0.0;
	movingBase.canJump = true;
	movingBase.isDash = false;
	movingBase.dashCount = 0;
	movingBase.flyCount = 0;


	movingBase.rotMat.makeRot(FK_PI/2.0, fk_Y);

	isAttackHitFlag = false;

	ino.setSize(17.0, 55.0, 17.0);
	inoModel.setShape(&ino);
	inoModel.setMaterial(Blue);
	inoModel.setSmoothMode(true);

	inoThrow.setSize( 8.0, 8.0, 8.0);
	inoThrowModel.setShape(&inoThrow);
	inoThrowModel.setMaterial(Green);
	inoThrowModel.setSmoothMode(true);

	inoThrowOBB.setBlockSize(8.0, 8.0, 8.0);
	inoThrowOBB.setModel(&inoThrowModel);

	inoRush.setSize( 16.0, 16.0, 16.0);
	inoRushModel.setShape(&inoRush);
	inoRushModel.setMaterial(White);
	inoRushModel.setSmoothMode(true);

	inoRushOBB.setBlockSize(16.0, 16.0, 16.0);
	inoRushOBB.setModel(&inoRushModel);

	animaThrowBlockDistance = -1;
	isAnimaRushHitFlag = false;
	isAnimaThrowHitFlag = false;

	ino_motionStatus = INO_STOP;

	isDebug = false;
}

CNageru::~CNageru()
{
}

void CNageru::init(CDatabase *DB)
{
	statusBase.lifeMax = 20;
	statusBase.life = statusBase.lifeMax;
	statusBase.stock = 0;
	statusBase.anima = 0.0;
	statusBase.combo = 0;

	motionStatus = NAGERU_STOP;
	damageMotionCount = -1;

	movingBase.acc = 0.0;
	movingBase.back = 0.0;
	movingBase.norm = 0.0;
	movingBase.pos = 0.0;
	movingBase.refV = 0.0;
	movingBase.spd = 0.0;
	movingBase.vec = 0.0;
	movingBase.view = 0.0;
	movingBase.canJump = true;
	movingBase.isDash = false;
	movingBase.dashCount = 0;
	movingBase.flyCount = 0;
	movingBase.rotMat.makeRot(FK_PI/2.0, fk_Y);

	

	for(int i=0; i<6; i++ )
	{
		isThrowBlockID[i] = 9999;
		throwBlockDistance[i] = -1;
	}

	isAttackHitFlag = false;

	animaThrowBlockDistance = -1;
	isAnimaRushHitFlag = false;
	isAnimaThrowHitFlag = false;

	ino_motionStatus = INO_STOP;

	isDebug = false;
}

void CNageru::setMaxLife(int maxLife)
{
	statusBase.lifeMax = maxLife;
	statusBase.life = statusBase.lifeMax;
}

void CNageru::loadModel(CDatabase *DB,std::string str1 ,std::string str2 , std::string str3 , std::string str4 )
{
	nageruStr = str1 ;
	inoStr = str2 ;
	inoThrowStr = str3 ;
	returnStr = str4 ;
	DB->modelDB.createModel( nageruStr );
	DB->modelDB.readMotionFile( nageruStr , "dat/model/nageru/nageru.mqo" , "dat/model/nageru/nageru_setup.fkc" );
	DB->modelDB.readAnimationFile(nageruStr ,"dat/model/nageru/nageru_neutralpose.fkm");
	DB->modelDB.readAnimationFile(nageruStr ,"dat/model/nageru/nageru_walk_front.fkm");
	DB->modelDB.readAnimationFile(nageruStr ,"dat/model/nageru/nageru_walk_back.fkm");
	DB->modelDB.readAnimationFile(nageruStr ,"dat/model/nageru/nageru_walk_right.fkm");
	DB->modelDB.readAnimationFile( nageruStr ,"dat/model/nageru/nageru_walk_left.fkm");
	DB->modelDB.readAnimationFile( nageruStr , "dat/model/nageru/nageru_jump_rize.fkm");
	DB->modelDB.readAnimationFile( nageruStr ,"dat/model/nageru/nageru_jump_spin.fkm");
	DB->modelDB.readAnimationFile( nageruStr ,"dat/model/nageru/nageru_jump_fall.fkm");
	DB->modelDB.readAnimationFile( nageruStr , "dat/model/nageru/nageru_attack01.fkm" );	//XgbNȂUǂ
	DB->modelDB.readAnimationFile( nageruStr , "dat/model/nageru/nageru_slash.fkm" );
	DB->modelDB.readAnimationFile( nageruStr , "dat/model/nageru/nageru_throw.fkm" );
	DB->modelDB.readAnimationFile( nageruStr , "dat/model/nageru/nageru_damage.fkm" );
	DB->modelDB.readAnimationFile( nageruStr , "dat/model/nageru/nageru_down.fkm" );
	DB->modelDB.readAnimationFile( nageruStr , "dat/model/nageru/nageru_down_loop.fkm" );
	DB->modelDB.entryMotionCharactor( nageruStr );
	DB->modelDB.setBlockSize( nageruStr, 10.0, 45.0, 10.0 );
	//DB->modelDB.entryModel("nageru");

	DB->modelDB.createModel( returnStr );
	DB->modelDB.readMotionFile( returnStr , "dat/model/nageru/return.mqo" , "dat/model/nageru/return.fkc" );

	DB->modelDB.createModel( inoStr );
	DB->modelDB.readMotionFile( inoStr , "dat/model/anima/anima.mqo" , "dat/model/anima/anima_born.fkc" );

	DB->modelDB.readAnimationFile( inoStr , "dat/model/anima/init.fkm" );
	DB->modelDB.readAnimationFile( inoStr , "dat/model/anima/a_rush.fkm" );
	DB->modelDB.readAnimationFile( inoStr , "dat/model/anima/a_throw.fkm" );
	DB->modelDB.readAnimationFile( inoStr , "dat/model/anima/a_repair.fkm" );
	DB->modelDB.readAnimationFile( inoStr , "dat/model/anima/a_cure.fkm" );

	DB->modelDB.createModel( inoThrowStr );
	DB->modelDB.readMotionFile( inoThrowStr , "dat/model/anima/anima_ball.mqo" , "dat/model/anima/anima_ball.fkc" );
	DB->modelDB.setBlockSize( inoThrowStr, 8.0, 8.0, 8.0 );
}

//f̃[V̍XV
void CNageru::updateModel(CDatabase *DB)
{
	DB->modelDB.glMoveTo( nageruStr, nageruModel.getPosition() );
	DB->modelDB.getModel(nageruStr)->glAngle( nageruModel.getAngle() );
	if(motionStatus != NAGERU_DEAD )
	{
		DB->modelDB.playMotion( nageruStr , motionStatus );
	}

	DB->modelDB.glMoveTo( returnStr, nageruModel.getPosition().x, nageruModel.getPosition().y , nageruModel.getPosition().z);
	DB->modelDB.getModel(returnStr)->loFocus( 0.1, 0.0, -1.0 );

	DB->modelDB.glMoveTo( inoStr, inoModel.getPosition() );
	DB->modelDB.getModel(inoStr)->glAngle( inoModel.getAngle() );
	DB->modelDB.playMotion( inoStr , ino_motionStatus );

	DB->modelDB.glMoveTo( inoThrowStr, inoThrowModel.getPosition() );
	DB->modelDB.getModel(inoThrowStr)->loFocus( 0.6, 0.4, -1.0 );
	DB->modelDB.playMotion(inoThrowStr, 0 );
}

CNageru::StatusBase CNageru::getStatusBase()
{
	return statusBase;
}


CNageru::MovingBase CNageru::getMovingBase()
{
	return movingBase;
}

CNageru::MotionStatus CNageru::getMotionStatus()
{
	return motionStatus;
}

//ʒu
void CNageru::setPos(fk_Vector pos)
{
	nageruModel.glMoveTo( pos );
}		

fk_Vector CNageru::getPos()
{
	return nageruModel.getPosition();
}

fk_Model * CNageru::getPModel()
{
	return &nageruModel;
}

fk_Model * CNageru::getPAttackModel()
{
	return &attackModel;
}

fk_Model * CNageru::getPAnimaThrowModel()
{
	return &inoThrowModel;
}

//*spd擾
fk_Vector * CNageru::getPSpd()
{
	return &movingBase.spd;
}

void CNageru::setThrowSpd(fk_Vector vec)
{
	throwBlockVec = vec;
}

fk_Vector * CNageru::getPThrowSpd()
{
	return &throwBlockVec;
}

unsigned int CNageru::getLiftBlockID(int liftNum )
{
	return isLiftBlockID[liftNum];	
}

fk_Vector * CNageru::getPanimaThrowSpd()
{
	return &animaThrowBlockVec;
}

int CNageru::getAttackDamage()
{
	return int(attackDamage * comboBonus);
}

int CNageru::getThrowDamage()
{
	int throwDamage = 5;
	return int(throwDamage * comboBonus);
}

int CNageru::getAnimaRushDamage()
{
	return int(animaRushDamage * comboBonus);
}

int CNageru::getAnimaThrowDamage()
{
	int animaThrowDamage = 20;
	return int(animaThrowDamage * comboBonus);
}

fkut_OBB * CNageru::getAttackPObb()
{
	return &attackOBB;
}

void CNageru::setAttackFlag(bool flag)
{
	isAttackHitFlag = flag;
}

bool CNageru::getAttackFlag()
{
	return isAttackHitFlag;
}

void CNageru::setAnimaRushFlag(bool hitFlag)
{
	isAnimaRushHitFlag = hitFlag;
}	

bool CNageru::getAnimaRushFlag()
{
	return isAnimaRushHitFlag;
}

bool CNageru::getAnimaThrowFlag()
{
	return isAnimaThrowHitFlag;
}

void CNageru::motionStateStand()
{
	if(motionStatus != NAGERU_ATTACK && motionStatus != NAGERU_ATTACK_NS && motionStatus != NAGERU_THROW &&
		motionStatus != NAGERU_JUMP	&& motionStatus != NAGERU_SPIN && 
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		motionStatus = NAGERU_STAND;	
	}
}

void CNageru::motionStateStop()
{
	if(motionStatus == NAGERU_JUMP || motionStatus == NAGERU_FALL || motionStatus == NAGERU_SPIN &&
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		motionStatus = NAGERU_STOP;	
	}
}

void CNageru::motionStateFall()
{
	if(motionStatus == NAGERU_JUMP && movingBase.spd.y <1.5 && 
		motionStatus != NAGERU_ATTACK && motionStatus != NAGERU_THROW &&
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		motionStatus = NAGERU_SPIN;	
	}


	if(movingBase.spd.y < -0.1 && motionStatus != NAGERU_ATTACK && motionStatus != NAGERU_THROW &&
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		motionStatus = NAGERU_FALL;	
	}
}

//is菈
void CNageru::setView(fk_Vector cameraVec)
{
	movingBase.view = cameraVec;
	movingBase.view.y = 0.0;
	movingBase.view.normalize();
	return;
}

// n㎞͓x^A󒆂ł͉x
void CNageru::initSpd()
{
	movingBase.spd.init();
	return;
}

//ړ̍s
void CNageru::moveAction(int direct)
{
	if( motionStatus != NAGERU_ATTACK && motionStatus != NAGERU_DAMAGE &&
		damageMotionCount == -1 &&
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		switch(direct)
		{
			//
		case DIRECTION_DOWN:
			if(abs(movingBase.acc.y) > 0.0)
			{
				movingBase.acc -= movingBase.view*0.2;
			}
			else
			{
				movingBase.spd -= movingBase.view*1.5;
			}

			if( motionStatus != NAGERU_JUMP  && motionStatus != NAGERU_FALL && motionStatus != NAGERU_SPIN &&
				motionStatus != NAGERU_ATTACK && motionStatus != NAGERU_THROW )
			{
				motionStatus = NAGERU_WALK_B;
			}
			break;
			//
		case DIRECTION_LEFT:
			if(abs(movingBase.acc.y) > 0.0) 
			{
				movingBase.acc += movingBase.rotMat*movingBase.view*0.2;
			}
			else
			{
				movingBase.spd += movingBase.rotMat*movingBase.view*1.0;
			}

			if( motionStatus != NAGERU_JUMP  && motionStatus != NAGERU_FALL && motionStatus != NAGERU_SPIN &&
				motionStatus != NAGERU_ATTACK && motionStatus != NAGERU_THROW )
			{
				motionStatus = NAGERU_WALK_L;
			}
			break;
			//E
		case DIRECTION_RIGHT:
			if(abs(movingBase.acc.y) > 0.0) 
			{
				movingBase.acc -= movingBase.rotMat*movingBase.view*0.2;
			}
			else
			{
				movingBase.spd -= movingBase.rotMat*movingBase.view*1.0;
			}

			if( motionStatus != NAGERU_JUMP  && motionStatus != NAGERU_FALL && motionStatus != NAGERU_SPIN &&
				motionStatus != NAGERU_ATTACK && motionStatus != NAGERU_THROW )
			{
				motionStatus = NAGERU_WALK_R;
			}
			break;
			//
		case DIRECTION_UP:
			if(abs(movingBase.acc.y) > 0.0)
			{
				movingBase.acc += movingBase.view*0.2;
			}
			else
			{
				movingBase.spd += movingBase.view*1.0;
			}

			if( motionStatus != NAGERU_JUMP  && motionStatus != NAGERU_FALL && motionStatus != NAGERU_SPIN &&
				motionStatus != NAGERU_ATTACK && motionStatus != NAGERU_THROW )
			{
				motionStatus = NAGERU_WALK_F;
			}
			break;

		default:
			break;
		}
	}
	return;
}

void CNageru::setJumpFlag(bool flag)
{
	movingBase.canJump = flag;
}

//ՓˎxAWvtO
void CNageru::initAcc()
{
	movingBase.canJump = true;
	movingBase.acc.init();
	return;
}

//Wv̍sitgǂɂƂ
void CNageru::jumpAction(bool isLift)
{
	if( motionStatus != NAGERU_DAMAGE &&
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		if(movingBase.canJump == true || isLift == true)
		{
			if(movingBase.flyCount > 0 )
			{
				statusBase.inv = 0;
			}
			movingBase.flyCount = 0;
			movingBase.acc.x = movingBase.spd.x;
			movingBase.acc.z = movingBase.spd.z;
			//acc.y = 2.0;//TṽWv
			movingBase.acc.y = 4.5;
			if(isLift == false )
			{
				movingBase.canJump = false;
			}

			motionStatus = NAGERU_JUMP;
		}
	}
}

//Xs[hʏ퉻̒l̐ݒ
void CNageru::normSpd()
{
	if(movingBase.spd.normalize() ) 
	{
		movingBase.spd *= 1.0;
	}
	movingBase.vec = movingBase.spd;	//擾
	return;
}

//_bV̍s
void CNageru::dashAction()
{
	if(motionStatus != NAGERU_DAMAGE &&
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		if(movingBase.isDash == true )
		{
			//20t[_bV
			if(movingBase.dashCount > 20 )
			{
				movingBase.isDash = false;
				movingBase.dashCount = 0;
			}
			while(movingBase.acc.y < 0 )
			{
				movingBase.acc.y += 0.098;
			}
			movingBase.spd += movingBase.acc*2;

			movingBase.dashCount ++;
		}
	}
	return;
}

//d͂̉e
void CNageru::setGravity()
{
	if(movingBase.flyCount == 0 )
	{
		//acc.y -= 0.098;//Tvd
		movingBase.acc.y -= 0.098*1.70;
		if(movingBase.acc.x * movingBase.acc.x + movingBase.acc.z * movingBase.acc.z > 1.0*1.0) {
			double tmpSpdLen = sqrt(movingBase.acc.x * movingBase.acc.x + movingBase.acc.z * movingBase.acc.z);
			movingBase.acc.x *= 1.0/tmpSpdLen;
			movingBase.acc.z *= 1.0/tmpSpdLen;
		} else {
			movingBase.acc.x *= 0.9;
			movingBase.acc.z *= 0.9;
		}
		return;
	}
}

//ߐڍÜړ
void CNageru::moveAttack()
{
	if(motionStatus == NAGERU_ATTACK &&
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		movingBase.acc.y = 0;
		//movingBase.spd.x += movingBase.view.x *0.2;
		//movingBase.spd.z += movingBase.view.z *0.2;
		//movingBase.spd.x += movingBase.spd.x *0.2;
		//movingBase.spd.z += movingBase.spd.z *0.2;
		movingBase.acc.x = 0;
		movingBase.acc.z = 0;
	}
	return;
}

//x𑬓xɏ悹
void CNageru::addAcc()
{
	movingBase.spd += movingBase.acc;
	if(movingBase.spd.y == 0.0 )
	{
		movingBase.spd.x += movingBase.acc.x;
		movingBase.spd.z += movingBase.acc.z;
	}
	if(movingBase.spd.y < -3.0 )
	{
		movingBase.spd.y = -3.0;
	}
	return;
}

//vC̏
bool CNageru::setFallState()
{
	bool isDrop = false;
	if(nageruModel.getPosition().y < -200)
	{
		nageruModel.loTranslate(0.0, 280.0, 0.0);
		isDrop= true;
		movingBase.canJump = false;
		movingBase.flyCount = 240;
		damageMotionCount = 0;
		initAcc();
	}
	return isDrop;
}

void CNageru::updateFly(CDatabase *DB)
{
	movingBase.flyCount --;
	if(movingBase.flyCount <= 0 )
	{
		DB->modelDB.removeMotionCharactor( returnStr );
		movingBase.flyCount = 0;
	}
	else
	{
		DB->modelDB.entryMotionCharactor( returnStr );
	}
}

// x𑀍샂fɉĎۂɓ
void CNageru::translatePlayer(CDatabase *DB)
{
	movingBase.spd.x *=  1.5;
	movingBase.spd.z *=  1.5;
	nageruModel.glTranslate(movingBase.spd);
	nageruModel.glVec(movingBase.vec);	//␳
	return;
}

//GɌČύX
void CNageru::setVecEnemy(fk_Vector pos)
{
	if(	motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD )
	{
		nageruModel.glFocus(pos.x, nageruModel.getPosition().y + movingBase.vec.y, pos.z);
		nageruModel.loFocus(0, 0, 1);
	}
	return;
}

void CNageru::entryLiftBlock(fk_Scene *argScene, unsigned int blockID)
{
	if(motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		for(int i=0 ; i < 6; i++ )
		{	
			if(isLiftBlockID[i] == 9999)
			{
				statusBase.stock ++;
				isLiftBlockID[i] = blockID;
				argScene->entryModel( &liftBlockModel[i] );
				return;
			}
		}
	}
	return;
}


unsigned int CNageru::removeLiftBlock(fk_Scene *argScene)
{
	if(	motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD )
	{
		for(int i=0 ; i < 6; i++ )
		{	
			if(isLiftBlockID[i] != 9999)
			{
				unsigned int blockID = isLiftBlockID[i];
				statusBase.stock --;
				isLiftBlockID[i] = 9999;
				argScene->removeModel( &liftBlockModel[i] );
				return blockID;
			}
		}
	}
	return 9999;
}

// tgubN̈ړA]
void CNageru::moveLiftBlock()
{
	parentLiftBlockModel.glMoveTo(nageruModel.getPosition() );
	parentLiftBlockModel.loTranslate(0.0, 30.0, 0.0 );
	parentLiftBlockModel.loFocus(0.07, 0.0, -1.0);
}


//X[
unsigned int CNageru::doThrow(fk_Scene *argScene)
{
	if(statusBase.stock > 0 )
	{
		unsigned int blockID;
		blockID = removeLiftBlock(argScene);
		doDash();
		motionStatus = NAGERU_THROW;	
		return blockID;
	}
	return 9999;
}

void CNageru::entryVSThrowBlock(unsigned int blockID)
{
	for(int i=0; i<6; i++ )
	{
		if(isVSThrowBlockID[i] == 999 )
		{
			isVSThrowBlockID[i] = blockID;
			return;
		}
	}
}

bool CNageru::checkHitVSThrowBlockID(unsigned int blockID)
{
	for(int i=0; i<6; i++ )
	{
		if(isVSThrowBlockID[i] == blockID )
		{
			return false;
		}
	}
	return true;
}

void CNageru::removeVSThrowBlockID(unsigned int blockID)
{
	for(int i=0; i<6; i++ )
	{
		if(isVSThrowBlockID[i] == blockID )
		{
			isVSThrowBlockID[i] = 999;
			return;
		}
	}
}

//X[̃ubN̈ړ̌vZn
void CNageru::startCalcThrowBlockDistance(unsigned int blockID)
{
	for(int i=0; i<6; i++)
	{
		if(throwBlockDistance[i] == -1 )
		{
			throwBlockDistance[i] = 0;
			isThrowBlockID[i] = blockID;
			return;
		}
	}
}

//X[ubN̈ړ̌vZ
unsigned int CNageru::calcThrowBlockDistance()
{
	for(int i=0; i<6; i++)
	{
		if(throwBlockDistance[i] >= 0 )
		{
			throwBlockDistance[i] ++;
			if(throwBlockDistance[i] >= 200 )
			{
				isVSThrowBlockID[i] = 999;
				throwBlockDistance[i] = -1;
				return isThrowBlockID[i];
			}
		}
	}
	return 9999;
}

//X[̃ubN̈ړ̌vZn
void CNageru::stopCalcThrowBlockDistance(unsigned int blockID)
{
	for(int i=0; i<6; i++)
	{
		if(isThrowBlockID[i] == blockID)
		{
			throwBlockDistance[i] = -1;
			return;
		}
	}
}

//_bV֐ݒ
void CNageru::doDash()
{
	movingBase.isDash = true;
}

// Uݒ
unsigned int CNageru::doAttack(fk_Scene *argScene)
{
	if(statusBase.stock > 0 && motionStatus != NAGERU_ATTACK &&
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		//fk_Window::printf("ok");
		unsigned int returnID;
		attackModel.glMoveTo( nageruModel.getPosition() );
		attackModel.glAngle( nageruModel.getAngle() );
		attackModel.loTranslate( 0.0, 20.0, 30.0 );

		returnID = removeLiftBlock(argScene);
		motionStatus = NAGERU_ATTACK;
		return returnID;
	}
	return 9999;
}

//U̓蔻XV
void CNageru::updateAttack(CDatabase *DB)
{
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18 )
	{
		attackDamage = int(2 * comboBonus);
		isAttackHitFlag = true;
		attackModel.setMaterial( Red);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18 + 5 )
	{
		isAttackHitFlag = false;
		attackModel.setMaterial( White);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18*2  )
	{
		attackDamage = int(2 * comboBonus);
		isAttackHitFlag = true;
		attackModel.setMaterial( Red);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18*2 +5)
	{
		isAttackHitFlag = false;
		attackModel.setMaterial( White);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18*3 )
	{
		attackDamage = int(3 * comboBonus);
		isAttackHitFlag = true;
		attackModel.setMaterial( Red);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18*3 +5)
	{
		isAttackHitFlag = false;
		attackModel.setMaterial( White);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18*4 )
	{
		attackDamage = int(4 * comboBonus);
		isAttackHitFlag = true;
		attackModel.setMaterial( Red);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18*4 +5)
	{
		isAttackHitFlag = false;
		attackModel.setMaterial( White);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18*5 )
	{
		attackDamage = int(4 * comboBonus);
		isAttackHitFlag = true;
		attackModel.setMaterial( Red);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 18*5 +5)
	{
		isAttackHitFlag = false;
		attackModel.setMaterial( White);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 96 )
	{
		attackDamage = int(3 * comboBonus);
		isAttackHitFlag = true;
		attackModel.setMaterial( Red);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 96 +5)
	{
		isAttackHitFlag = false;
		attackModel.setMaterial( White);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 102 )
	{
		attackDamage = int(3 * comboBonus);
		isAttackHitFlag = true;
		attackModel.setMaterial( Red);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 102 +5)
	{
		isAttackHitFlag = false;
		attackModel.setMaterial( White);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 108 )
	{
		attackDamage = int(3 * comboBonus);
		isAttackHitFlag = true;
		attackModel.setMaterial( Red);
	}
	if(DB->modelDB.getNowFrame(nageruStr, NAGERU_ATTACK ) == 108 +5)
	{
		isAttackHitFlag = false;
		attackModel.setMaterial( White);
	}
}

//[V̒~
void CNageru::stopMotionStatus(CDatabase *DB)
{
	if(DB->modelDB.isMotionFinished( nageruStr,  NAGERU_ATTACK ) ||
		DB->modelDB.isMotionFinished( nageruStr,  NAGERU_THROW ) ||
		DB->modelDB.isMotionFinished( nageruStr,  NAGERU_SPIN ) )
	{
		DB->modelDB.setNowFrame( nageruStr ,motionStatus ,0 );
		motionStatus = NAGERU_STOP;
	}
}

//Aj}Q[W̑
void CNageru::plusAnimaGauge(double plusNum)
{
	statusBase.anima += plusNum;
	if(statusBase.anima >= 1.0 )
	{
		statusBase.anima = 1.0;
	}
}

//Aj}̏
void CNageru::summonAnima(CDatabase *DB, int motionStatus)
{
	if(statusBase.anima >= 1.0 &&
		motionStatus != NAGERU_DEAD_START && motionStatus != NAGERU_DEAD)
	{
		statusBase.anima = 0;
		inoModel.glMoveTo( nageruModel.getPosition() );
		inoModel.glAngle( nageruModel.getAngle() );
		DB->modelDB.entryMotionCharactor( inoStr );


		switch(motionStatus)
		{
		case 1:
			ino_motionStatus = INO_RUSH;
			inoRushModel.glMoveTo( inoModel.getPosition() );
			inoRushModel.glAngle( inoModel.getAngle() );
			inoRushModel.loTranslate( 0.0, 60.0, 50.0 );
			break;

		case 2:
			ino_motionStatus = INO_THROW;
			inoThrowModel.glMoveTo( inoModel.getPosition() );
			inoThrowModel.loTranslate( 0.0, 60.0, 10.0 );
			isAnimaThrowHitFlag = true;
			DB->modelDB.entryMotionCharactor(inoThrowStr);
			animaThrowBlockDistance = 0;
			break;

		case 3:
			ino_motionStatus = INO_REPAIR;
			break;

		case 4:
			ino_motionStatus = INO_CURE;
			statusBase.life += (statusBase.lifeMax /2);
			if(statusBase.life > statusBase.lifeMax )
			{
				statusBase.life = statusBase.lifeMax;
			}
			break;

		default :
			break;
		}
	}
}

void CNageru::setThrowFocus(fk_Vector pos)
{
	animaThrowBlockVec = inoThrowModel.getPosition() - pos;
	animaThrowBlockVec.normalize();
	animaThrowBlockVec *= -1;
	//animaThrowBlockVec *= -8;
}

//Aj}̃[u
void CNageru::removeIno(CDatabase *DB, bool stageChageFlag)
{
	if(stageChageFlag == false )
	{
		if(DB->modelDB.isMotionFinished( inoStr,  ino_motionStatus ))
		{
			ino_motionStatus = INO_STAND;
			DB->modelDB.removeMotionCharactor( inoStr );
			isAnimaRushHitFlag = false;
		}
	}
	else
	{
		ino_motionStatus = INO_STAND;
		DB->modelDB.removeMotionCharactor( inoStr );
		isAnimaRushHitFlag = false;
	}
}

//Aj}̃Abvf[g
void CNageru::updateAnima(CDatabase *DB)
{
	switch(ino_motionStatus)
	{
	case INO_RUSH:
		if(DB->modelDB.getNowFrame(inoStr, ino_motionStatus ) >= 28 && DB->modelDB.getNowFrame(inoStr, ino_motionStatus ) <= 50 )
		{
			inoModel.loTranslate( 0.0, 0.0, 3.0 );
			inoRushModel.loTranslate( 0.0, 0.0, 3.0 );

			if(isAnimaRushHitFlag == false && DB->modelDB.getNowFrame(inoStr, ino_motionStatus ) %3 == 0)
			{
				animaRushDamage = 6;
				isAnimaRushHitFlag = true;
			}

		}

		if(DB->modelDB.getNowFrame(inoStr, ino_motionStatus ) == 80 )
		{
			animaRushDamage = 10;
			isAnimaRushHitFlag = true;
		}
		if(DB->modelDB.getNowFrame(inoStr, ino_motionStatus ) >= 85 && DB->modelDB.getNowFrame(inoStr, ino_motionStatus ) < 90)
		{
			inoModel.loTranslate( 0.0, 2.0, 1.0 );
			inoRushModel.loTranslate( 0.0, 2.0, 1.0 );
		}
		break;

	default :
		break;

	}
}

void CNageru::updateAnimaThrow(CDatabase *DB)
{
	if(animaThrowBlockDistance >= 0 )
	{
		animaThrowBlockDistance ++;
		if(DB->modelDB.getNowFrame(inoStr, ino_motionStatus ) > 20 || animaThrowBlockDistance > 20)
		{
			//inoThrowModel.glTranslate( animaThrowBlockVec );
			inoThrowModel.glTranslate( animaThrowBlockVec*8 );
		}
		if(animaThrowBlockDistance > 150 )
		{
			DB->modelDB.removeMotionCharactor( inoThrowStr );
			isAnimaThrowHitFlag = false;
			animaThrowBlockDistance = -1;
		}
	}
}

void CNageru::removeAnimaThrow(CDatabase *DB)
{
	DB->modelDB.removeMotionCharactor( inoThrowStr );
	isAnimaThrowHitFlag = false;
	animaThrowBlockDistance = -1;
}

void CNageru::setDamage(int damage, int inv)
{
	if( statusBase.inv == 0 )
	{
		if(damage > 0 )
		{
			statusBase.life -= damage;
			statusBase.combo = 0;
			damageMotionCount = 0;
			motionStatus = NAGERU_DAMAGE;
		}
		if(statusBase.life < 0)
		{
			statusBase.life = 0;
		}
		statusBase.inv = inv;
	}
}

void CNageru::updateInv()
{
	statusBase.inv --;
	if(statusBase.inv < 0 )
	{
		statusBase.inv = 0;
	}
}

int CNageru::getInv()
{
	return statusBase.inv;
}

void CNageru::updateDamageMotion()
{
	if(damageMotionCount >= 0 )
	{
		damageMotionCount ++;
		if(damageMotionCount > 30)
		{
			damageMotionCount = -1;
		}
		motionStatus = NAGERU_DAMAGE;
	}

}

void CNageru::updateCombo()
{
	comboTime --;
	if(comboTime <= 0 )
	{
		comboTime = 0;
		statusBase.combo = 0;
	}

	comboBonus = 1.0 + 0.1*statusBase.combo/4;
}

void CNageru::addCombo()
{
	statusBase.combo ++;
	comboTime = 300;
}

// fobOF蔻`
void CNageru::debugDraw(fk_Scene *argScene)
{
	if(isDebug == false)
	{
		argScene->entryModel( &attackModel );
		argScene->entryModel( &inoRushModel );
		isDebug = true;
	}
	else
	{
		argScene->removeModel( &attackModel );
		argScene->removeModel( &inoRushModel );
		isDebug = false;
	}
}

void CNageru::updateDead(CDatabase *DB)
{
	if(motionStatus != NAGERU_DEAD )
	{
		if(statusBase.life <= 0 && motionStatus != NAGERU_DEAD_START)
		{
			motionStatus = NAGERU_DEAD_START;
		}
		if(DB->modelDB.isMotionFinished( nageruStr,  NAGERU_DEAD_START ) && statusBase.life <= 0)
		{
			motionStatus = NAGERU_DEAD;
		}
	}
}

void CNageru::deleteModel(CDatabase *DB)
{
	//DB->modelDB.removeMotionCharactor(nageruStr);
	DB->modelDB.deleteModel(nageruStr);
	DB->modelDB.deleteModel(inoStr);
	DB->modelDB.deleteModel(returnStr);
	DB->modelDB.deleteModel(inoThrowStr);
	DB->systemDB.getScene()->removeModel(&nageruModel);
	DB->systemDB.getScene()->removeModel(&parentLiftBlockModel);
	for(int i=0; i<6; i++ )
	{
		DB->systemDB.getScene()->removeModel(&liftBlockModel[i]);
	}
	DB->systemDB.getScene()->removeModel(&attackModel);
	DB->systemDB.getScene()->removeModel(&inoModel);
	DB->systemDB.getScene()->removeModel(&inoThrowModel);
	DB->systemDB.getScene()->removeModel(&inoRushModel);
}

void CNageru::debug()
{
	//fk_Window::printf( "acc,spd = %lf,%lf" , movingBase.acc.x, movingBase.spd.x );
	//fk_Window::printf( "blockDistance = %d" , throwBlockDistance[0] );
	fk_Window::printf( "%d" , motionStatus );
}