//---------------------------------------------------
// iQ
//---------------------------------------------------


#pragma once

#include "common.h"
#include "database.h"

class CNageru
{

private :
	std::string nageruStr , inoStr , inoThrowStr , returnStr ;
	fk_Block		nageru;
	fk_Model		nageruModel;

	fk_Model	parentLiftBlockModel;	//グubN]p̐ef
	fk_Block	liftBlock[6];			//グubN	
	fk_Model	liftBlockModel[6];

	struct StatusBase {
		int lifeMax;
		int life;
		int stock;
		double anima;
		int combo;
		int inv;
	};

	int comboTime;
	double comboBonus;
	int attackDamage;
	int animaRushDamage;
	StatusBase statusBase;

	unsigned int isLiftBlockID[6];
	unsigned int isThrowBlockID[12];
	unsigned int isVSThrowBlockID[12];

	struct MovingBase{
		//ړA@Ŏgϐ
		fk_Vector pos;
		fk_Vector		spd, acc, view, norm, back, refV;
		fk_Vector		vec;
		fk_Matrix		rotMat;
		bool canJump;
		bool isDash;
		int dashCount;
		int flyCount;
	};

	MovingBase movingBase;

	//U֌W
	int	throwBlockDistance[6];
	fk_Vector throwBlockVec;

	fk_Block		attack;
	fk_Model		attackModel;
	fkut_OBB		attackOBB;

	bool isAttackHitFlag;


	//ԑJ
	enum MotionStatus{
		NAGERU_STOP = -1,	//~
		NAGERU_STAND,		//0 
		NAGERU_WALK_F,		//1 siOj
		NAGERU_WALK_B,		//2 sij
		NAGERU_WALK_R,		//3 sij
		NAGERU_WALK_L,		//4 siEj
		NAGERU_JUMP,		//5 Wv
		NAGERU_SPIN,		//6 Wv_̉]
		NAGERU_FALL,		//7 
		NAGERU_ATTACK_NS,	//8 ߐڍUiXgbNȂj
		NAGERU_ATTACK,		//9 ߐڍUiXgbNj
		NAGERU_THROW,		//10 U
		NAGERU_DAMAGE,		//11 _[W
		NAGERU_DEAD_START,	//12 Ɏn
		NAGERU_DEAD,		//13 S
	};

	MotionStatus motionStatus;

	int damageMotionCount;

	enum DirectionStatus{
		DIRECTION_UP = 0,
		DIRECTION_DOWN,
		DIRECTION_LEFT,
		DIRECTION_RIGHT
	};

	DirectionStatus directionStatus;


	fk_Block		ino;
	fk_Model		inoModel;

	fk_Block		inoThrow;
	fk_Model		inoThrowModel;
	fkut_OBB		inoThrowOBB;

	fk_Block		inoRush;
	fk_Model		inoRushModel;
	fkut_OBB		inoRushOBB;

	enum Ino_MotionStatus
	{
		INO_STOP = -1,
		INO_STAND,	//0 _ij
		INO_RUSH,	//1 Aj}XbV
		INO_THROW,	//2 Aj}X[
		INO_REPAIR,	//3 Aj}yA
		INO_CURE,	//4 Aj}LA
	};

	Ino_MotionStatus ino_motionStatus;

	fk_Vector animaThrowBlockVec;
	int animaThrowBlockDistance;
	bool isAnimaThrowHitFlag;
	bool isAnimaRushHitFlag;

	bool isDebug;

public :
	CNageru();
	~CNageru();

	void init(CDatabase *DB);
	void setMaxLife(int maxLife);

	void loadModel(CDatabase *DB,std::string str1 ,std::string str2 , std::string str3 , std::string str4 );
	void updateModel(CDatabase *DB);

	CNageru::StatusBase getStatusBase();
	CNageru::MovingBase getMovingBase();

	void motionStateStand();
	void motionStateStop();
	void motionStateFall();

	CNageru::MotionStatus getMotionStatus(); 
	fk_Model * getPModel();
	fk_Model * getPAttackModel();
	fk_Model * getPAnimaThrowModel();
	void setPos(fk_Vector pos);		//ʒu
	fk_Vector getPos();						//ʒuW擾
	fk_Vector * getPSpd();						//x|C^擾
	void setThrowSpd(fk_Vector vec);
	unsigned int getLiftBlockID(int liftNum );
	fk_Vector * getPThrowSpd();
	fk_Vector * getPanimaThrowSpd();
	int getAttackDamage();
	int getThrowDamage();
	int getAnimaRushDamage();
	int getAnimaThrowDamage();
	fkut_OBB * getAttackPObb();
	void setAttackFlag(bool flag);
	bool getAttackFlag();
	void setAnimaRushFlag(bool hitFlag);
	bool getAnimaRushFlag();
	bool getAnimaThrowFlag();

	void setView(fk_Vector cameraVec);		//is菈
	void initSpd();							//n㎞͓x^A󒆂ł͉x
	void setJumpFlag(bool flag);
	void initAcc();

	void moveAction(int directNum);	//ړ̍s
	void jumpAction(bool isLift);	//Wv̍s
	void moveAttack();
	void addAcc();					//x𑬓xɒǉ
	void normSpd();					//Xs[hʏ퉻̒l̐ݒ

	bool setFallState();
	void updateFly(CDatabase *DB);

	void dashAction();
	void setGravity();
	void translatePlayer(CDatabase *DB);				// x𑀍샂fɉĎۂɓ

	void setVecEnemy(fk_Vector pos);//GɌČύX

	void entryLiftBlock(fk_Scene *argScene, unsigned int blockID);
	unsigned int removeLiftBlock(fk_Scene *argScene);
	void moveLiftBlock();

	unsigned int doThrow(fk_Scene *argScene);
	void entryVSThrowBlock(unsigned int blockID);
	bool checkHitVSThrowBlockID(unsigned int blockID);
	void removeVSThrowBlockID(unsigned int blockID);
	void startCalcThrowBlockDistance(unsigned int blockID);
	unsigned int calcThrowBlockDistance();
	void stopCalcThrowBlockDistance(unsigned int blockID);
	void doDash();
	unsigned int doAttack(fk_Scene *argScene);

	void stopMotionStatus(CDatabase *DB);
	void updateAttack(CDatabase *DB);
	void removeIno(CDatabase *DB, bool stageChageFlag);

	void setDamage(int damage, int inv);
	void updateInv();
	int getInv();
	void updateDamageMotion();

	void plusAnimaGauge(double plusNum);
	void summonAnima(CDatabase *DB, int ino_motionStatus);
	void setThrowFocus(fk_Vector pos);
	void updateAnima(CDatabase *DB);
	void updateAnimaThrow(CDatabase *DB);
	void removeAnimaThrow(CDatabase *DB);

	void updateCombo();
	void addCombo();

	void updateDead(CDatabase *DB);

	void deleteModel(CDatabase *DB);

	void debugDraw(fk_Scene *argScene);
	void debug();
};