//---------------------------------------------------
// IvV
//---------------------------------------------------

#include "option.h"

COption::COption()
{
	cursorNum = 0;
	isWindowMode = 1;
	gameLevel = 2;
	bgmVolume = 100;
	seVolume = 100;
	cameraMode = 0 ;
}

COption::~COption()
{
}

void COption::init()
{
	bgmVolume = DB->configDB.getBgmVolume();
	seVolume = DB->configDB.getSeVolume();
	cameraMode = DB->configDB.getCameraMode();

	DB->graphDB.setImage( "option", "dat/graph/title/option.png" );
	DB->graphDB.setPositionLT( "option", -90.0, WINDOW_HEIGHT/2.0 -30);

	DB->graphDB.setImage( "windowsize", "dat/graph/option/windowsize.png" );
	DB->graphDB.setPositionLT( "windowsize", -400.0, 150.0);
	DB->graphDB.setImage( "windowsize_d", "dat/graph/option/windowsize_d.png" );
	DB->graphDB.setPositionLT( "windowsize_d", -400.0, 150.0);
	DB->graphDB.setImage( "gamelevel", "dat/graph/option/gamelevel.png" );
	DB->graphDB.setPositionLT( "gamelevel", -400.0, 100.0);
	DB->graphDB.setImage( "gamelevel_d", "dat/graph/option/gamelevel_d.png" );
	DB->graphDB.setPositionLT( "gamelevel_d", -400.0, 100.0);
	DB->graphDB.setImage( "bgmvolume", "dat/graph/option/bgmvolume.png" );
	DB->graphDB.setPositionLT( "bgmvolume", -400.0, 50.0);
	DB->graphDB.setImage( "bgmvolume_d", "dat/graph/option/bgmvolume_d.png" );
	DB->graphDB.setPositionLT( "bgmvolume_d", -400.0, 50.0);
	DB->graphDB.setImage( "sevolume", "dat/graph/option/sevolume.png" );
	DB->graphDB.setPositionLT( "sevolume", -400.0, 0.0);
	DB->graphDB.setImage( "sevolume_d", "dat/graph/option/sevolume_d.png" );
	DB->graphDB.setPositionLT( "sevolume_d", -400.0, 0.0);
	DB->graphDB.setImage( "cameramode", "dat/graph/option/cameramode.png" );
	DB->graphDB.setPositionLT( "cameramode", -400.0, -50.0);
	DB->graphDB.setImage( "cameramode_d", "dat/graph/option/cameramode_d.png" );
	DB->graphDB.setPositionLT( "cameramode_d", -400.0, -50.0);
	DB->graphDB.setImage( "datadelete", "dat/graph/option/datadelete.png" );
	DB->graphDB.setPositionLT( "datadelete", -400.0, -100.0);
	DB->graphDB.setImage( "datadelete_d", "dat/graph/option/datadelete_d.png" );
	DB->graphDB.setPositionLT( "datadelete_d", -400.0, -100.0);
	DB->graphDB.setImage( "return", "dat/graph/option/return.png" );
	DB->graphDB.setPositionLT( "return", -400.0, -150.0);
	DB->graphDB.setImage( "return_d", "dat/graph/option/return_d.png" );
	DB->graphDB.setPositionLT( "return_d", -400.0, -150.0);

	DB->graphDB.setImage( "window", "dat/graph/option/window.png" );
	DB->graphDB.setPositionLT( "window", -150.0, 150.0);
	DB->graphDB.setImage( "fullscreen", "dat/graph/option/fullscreen.png" );
	DB->graphDB.setPositionLT( "fullscreen", 175.0, 150.0);

	DB->graphDB.setImage( "easy", "dat/graph/option/easy.png" );
	DB->graphDB.setPositionLT( "easy", -150.0, 100.0);
	DB->graphDB.setImage( "normal", "dat/graph/option/normal.png" );
	DB->graphDB.setPositionLT( "normal", 50.0, 100.0);
	DB->graphDB.setImage( "hard", "dat/graph/option/hard.png" );
	DB->graphDB.setPositionLT( "hard", 250.0, 100.0);

	DB->graphDB.setImage( "gauge1", "dat/graph/option/gauge.png" );
	DB->graphDB.setPositionLT( "gauge1", -150.0, 50.0);
	DB->graphDB.setImage( "gauge2", "dat/graph/option/gauge.png" );
	DB->graphDB.setPositionLT( "gauge2", -150.0, 0.0);

	DB->graphDB.setImage( "auto", "dat/graph/option/auto.png" );
	DB->graphDB.setPositionLT( "auto", -150.0, -50.0);
	DB->graphDB.setImage( "manual", "dat/graph/option/manual.png" );
	DB->graphDB.setPositionLT( "manual", 150.0, -50.0);

	DB->graphDB.setImage( "ok_question1", "dat/graph/option/ok_question.png" );
	DB->graphDB.setPositionLT( "ok_question1", -150.0, -100.0);

	DB->graphDB.setImage( "ok_question2", "dat/graph/option/ok_question.png" );
	DB->graphDB.setPositionLT( "ok_question2", -150.0, -150.0);


	DB->graphDB.setImage( "cursor_op", "dat/graph/option/cursor_op.png" );
	DB->graphDB.setPositionLT( "cursor_op", -175.0, 150.0);
	DB->graphDB.setImage( "cursor_op2", "dat/graph/option/cursor_op.png" );
	DB->graphDB.setPositionLT( "cursor_op2", -175.0, 100.0);
	DB->graphDB.setImage( "cursor_op3", "dat/graph/option/cursor_op.png" );
	DB->graphDB.setPositionLT( "cursor_op3", -175.0, -50.0);
	DB->graphDB.setImage( "cursor_op4", "dat/graph/option/cursor_op.png" );
	DB->graphDB.setPositionLT( "cursor_op4", -175.0, -100.0);
	DB->graphDB.setImage( "cursor_op5", "dat/graph/option/cursor_op.png" );
	DB->graphDB.setPositionLT( "cursor_op5", -175.0, -150.0);
}

bool COption::onPeriod()
{
	/*
	//vZ
	*/
	if( input->checkDown( INPUT_UP ) ) cursorNum --;
	if( input->checkDown( INPUT_DOWN ) ) cursorNum ++;
	if(cursorNum < 0 ) cursorNum = 0;
	if(cursorNum > 6 ) cursorNum = 6;

	switch(cursorNum)
	{
	case 0:
		if( input->checkDown( INPUT_RIGHT ) )   isWindowMode = false;
		if( input->checkDown( INPUT_LEFT ) ) isWindowMode = true;
		break;
	case 1:
		if( input->checkDown( INPUT_RIGHT ) )   gameLevel ++;
		if( input->checkDown( INPUT_LEFT ) ) gameLevel --;
		if( gameLevel < 1 ) gameLevel = 1;
		if( gameLevel > 3 ) gameLevel = 3;
		break;
	case 2:
		if( input->checkPress( INPUT_RIGHT ) && bgmVolume < 100 )   bgmVolume ++;
		if( input->checkPress( INPUT_LEFT ) && bgmVolume > 0 ) bgmVolume --;
		break;
	case 3:
		if( input->checkPress( INPUT_RIGHT ) && seVolume < 100 )   seVolume ++;
		if( input->checkPress( INPUT_LEFT ) && seVolume > 0 ) seVolume --;
		break;
	case 4:
		if( input->checkPress( INPUT_RIGHT ) )   cameraMode = 1 ;
		if( input->checkPress( INPUT_LEFT ) ) cameraMode = 0 ;
		break;
	case 5:
		if( input->checkDown( INPUT_1 ) )
		{	//f[^
			DB->rankingDB.deleteRanking( "ranking.dat" );
		}
		break;
	case 6:
		if( input->checkDown( INPUT_1 ) )
		{
			*scene = S_TITLE;
			//摜
			DB->graphDB.deleteImage( "windowsize" );
			DB->graphDB.deleteImage( "windowsize_d" );
			DB->graphDB.deleteImage( "gamelevel" );
			DB->graphDB.deleteImage( "gamelevel_d" );
			DB->graphDB.deleteImage( "bgmvolume" );
			DB->graphDB.deleteImage( "bgmvolume_d" );
			DB->graphDB.deleteImage( "sevolume" );
			DB->graphDB.deleteImage( "sevolume_d" );
			DB->graphDB.deleteImage( "cameramode" );
			DB->graphDB.deleteImage( "cameramode_d" );
			DB->graphDB.deleteImage( "datadelete" );
			DB->graphDB.deleteImage( "datadelete_d" );
			DB->graphDB.deleteImage( "return" );
			DB->graphDB.deleteImage( "return_d" );
			DB->graphDB.deleteImage( "window" );
			DB->graphDB.deleteImage( "fullscreen" );
			DB->graphDB.deleteImage( "easy" );
			DB->graphDB.deleteImage( "normal" );
			DB->graphDB.deleteImage( "hard" );
			DB->graphDB.deleteImage( "ok_question1" );
			DB->graphDB.deleteImage( "ok_question2" );
			DB->graphDB.deleteImage( "auto" );
			DB->graphDB.deleteImage( "manual" );
			DB->graphDB.deleteImage( "cursor_op" );
			DB->graphDB.deleteImage( "cursor_op2" );
			DB->graphDB.deleteImage( "cursor_op3" );
			DB->graphDB.deleteImage( "cursor_op4" );
			DB->graphDB.deleteImage( "cursor_op5" );
			DB->configDB.setBgmVolume( bgmVolume );
			DB->configDB.setSeVolume( seVolume );
			DB->soundDB.changeVolume( bgmVolume , seVolume );
			DB->systemDB.setDifficulty( gameLevel );
			if( isWindowMode )
			{
				DB->systemDB.windowMode();
			}
			else
			{
				DB->systemDB.fullscreenMode();
			}
			if( cameraMode == 0 )
			{
				DB->configDB.setCameraMode( 0 );
			}
			else
			{
				DB->configDB.setCameraMode( 1 );
			}
			return true;
		}
		break;
	default:
		break;
	}

	/*
	//`揈
	*/
	DB->graphDB.removeImage( "windowsize_d" );	
	DB->graphDB.removeImage( "gamelevel_d" );
	DB->graphDB.removeImage( "datadelete_d" );
	DB->graphDB.removeImage( "bgmvolume_d" );
	DB->graphDB.removeImage( "sevolume_d" );
	DB->graphDB.removeImage( "return_d" );
	DB->graphDB.entryImage( "windowsize" );
	DB->graphDB.entryImage( "gamelevel" );
	DB->graphDB.entryImage( "cameramode" );
	DB->graphDB.entryImage( "datadelete" );
	DB->graphDB.entryImage( "bgmvolume" );
	DB->graphDB.entryImage( "sevolume" );
	DB->graphDB.entryImage( "return" );
	switch(cursorNum)
	{
	case 0:
		DB->graphDB.removeImage( "windowsize" );
		DB->graphDB.entryImage( "windowsize_d" );
		break;
	case 1:
		DB->graphDB.removeImage( "gamelevel" );
		DB->graphDB.entryImage( "gamelevel_d" );
		break;
	case 2:
		DB->graphDB.removeImage( "bgmvolume" );
		DB->graphDB.entryImage( "bgmvolume_d" );
		break;
	case 3:
		DB->graphDB.removeImage( "sevolume" );
		DB->graphDB.entryImage( "sevolume_d" );
		break;
	case 4:
		DB->graphDB.removeImage( "cameramode" );
		DB->graphDB.entryImage( "cameramode_d" );
		break;
	case 5:
		DB->graphDB.removeImage( "datadelete" );
		DB->graphDB.entryImage( "datadelete_d" );
		break;
	case 6:
		DB->graphDB.removeImage( "return" );
		DB->graphDB.entryImage( "return_d" );
		break;
	default:
		break;
	}

	if(isWindowMode != true ) DB->graphDB.setPositionLT( "cursor_op", 145.0, 150.0);
	else DB->graphDB.setPositionLT( "cursor_op", -175.0, 150.0);

	if(gameLevel == 1 ) DB->graphDB.setPositionLT( "cursor_op2", -175.0, 100.0);
	else if(gameLevel == 2 ) DB->graphDB.setPositionLT( "cursor_op2", 25.0, 100.0);
	else if(gameLevel == 3 ) DB->graphDB.setPositionLT( "cursor_op2", 225.0, 100.0);
	if(cameraMode == 0 ) DB->graphDB.setPositionLT( "cursor_op3" , -175.0 , -50.0 );
	else if(cameraMode == 1 ) DB->graphDB.setPositionLT( "cursor_op3" , 120.0 , -50.0 );

	DB->graphDB.setSpriteArea( "gauge1" , 0.0 , 0.0 , 176.0*(bgmVolume/100.0)+10.0 , 38.0 );
	DB->graphDB.setPositionLT( "gauge1" , -150.0 , 50.0 );
	DB->graphDB.setSpriteArea( "gauge2" , 0.0 , 0.0 , 176.0*(seVolume/100.0)+10.0 , 38.0 );
	DB->graphDB.setPositionLT( "gauge2" , -150.0 , 0.0 );
	return false ;
}
