//---------------------------------------------------
// LOf[^x[X
//---------------------------------------------------

#include "rankingDB.h"

CRankingDB::CRankingDB()
{
	for( int i=0 ; i<10 ; i++ )
	{
		rankScore[i] = 0 ;
	}
	key1 = 0x615d2f ;
	key2 = 0x1aa3c7 ;
}

CRankingDB::~CRankingDB()
{
}

/*
 LOf[^ǂݍ
 */
bool CRankingDB::loadRanking( const char* pass )
{
	int		check1 , check2 ;

	std::ifstream txt( pass );
	if( txt.fail() )
	{
		fl_alert( "read error [%s]" , pass );
		return false ;
	}
	for( int i=0 ; i<10 ; i++ )
	{
		txt >> check1 ;
		txt >> check2 ;
		if( (check1^key1) != (check2^key2) )
		{
			fl_alert( "ranking data error - unjust data" );
			txt.close();
			for( int j=0 ; j<10 ; j++ )
			{
				rankScore[j] = 0 ;
			}
			return false ;
		}
		rankScore[i] = check1^key1 ;
	}
	txt.close();
	return true ;
}

/*
 LOf[^
 */
void CRankingDB::saveRanking( const char* pass )
{
	std::ofstream	txt( pass );
	if( txt.fail() )
	{
		fl_alert( "read error [%s]" , pass );
		return ;
	}
	for( int i=0 ; i<10 ; i++ )
	{
		if( i != 0 )
		{
			txt << " " ;
		}
		txt << (rankScore[i]^key1) << " " << (rankScore[i]^key2) ;
	}
	txt.close();
}

/*
 LOf[^
 */
void CRankingDB::deleteRanking( const char* pass )
{
	std::ofstream	txt( pass );
	if( txt.fail() )
	{
		return ;
	}
	for( int i=0 ; i<10 ; i++ )
	{
		if( i != 0 )
		{
			txt << " " ;
		}
		txt << (0^key1) << " " << (0^key2) ;
	}
	txt.close();
}

/*
 LOf[^o^
 */
int CRankingDB::setRankingScore( int score )
{
	for( int i=0 ; i<10 ; i++ )
	{
		if( rankScore[i] < score )
		{
			for( int j=9 ; j>i ; j-- )
			{
				rankScore[j] = rankScore[j-1] ;
			}
			rankScore[i] = score ;
			return i+1 ;
		}
	}
	return -1 ;
}

/*
 LOf[^擾
 */
int CRankingDB::getRankingScore( int rank )
{
	if( rank >= 1 && rank <= 10 )
	{
		return rankScore[rank-1] ;
	}
	return -1 ;
}
