//---------------------------------------------------
// bNLO
//---------------------------------------------------


#include "rocking.h"

CRocking::CRocking()
{
	rocking.setSize(120.0, 120.0, 120.0);
	rockingModel.glMoveTo(0.0, 60.1, -180.0);
	rockingModel.setMaterial(DarkGreen);
	rockingModel.setShape(&rocking);
	rockingModel.setSmoothMode(true);

	rockingModel.glMoveTo(0.0, -45.0, 0.0);//vCW

	//vC[f̈ʒuֈړ
	parentLiftBlockModel.glMoveTo(rockingModel.getPosition());

	//parentLiftBlockModel𒆐SɘZp``悤ɔzu
	liftBlockModel[0].glMoveTo(parentLiftBlockModel.getPosition().x, 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z-(20.0*2));
	liftBlockModel[1].glMoveTo(parentLiftBlockModel.getPosition().x+(17.3*2), 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z-(10.0*2));
	liftBlockModel[2].glMoveTo(parentLiftBlockModel.getPosition().x+(17.3*2), 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z+(10.0*2));
	liftBlockModel[3].glMoveTo(parentLiftBlockModel.getPosition().x, 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z+(20.0*2));
	liftBlockModel[4].glMoveTo(parentLiftBlockModel.getPosition().x-(17.3*2), 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z+(10.0*2));
	liftBlockModel[5].glMoveTo(parentLiftBlockModel.getPosition().x-(17.3*2), 
		parentLiftBlockModel.getPosition().y, 
		parentLiftBlockModel.getPosition().z-(10.0*2));

	for(int i = 0; i < 6; i++ )
	{
		liftBlock[i].setSize(8.0*4, 8.0*4, 8.0*4);
		liftBlockModel[i].setMaterial(Purple);
		liftBlockModel[i].setShape(&liftBlock[i]);
		liftBlockModel[i].setParent( &parentLiftBlockModel, true);
		isLiftBlockID[i] = false;
	}

	statusBase.lifeMax = 20;
	statusBase.life = statusBase.lifeMax;
	statusBase.stock = 0;
	statusBase.anima = 0.0;
	statusBase.combo = 0;
	statusBase.inv = 0;

	movingBase.acc = fk_Vector(0.0, 0.0, 0.0);
	movingBase.spd = fk_Vector(0.0, 0.0, 0.0);
	movingBase.pos = fk_Vector(0.0, 0.0, 0.0);
	movingBase.moveVec = fk_Vector(0.0, 0.0, 0.0);

	motionStatus = ROCKING_STAND;

	gameLevel = 1;
	enemyAI = 0;
	actCount = 0;
	attackPattern = 0;
	hitBlock = false;

	rush.setSize(60.0, 60.0, 100.0);
	rushModel.glMoveTo(0.0, 60.1, -180.0);
	rushModel.setMaterial(Purple);
	rushModel.setShape(&rush);
	rushModel.setSmoothMode(true);
	rushOBB.setBlockSize(60.0, 60.0, 90.0);
	rushOBB.setModel(&rushModel);
	

	rushHitFlag = false;

	shockwaveHitFlag[shockwaveNum] = false;
	shockwaveDistance[shockwaveNum] = 0;

	isDebug = false;
}

CRocking::~CRocking()
{
}

void CRocking::init()
{
	statusBase.lifeMax = 250;
	statusBase.life = statusBase.lifeMax;
	statusBase.stock = 0;
	statusBase.anima = 0.0;
	statusBase.combo = 0;

	movingBase.acc = fk_Vector(0.0, 0.0, 0.0);
	movingBase.spd = fk_Vector(0.0, 0.0, 0.0);
	movingBase.pos = fk_Vector(0.0, 0.0, 0.0);
	movingBase.moveVec = fk_Vector(0.0, 0.0, 0.0);

	motionStatus = ROCKING_STAND;

	gameLevel = 1;
	enemyAI = 0;
	actCount = 0;
	attackPattern = 0;
	hitBlock = false;

	rushHitFlag = false;

	shockwaveHitFlag[shockwaveNum] = false;
	shockwaveDistance[shockwaveNum] = 0;

	isDebug = false;
}

void CRocking::loadModel(CDatabase *DB)
{
	DB->modelDB.createModel( "rocking" );
	DB->modelDB.readMotionFile( "rocking" , "dat/model/rocking/Rocking_third.mqo" , "dat/model/rocking/Rocking.fkc" );
	DB->modelDB.readAnimationFile("rocking" ,"dat/model/rocking/rocking_neutralpose.fkm");
	DB->modelDB.readAnimationFile( "rocking" ,"dat/model/rocking/rocking_fall001.fkm");
	DB->modelDB.readAnimationFile( "rocking" ,"dat/model/rocking/rocking_fall002.fkm");
	DB->modelDB.readAnimationFile( "rocking" ,"dat/model/rocking/rocking_fall002.fkm");
	DB->modelDB.readAnimationFile("rocking" ,"dat/model/rocking/rocking_fall003_start.fkm");
	DB->modelDB.readAnimationFile("rocking" ,"dat/model/rocking/rocking_fall003_c.fkm");
	DB->modelDB.readAnimationFile("rocking" ,"dat/model/rocking/rocking_fall003.fkm");
	DB->modelDB.readAnimationFile( "rocking" , "dat/model/rocking/rocking_lift.fkm");
	DB->modelDB.readAnimationFile( "rocking" ,"dat/model/rocking/rocking_throw.fkm");
	DB->modelDB.readAnimationFile( "rocking" ,"dat/model/rocking/rocking_rush.fkm");
	DB->modelDB.readAnimationFile( "rocking" , "dat/model/rocking/rocking_dead3.fkm" );
	DB->modelDB.entryMotionCharactor( "rocking" );
	DB->modelDB.setHitMargin("rocking", 0.0, -40.0, 0.0);
	DB->modelDB.setBlockSize( "rocking", 120.0, 120.0, 120.0 );

	for(int i=0; i<shockwaveNum; i++ )
	{
		shockwave[i].setBlockSize(60.0, 10.0, 25.0);
		shockwaveModel[i].setShape( &shockwave[i] );
		shockwaveModel[i].glMoveTo( rockingModel.getPosition() );
		//DB->systemDB.getScene()->entryModel( &shockwaveModel[i] );
		shockwaveOBB[i].setBlockSize(60.0, 10.0, 25.0);
		shockwaveOBB[i].setModel( &shockwaveModel[i] );
		if(!shockwave_wObj[i].loadObjectData( "dat/model/rocking/shockwave_w.mqo" ))fk_Window::printf("[shockwave_w.mqo] Read Error.");
		if(!shockwave_wObj[i].loadJointData( "dat/model/rocking/shockwave_w.fkc" ))fk_Window::printf("[shockwave_w.fkc] Read Error.");
		if(!shockwave_hObj[i].loadObjectData( "dat/model/rocking/shockwave.mqo" ))fk_Window::printf("[shockwave.mqo] Read Error.");
		if(!shockwave_hObj[i].loadJointData( "dat/model/rocking/shockwave.fkc" ))fk_Window::printf("[shockwave.fkc] Read Error.");
	}
}

void CRocking::updateModel(CDatabase *DB)
{
	DB->modelDB.glMoveTo( "rocking", rockingModel.getPosition() );
	DB->modelDB.getModel("rocking")->glAngle( rockingModel.getAngle() );
	DB->modelDB.playMotion( "rocking" , motionStatus );

	for(int i=0;i<shockwaveNum;i++)
	{
		shockwave_wObj[i].getBaseModel()->glMoveTo( shockwaveModel[i].getPosition() );
		shockwave_wObj[i].getBaseModel()->glAngle( shockwaveModel[i].getAngle() );
		shockwave_wObj[i].getBaseModel()->loTranslate(0.0, 20.0, -10.0 );
		shockwave_wObj[i].getBaseModel()->loFocus( 0.0, 0.0, 1.0 );
		shockwave_hObj[i].getBaseModel()->glMoveTo( shockwaveModel[i].getPosition() );
		shockwave_hObj[i].getBaseModel()->glAngle( shockwaveModel[i].getAngle() );
		shockwave_hObj[i].getBaseModel()->loTranslate(0.0, 20.0, -10.0 );
		shockwave_hObj[i].getBaseModel()->loFocus( 0.0, 0.0, 1.0 );
	}
}

//ʒu
void CRocking::setPos(fk_Vector pos)
{
	rockingModel.glMoveTo( pos );
	rockingModel.glTranslate( 0.0, 40.0, 0.0 );
}	

fk_Vector CRocking::getPos()
{
	return rockingModel.getPosition();
}

void CRocking::initSpd()
{
	movingBase.spd.init();
	return;
}

//*spd擾
fk_Vector * CRocking::getPSpd()
{
	return &movingBase.spd;
}

fk_Model * CRocking::getPModel()
{
	return &rockingModel;
}

int CRocking::getShockwaveNum()
{
	return shockwaveNum;
}

fkut_OBB * CRocking::getPShockwaveOBB(int shockwaveID)
{
	return &shockwaveOBB[shockwaveID];
}

void CRocking::setShockwaveHitFlag(int shockwaveID, bool hitFlag)
{
	shockwaveHitFlag[shockwaveID] = hitFlag;
}

bool CRocking::getShockwaveHitFlag(int shockwaveID)
{
	return shockwaveHitFlag[shockwaveID];
}

void CRocking::setRushHitFlag(bool hitFlag)
{
	rushHitFlag = hitFlag;
}

bool CRocking::getRushHitFlag()
{
		return rushHitFlag;
}

fkut_OBB * CRocking::getPRushOBB()
{
	return &rushOBB;
}

CRocking::MotionStatus CRocking::getMotionStatus()
{
	return motionStatus;
}

CRocking::StatusBase CRocking::getStatusBase()
{
	return statusBase;
}


void CRocking::entryLiftBlock(fk_Scene *argScene, unsigned int blockID)
{
	for(int i=0 ; i < 6; i++ )
	{	
		if(isLiftBlockID[i] == 9999)
		{
			statusBase.stock ++;
			isLiftBlockID[i] = blockID;
			argScene->entryModel( &liftBlockModel[i] );
			return;
		}
	}
	return;
}

unsigned int CRocking::removeLiftBlock(fk_Scene *argScene)
{
	for(int i=0 ; i < 6; i++ )
	{	
		if(isLiftBlockID[i] != 9999)
		{
			unsigned int blockID = isLiftBlockID[i];
			statusBase.stock --;
			isLiftBlockID[i] = 9999;
			argScene->removeModel( &liftBlockModel[i] );
			return blockID;
		}
	}
	return 9999;
}

// tgubN̈ړA]
void CRocking::moveLiftBlock()
{
	parentLiftBlockModel.glMoveTo(rockingModel.getPosition() );
	parentLiftBlockModel.loTranslate(0.0, 30.0, 0.0 );
	parentLiftBlockModel.loFocus(0.07, 0.0, -1.0);
}

void CRocking::translatePlayer(CDatabase *DB)
{
	rockingModel.glTranslate(movingBase.spd);
	rockingModel.glVec(movingBase.vec);	//␳
}

//vC[̕֌
void CRocking::focusToPlayer(fk_Vector pos)
{
	if(motionStatus == ROCKING_STAND || motionStatus == ROCKING_RUSH ||  motionStatus == ROCKING_THROW ||( motionStatus == ROCKING_FALL && movingBase.pos.y < 0 ))
	{
		rockingModel.glFocus(pos.x, getPos().y, pos.z);
		rockingModel.loFocus(0, 0, 1);
		movingBase.moveVec = fk_Vector(pos.x - rockingModel.getPosition().x, 0.0, pos.z - rockingModel.getPosition().z);
		movingBase.moveVec.normalize();
		return;
	}
}

void CRocking::setDamage(int damage, int inv)
{
	if( statusBase.inv == 0 )
	{
		statusBase.life -= damage;
		if(statusBase.life < 0)
		{
			statusBase.life = 0;
		}
		statusBase.inv = inv;
	}
}

void CRocking::updateInv()
{
	statusBase.inv --;
	if(statusBase.inv < 0 )
	{
		statusBase.inv = 0;
	}
}

void CRocking::setHitBlock(bool hitFlag)
{
	hitBlock = hitFlag;
	if(hitFlag == true )
	{
		movingBase.spd = fk_Vector ( 0.0, 0.0, 0.0 );
	}
}

//GAIJEg̑ƍsp^[̌
void CRocking::actAI(CDatabase *DB, fk_Vector pos)
{
	enemyAI ++;
	if(statusBase.life <= 0 )
	{
		motionStatus = ROCKING_DEAD_START;
	}
	if(getPos().y <= -30.0 )
	{
		enemyAI = 0;
		motionStatus = ROCKING_MOVE;
		rockingModel.glTranslate( 0.0, 250.0, 0.0);
		rockingModel.glFocus(pos.x, getPos().y, pos.z);
		rockingModel.loFocus(0, 0, 1);
		movingBase.moveVec = fk_Vector(pos.x - rockingModel.getPosition().x, 0.0, pos.z - rockingModel.getPosition().z);
		movingBase.moveVec.normalize();
		movingBase.spd = movingBase.moveVec;
	}
	

	switch(motionStatus)
	{
	case ROCKING_STAND:
		if(enemyAI > 150 )
		{	
			enemyAI = 0;
			motionStatus = ROCKING_JUMP_START;
			movingBase.spd = fk_Vector(0.0, 2.0, 0.0);
		}
		break;

	case ROCKING_JUMP_START:
		if(DB->modelDB.isMotionFinished( "rocking", motionStatus) )
		{
			enemyAI = 0;
			motionStatus = ROCKING_JUMP;
		}
		break;

	case ROCKING_JUMP:
		if(enemyAI > 50 )
		{
			motionStatus = ROCKING_MOVE;
			enemyAI = 0;
			movingBase.spd = movingBase.moveVec/2;
		}
		break;

	case ROCKING_MOVE:
		if(enemyAI > 150 )
		{	
			enemyAI = 0;
			movingBase.spd = fk_Vector(0.0, -3.0, 0.0 );
			motionStatus = ROCKING_FALL_START;
		}
		break;

	case ROCKING_FALL_START:
		if(DB->modelDB.isMotionFinished( "rocking", motionStatus) )
		{
			enemyAI = 0;
			motionStatus = ROCKING_FALL;
		}
		break;


	case ROCKING_FALL:
		if(hitBlock == true )
		{
			enemyAI = 0;
			motionStatus = ROCKING_LANDING;

			switch(attackPattern)
			{
			case 0:
				actShockwave(DB);
				attackPattern = 1;
				break;

			case 1:
				actShockwave(DB);
				attackPattern = 2;
				break;

			case 2:
				actShockwave(DB);
				attackPattern = 0;
				break;

			default:
				break;
			}
		}

		break;

	case ROCKING_LANDING:
		if(DB->modelDB.isMotionFinished( "rocking", motionStatus) )
		{
			if(statusBase.anima >= 1.0 )
			{
				motionStatus = ROCKING_RUSH;
				enemyAI = 0;
			}
			else if(statusBase.stock > 0 )
			{
				motionStatus = ROCKING_THROW;
				enemyAI = 0;
			}
			else
			{
				motionStatus = ROCKING_LIFT;
				enemyAI = 0;
			}
		}
		break;

	case ROCKING_LIFT:
		if(DB->modelDB.isMotionFinished( "rocking", motionStatus) )
		{
			enemyAI = 0;
			if(gameLevel < 3 ) 
			{
				motionStatus = ROCKING_STAND;
			}
			else
			{
				motionStatus = ROCKING_JUMP;
				movingBase.spd = fk_Vector(0.0, 2.0, 0.0);
			}
		}
		break;

	case ROCKING_THROW:
		if(DB->modelDB.isMotionFinished( "rocking", motionStatus) )
		{
			enemyAI = 0;
			if(gameLevel < 3 ) 
			{
				motionStatus = ROCKING_STAND;
			}
			else
			{
				motionStatus = ROCKING_JUMP;
				movingBase.spd = fk_Vector(0.0, 2.0, 0.0);
			}
		}
		break;
	case ROCKING_RUSH:
		statusBase.anima = 0.0;
		if(DB->modelDB.isMotionFinished( "rocking", motionStatus) )
		{	
			enemyAI = 0;
			if(gameLevel < 3 ) 
			{
				motionStatus = ROCKING_STAND;
			}
			else 
			{
				motionStatus = ROCKING_JUMP;
				movingBase.spd = fk_Vector(0.0, 2.0, 0.0);
			}
		}
		break;


	case ROCKING_DEAD_START:
		if(hitBlock == false )
		{
			movingBase.spd = fk_Vector(0.0, -2.0, 0.0);
		}
		
		if(DB->modelDB.isMotionFinished( "rocking", motionStatus) )
		{
			motionStatus = ROCKING_DEAD;
		}
		break;

	case ROCKING_DEAD:

		break;

	default :
		break;
	}
}

//Aj}Q[W̑
void CRocking::plusAnimaGauge(double plusNum)
{
	statusBase.anima += plusNum;
	if(statusBase.anima >= 1.0 )
	{
		statusBase.anima = 1.0;
	}
}

//bV̓蔻XV
void CRocking::updateRushBlock(CDatabase *DB)
{
	if(motionStatus == ROCKING_RUSH)
	{
		rushModel.glMoveTo(rockingModel.getPosition() );
		rushModel.glAngle(rockingModel.getAngle() );
		rushModel.loTranslate(0.0, 0.0, 80.0 );
		if(DB->modelDB.getNowFrame("rocking", ROCKING_RUSH ) > 30 && DB->modelDB.getNowFrame("rocking", ROCKING_RUSH ) %5 == 0 )
		{
			rushHitFlag = true;
		}
		if(DB->modelDB.getNowFrame("rocking", ROCKING_RUSH ) > 60 )
		{
			rushHitFlag = false;
		}
	}
	return;
}

void CRocking::actShockwave(CDatabase *DB)
{
	for(int i=0; i< shockwaveNum; i++ )
	{
		for(int j = 1; j < shockwave_wObj[i].getObjectNum(); j++) { // base΂̂1
			shockwave_wObj[i].getObjectModel(j)->getMaterial()->setAlpha(1.0);
		}
		for(int j = 1; j < shockwave_hObj[i].getObjectNum(); j++) { // base΂̂1
			shockwave_hObj[i].getObjectModel(j)->getMaterial()->setAlpha(1.0);
		}

		shockwaveModel[i].glMoveTo(rockingModel.getPosition() +fk_Vector(0.0, -30.0, 0.0));
		switch(attackPattern)
		{
		case 0:
			shockwave_wObj[i].entryScene(DB->systemDB.getScene() );
			shockwave[i].setBlockSize(60.0, 10.0, 25.0);
			shockwaveOBB[i].setBlockSize(60.0, 10.0, 25.0);
			shockwaveModel[i].loTranslate(0.0, -20.0, 0.0);
			break;

		case 1:
			shockwave_hObj[i].entryScene(DB->systemDB.getScene() );
			shockwave[i].setBlockSize(10.0, 60.0, 15.0);
			shockwaveOBB[i].setBlockSize(10.0, 60.0, 15.0);
			shockwaveModel[i].loTranslate(0.0, 10.0, 0.0);
			break;

		case 2:
		if( i %2 == 1)
		{
			shockwave[i].setBlockSize(60.0, 10.0, 25.0);
			shockwaveOBB[i].setBlockSize(60.0, 10.0, 25.0);
			shockwave_wObj[i].entryScene(DB->systemDB.getScene());
			shockwaveModel[i].loTranslate(0.0, -20.0, 0.0);
		}
		else
		{
			shockwave[i].setBlockSize(10.0, 60.0, 15.0);
			shockwaveOBB[i].setBlockSize(10.0, 60.0, 15.0);
			shockwave_hObj[i].entryScene(DB->systemDB.getScene());
			shockwaveModel[i].loTranslate(0.0, 10.0, 0.0);
		}
			break;

		default:
			break;
		}

		if( i == 0 )
		{
			shockwaveModel[i].loFocus(0, 0, 1);
			shockwaveModel[i].loTranslate(0.0, 0.0, -30.0);
		}
		else 
		{
			shockwaveModel[i].glVec(shockwaveModel[i-1].getVec());
			shockwaveModel[i].loFocus(-0.37, 0.0, -1.0);
			shockwaveModel[i].loTranslate(0.0, 0.0, -30.0);
		}
		shockwaveHitFlag[i] = true;
		shockwaveDistance[i] = 0;
	}
}

void CRocking::updateShockwave(CDatabase *DB)
{
	for(int i=0; i<shockwaveNum; i++ )
	{
		if(shockwaveHitFlag[i] == true )
		{
			shockwaveModel[i].loTranslate(0, 0, -3.0);
			shockwaveDistance[i] ++;
			if(shockwaveDistance[i] > 180 )
			{
				for(int j = 1; j < shockwave_wObj[i].getObjectNum(); j++) { // base΂̂1
				shockwave_wObj[i].getObjectModel(j)->getMaterial()->setAlpha(1.0-((shockwaveDistance[i] -180) * 0.05));
				}
				for(int j = 1; j < shockwave_hObj[i].getObjectNum(); j++) { // base΂̂1
				shockwave_hObj[i].getObjectModel(j)->getMaterial()->setAlpha(1.0-((shockwaveDistance[i] -180) * 0.05));
				}
			}
			if(shockwaveDistance[i] > 200 )
			{
				shockwaveHitFlag[i] = false;
				shockwaveDistance[i] = 0;
				shockwave_wObj[i].removeScene(DB->systemDB.getScene() );
				shockwave_hObj[i].removeScene(DB->systemDB.getScene() );
			}
		}
	}	
}

void CRocking::removeShockwave(CDatabase *DB, int shockwaveID)
{
	shockwaveHitFlag[shockwaveID] = false;
	shockwaveDistance[shockwaveID] = 0;
	shockwave_wObj[shockwaveID].removeScene(DB->systemDB.getScene() );
	shockwave_hObj[shockwaveID].removeScene(DB->systemDB.getScene() );
}

void CRocking::deleteModel(CDatabase *DB)
{
	DB->modelDB.deleteModel( "rocking" );
	DB->systemDB.getScene()->removeModel(&parentLiftBlockModel);
	DB->systemDB.getScene()->removeModel(&rushModel);
	for(int i=0; i<6; i++ )
	{
		DB->systemDB.getScene()->removeModel(&liftBlockModel[i]);
	}
	for(int i=0; i<shockwaveNum; i++ )
	{
		DB->systemDB.getScene()->removeModel(&shockwaveModel[i]);
	}
}

void CRocking::moveLimit()
{
	if(rockingModel.getPosition().x > 250 )
	{
		rockingModel.glMoveTo(250, rockingModel.getPosition().y, rockingModel.getPosition().z );
	}
	if(rockingModel.getPosition().x < -150 )
	{
		rockingModel.glMoveTo(-150, rockingModel.getPosition().y, rockingModel.getPosition().z );
	}
	if(rockingModel.getPosition().z > 250 )
	{
		rockingModel.glMoveTo(rockingModel.getPosition().x, rockingModel.getPosition().y, 250 );
	}
	if(rockingModel.getPosition().z < -150 )
	{
		rockingModel.glMoveTo(rockingModel.getPosition().x, rockingModel.getPosition().y, -150 );
	}
}

// fobOF蔻`
void CRocking::debugDraw(fk_Scene *argScene)
{
	if(isDebug == false)
	{
		argScene->entryModel( &rushModel );
		isDebug = true;
	}
	else
	{
		argScene->removeModel( &rushModel );
		isDebug = false;
	}
}

//fobO
void CRocking::debug()
{
	fk_Window::printf("motionStatus = %d", motionStatus);
}