//---------------------------------------------------
// bNLO
//---------------------------------------------------


#pragma once

#include "common.h"
#include "database.h"

class CRocking
{

private :
	fk_Block		rocking;
	fk_Model		rockingModel;

	fk_Model	parentLiftBlockModel;	//グubN]p̐ef
	fk_Block	liftBlock[6];			//グubN	
	fk_Model	liftBlockModel[6];

	struct StatusBase {
	int lifeMax;
	int life;
	int stock;
	double anima;
	int combo;
	int inv;
	};

	StatusBase statusBase;

	unsigned int isLiftBlockID[6];

	struct MovingBase{
		//ړA@Ŏgϐ
	fk_Vector pos;
	fk_Vector		spd, acc, view, norm, back, refV;
	fk_Vector		vec;

	fk_Vector moveVec;
	};

	MovingBase movingBase;
	
	enum MotionStatus
	{
	ROCKING_STOP = -1,
	ROCKING_STAND,		//0 ʏ헧
	ROCKING_JUMP_START,	//1 Wvn
	ROCKING_JUMP,		//2 Wv
	ROCKING_MOVE,		//3 ړi󒆁j
	ROCKING_FALL_START, //4 n
	ROCKING_FALL,		//5 
	ROCKING_LANDING,	//6 n
	ROCKING_LIFT,		//7 ꎝグ
	ROCKING_THROW,		//8 ꓊
	ROCKING_RUSH,		//9 bV
	ROCKING_DEAD_START,	//10 Ɏn
	ROCKING_DEAD,		//11 S
	};

	MotionStatus motionStatus;


	int gameLevel;
	int	enemyAI;
	int	actCount;
	int	attackPattern;
	bool hitBlock;

	fk_Block		rush;
	fk_Model		rushModel;
	fkut_OBB		rushOBB;

	bool rushHitFlag;

	static const int shockwaveNum = 18;//Ռg̍ő吔
	fk_Block		shockwave[shockwaveNum];
	fk_Model		shockwaveModel[shockwaveNum];
	fkut_OBB		shockwaveOBB[shockwaveNum];
	CMotionCharactor shockwave_wObj[shockwaveNum];
	CMotionCharactor shockwave_hObj[shockwaveNum];

	bool shockwaveHitFlag[shockwaveNum];
	int shockwaveDistance[shockwaveNum];

	bool isDebug;

public :
	CRocking();
	~CRocking();

	void init();

	void loadModel(CDatabase *DB);
	void updateModel(CDatabase *DB);

	void setPos(fk_Vector pos);		//ʒu
	fk_Vector getPos();						//ʒuW擾
	fk_Vector * getPSpd();						//x|C^擾
	fk_Model * getPModel();
	fkut_OBB * getPRushOBB();
	fkut_OBB * getPShockwaveOBB(int shockwaveID);
	void setRushHitFlag(bool hitFlag);
	bool getRushHitFlag();
	int getShockwaveNum();
	void setShockwaveHitFlag(int shockwaveID, bool hitFlag);
	bool getShockwaveHitFlag(int shockwaveID);
	CRocking::MotionStatus getMotionStatus(); 
	CRocking::StatusBase getStatusBase();
		
	void setView(fk_Vector cameraVec);		//is菈
	void initSpd();							//n㎞͓x^A󒆂ł͉x

	void moveAction(int directNum);	//ړ̍siL[{[ĥ݁H
	void normSpd();					//Xs[hʏ퉻̒l̐ݒ

	void translatePlayer(CDatabase *DB);				// x𑀍샂fɉĎۂɓ

	void entryLiftBlock(fk_Scene *argScene, unsigned int blockID);
	unsigned int removeLiftBlock(fk_Scene *argScene);
	void moveLiftBlock();

	void focusToPlayer(fk_Vector pos);

	void setDamage(int damage, int inv);
	void updateInv();

	void setHitBlock(bool hitFlag);
	void actAI(CDatabase *DB, fk_Vector pos);

	void plusAnimaGauge(double plusNum);
	void updateRushBlock(CDatabase *DB);

	void actShockwave(CDatabase *DB);
	void updateShockwave(CDatabase *DB);
	void removeShockwave(CDatabase *DB, int shockwaveID);

	void deleteModel(CDatabase *DB);

	void moveLimit();

	void debugDraw(fk_Scene *argScene);
	void debug();
};

