#include "common.h"

#include "sound.h"

CSound::CSound(void)
{
};

CSound::~CSound(void)
{
};

void CSound::init(CDatabase *DB)
{
	isPlayMainBGM = false;
	isPlayRockingBGM = false;
	isPlayBontaBGM = false;

	DB->soundDB.loadBGM( "mainBGM", "dat/bgm/INNOCENT_FLIER.ogg");
	DB->soundDB.loadBGM( "bontaBGM", "dat/bgm/rival.ogg");
	DB->soundDB.loadBGM( "rockingBGM", "dat/bgm/GET_OVER_THE_WALL!!.ogg");
	DB->soundDB.loadBGM( "battleBGM", "dat/bgm/PV.ogg");
	DB->soundDB.loadBGM( "editorBGM", "dat/bgm/battle2.ogg");

	DB->soundDB.loadSE( "selectSE", "dat/se/tm2_pon001.wav" );
	DB->soundDB.loadSE( "jumpSE", "dat/se/arrow02.wav" );
	DB->soundDB.loadSE( "damageSE", "dat/se/voice022.wav" );
	DB->soundDB.loadSE( "liftSE", "dat/se/power05.wav" );
	DB->soundDB.loadSE( "fallSE", "dat/se/fall.wav" );

	DB->soundDB.loadSE( "slashSE", "dat/se/tm2_slash000.wav" );
	DB->soundDB.loadSE( "throwSE", "dat/se/tm2_gun000.wav" );

	DB->soundDB.loadSE( "summonAnimaSE", "dat/se/tm2_hit002.wav" );
	DB->soundDB.loadSE( "animaThrowSE", "dat/se/tm2_gun000.wav" );
	DB->soundDB.loadSE( "animaRushSE", "dat/se/tm2_hit004.wav" );
	DB->soundDB.loadSE( "animaRepairSE", "dat/se/tm2_power000.wav" );
	DB->soundDB.loadSE( "animaCureSE", "dat/se/tm2_power001.wav" );

	DB->soundDB.loadSE( "deathSE", "dat/se/tm2_death000.wav" );
	DB->soundDB.loadSE( "enemyDamageSE", "dat/se/tm2_bom001.wav" );
	DB->soundDB.loadSE( "landingSE", "dat/se/bigshot1.wav" );
	DB->soundDB.loadSE( "enemyDeathSE", "dat/se/bigshot4.wav" );

	DB->soundDB.loadSE( "gaugeFullSE", "dat/se/tm2_metalhit001.wav" );
};

//CBGMĐ
void CSound::playMainBGM(CDatabase *DB)
{
	DB->soundDB.playBGM("mainBGM");
	isPlayMainBGM = true;
}

//CBGM~
void CSound::stopMainBGM(CDatabase *DB)
{
	if(isPlayMainBGM = true )
	{
		DB->soundDB.stopBGM("mainBGM");
		isPlayMainBGM = false;
	}
}

bool CSound::getMainBGMStatus()
{
	return isPlayMainBGM;
}

//bNLOBGMĐ
void CSound::playRockingBGM(CDatabase *DB)
{
	DB->soundDB.playBGM("rockingBGM");
	isPlayRockingBGM = true;
}

//bNLOBGM~
void CSound::stopRockingBGM(CDatabase *DB)
{
	if(isPlayRockingBGM = true )
	{
		DB->soundDB.stopBGM("rockingBGM");
		isPlayRockingBGM = false;
	}
}

bool CSound::getRockingBGMStatus()
{
	return isPlayRockingBGM;
}

//CoBGMĐ
void CSound::playBontaBGM(CDatabase *DB)
{
	DB->soundDB.playBGM("bontaBGM");
	isPlayBontaBGM = true;
}

//CoBGM~
void CSound::stopBontaBGM(CDatabase *DB)
{
	if(isPlayBontaBGM = true )
	{
		DB->soundDB.stopBGM("bontaBGM");
		isPlayBontaBGM = false;
	}
}

bool CSound::getBontaBGMStatus()
{
	return isPlayBontaBGM;
}

//BGMĐ
void CSound::playBattleBGM(CDatabase *DB)
{
	DB->soundDB.playBGM("battleBGM");
	isPlayBattleBGM = true;
}

//BGM~
void CSound::stopBattleBGM(CDatabase *DB)
{
	if(isPlayBattleBGM = true )
	{
		DB->soundDB.stopBGM("battleBGM");
		isPlayBattleBGM = false;
	}
}

bool CSound::getBattleBGMStatus()
{
	return isPlayBattleBGM;
}



//J[\ZNgSEĐ
void CSound::playSelectSE(CDatabase *DB)
{
	DB->soundDB.playSE("selectSE");
}

//WvSEĐ
void CSound::playJumpSE(CDatabase *DB)
{
	DB->soundDB.playSE("jumpSE");
}

//_[WSEĐ
void CSound::playDamageSE(CDatabase *DB)
{
	DB->soundDB.playSE("damageSE");
}

//ubNグSEĐ
void CSound::playLiftSE(CDatabase *DB)
{
	DB->soundDB.playSE("liftSE");
}

//SEĐ
void CSound::playFallSE(CDatabase *DB)
{
	DB->soundDB.playSE("fallSE");
}

//ߐڍUSEĐ
void CSound::playSlashSE(CDatabase *DB)
{
	DB->soundDB.playSE("slashSE");
}

//SEĐ
void CSound::playThrowSE(CDatabase *DB)
{
	DB->soundDB.playSE("throwSE");
}

//Aj}SEĐ
void CSound::playSummonAnimaSE(CDatabase *DB)
{
	DB->soundDB.playSE("summonAnimaSE");
}

//Aj}X[SEĐ
void CSound::playAnimaThrowSE(CDatabase *DB)
{
	DB->soundDB.playSE("animaThrowSE");
}

//Aj}bVSEĐ
void CSound::playAnimaRushSE(CDatabase *DB)
{
	DB->soundDB.playSE("animaRushSE");
}

//Aj}yASEĐ
void CSound::playAnimaRepairSE(CDatabase *DB)
{
	DB->soundDB.playSE("animaRepairSE");
}

//Aj}LASEĐ
void CSound::playAnimaCureSE(CDatabase *DB)
{
	DB->soundDB.playSE("animaCureSE");
}

//vC[SSEĐ
void CSound::playPlayerDeathSE(CDatabase *DB)
{
	DB->soundDB.playSE("deathSE");
}

//G_[WSEĐ
void CSound::playEnemyDamageSE(CDatabase *DB)
{
	DB->soundDB.playSE("enemyDamageSE");
}

//GnSEĐ
void CSound::playEnemyLandingSE(CDatabase *DB)
{
	DB->soundDB.playSE("landingSE");
}

//GSSEĐ
void CSound::playEnemyDeathSE(CDatabase *DB)
{
	DB->soundDB.playSE("enemyDeathSE");
}

//Q[Wő厞SEĐ
void CSound::playGaugeFullSE(CDatabase *DB)
{
	DB->soundDB.playSE("gaugeFullSE");
}

void CSound::deleteSound(CDatabase *DB)
{
	DB->soundDB.deleteAll();
}

//fobO
void CSound::debug(CDatabase *DB)
{
	return;
}