//---------------------------------------------------
// ֌Wf[^x[X
//---------------------------------------------------

#include "soundDB.h"

CSoundDB::CSoundDB()
{
	bgmVol = 100 ;
	seVol = 100 ;
}

CSoundDB::~CSoundDB()
{
	deleteAll();
}

/*
 {[ύXi-1ŖύXj
 */
void CSoundDB::changeVolume( int bgmVolume , int seVolume )
{
	if( bgmVolume != -1 )
	{
		bgmVol = bgmVolume ;
	}
	if( seVolume != -1 )
	{
		seVol = seVolume ;
	}
	for( bgmIte = bgm.begin() ; bgmIte != bgm.end() ; bgmIte ++ )
	{
		(*bgmIte).second->setGain( bgmVol/100.0 );
	}
	for( seIte = se.begin() ; seIte != se.end() ; seIte ++ )
	{
		(*seIte).second->setGain( seVol/100.0 );
	}
}

/*
 BGM[h
 */
void CSoundDB::loadBGM( std::string name , std::string pass )
{
	if( findBGM( name ) )
	{
		return ;
	}
	bgm.insert( std::make_pair( name , new fk_AudioStream() ) );
	bgmIte = bgm.find( name );
	if( !(*bgmIte).second->open( pass ) )
	{
		fl_alert( "read error [%s]" , pass.c_str() );
		deleteBGM( name );
		return ;
	}
	(*bgmIte).second->setGain( bgmVol/100.0 );
	(*bgmIte).second->setLoopMode( true );
}

/*
 SE[h
 */
void CSoundDB::loadSE( std::string name , std::string pass )
{
	if( findSE( name ) )
	{
		return ;
	}
	se.insert( std::make_pair( name , new fk_AudioWavBuffer() ) );
	seIte = se.find( name );
	if( !(*seIte).second->open( pass ) )
	{
		fl_alert( "read error [%s]" , pass.c_str() );
		deleteSE( name );
		return ;
	}
	(*seIte).second->setGain( seVol/100.0 );
}

/*
 BGMĐ
 */
void CSoundDB::playBGM( std::string name )
{
	if( findBGM( name ) )
	{
		(*bgmIte).second->play();
	}
}

/*
 SEĐ
 */
void CSoundDB::playSE( std::string name )
{
	if( findSE( name ) )
	{
		stopSE( name );
		(*seIte).second->play();
	}
}

/*
 BGM~iFɒ~Ăꍇɂ͌Ă΂Ȃj
 */
void CSoundDB::stopBGM( std::string name )
{
	if( findBGM( name ) )
	{
		(*bgmIte).second->pause();
		(*bgmIte).second->seek( 0.0 );	// 2ȏĂԂƃoO
	}
}

/*
 SE~iFɒ~Ăꍇɂ͌Ă΂Ȃj
 */
void CSoundDB::stopSE( std::string name )
{
	if( findSE( name ) )
	{
		(*seIte).second->pause();
		(*seIte).second->seek( 0.0 );
	}
}

/*
 SBGM&SE~
 */
void CSoundDB::stopAll()
{
	for( bgmIte = bgm.begin() ; bgmIte != bgm.end() ; bgmIte ++ )
	{
		(*bgmIte).second->pause();
		(*bgmIte).second->seek( 0.0 );
	}
	for( seIte = se.begin() ; seIte != se.end() ; seIte ++ )
	{
		(*seIte).second->pause();
		(*seIte).second->seek( 0.0 );
	}
}

/*
 BGMV[Nʒuݒ
 */
void CSoundDB::seekBGM( std::string name , double seekSecond )
{
	if( findBGM( name ) )
	{
		(*bgmIte).second->seek( seekSecond );
	}
}

/*
 SEV[Nʒuݒ
 */
void CSoundDB::seekSE( std::string name , double seekSecond )
{
	if( findSE( name ) )
	{
		(*seIte).second->seek( seekSecond );
	}
}

/*
 BGM폜
 */
void CSoundDB::deleteBGM( std::string name )
{
	if( findBGM( name ) )
	{
		(*bgmIte).second->stop();
		delete (*bgmIte).second ;
		bgm.erase( name );
	}
}

/*
 SE폜
 */
void CSoundDB::deleteSE( std::string name )
{
	if( findSE( name ) )
	{
		(*seIte).second->stop();
		delete (*seIte).second ;
		se.erase( name );
	}
}

/*
 SBGM&SE폜
 */
void CSoundDB::deleteAll()
{
	for( bgmIte = bgm.begin() ; bgmIte != bgm.end() ; bgmIte ++ )
	{
		(*bgmIte).second->stop();
		delete (*bgmIte).second ;
	}
	for( seIte = se.begin() ; seIte != se.end() ; seIte ++ )
	{
		(*seIte).second->stop();
		delete (*seIte).second ;
	}
	bgm.clear();
	se.clear();
}

/*
 w肳ꂽOBGMtrue
 */
bool CSoundDB::findBGM( std::string name )
{
	bgmIte = bgm.find( name );
	return ( bgmIte != bgm.end() ) ;
}

/*
 w肳ꂽOSEtrue
 */
bool CSoundDB::findSE( std::string name )
{
	seIte = se.find( name );
	return ( seIte != se.end() ) ;
}
