//---------------------------------------------------
// Xe[WJ
//---------------------------------------------------

#include "stageCamera.h"

CStageCamera::CStageCamera()
{
	angle = height = 0.0 ;
	pos.init();
	posNow.init();
	focus.init();
	focusNow.init();
}

CStageCamera::~CStageCamera()
{
}

/*
 J̃AhXZbg
 */
void CStageCamera::setAddress( fk_Model *c )
{
	camera = c ;
}

/*
 VO[h̃J̏XV
 */
void CStageCamera::updateSingle( fk_Vector playerPos )
{
	if( height < 0.0 )
	{
		height = 0.0 ;
	}
	if( height > 75.0 )
	{
		height = 75.0 ;
	}
	pos = playerPos + fk_Vector( 300.0*sin( angle ) , 150.0-height , -300.0*cos( angle ) );
	posNow.x += (pos.x-posNow.x)/10.0 ;
	posNow.y += (pos.y-posNow.y)/5.0 ;
	posNow.z += (pos.z-posNow.z)/10.0 ;
	focus = playerPos + fk_Vector( -100.0*sin( angle ) , 0.0+height , 100.0*cos( angle ) );
	focusNow.x += (focus.x-focusNow.x)/10.0 ;
	focusNow.y += (focus.y-focusNow.y)/5.0 ;
	focusNow.z += (focus.z-focusNow.z)/10.0 ;
	camera->glMoveTo( posNow );
	camera->glFocus( focusNow );
}

/*
 VS[h̃J̏XV
 */
void CStageCamera::updateVS( fk_Vector p1Pos , fk_Vector p2Pos )
{
	double		dist = (p1Pos-p2Pos).dist() ;
	fk_Model	dummyModel ;

	dummyModel.glMoveTo( p1Pos );
	dummyModel.glFocus( p2Pos );
	dummyModel.loTranslate( 0.0 , 0.0 , -dist/2.0 );
	focus = dummyModel.getPosition();
	if( dist < 200.0 ) dist = 200.0 ;
	dummyModel.loFocus( 1.0 , 1.0 , 0.0 );
	dummyModel.loTranslate( 0.0 , 0.0 , -dist*2.0 );
	dummyModel.glMoveTo( dummyModel.getPosition().x , (p1Pos.y+p2Pos.y)/2.0+(dist/2.0) , dummyModel.getPosition().z );
	pos = dummyModel.getPosition();
	posNow.x += (pos.x-posNow.x)/20.0 ;
	posNow.y += (pos.y-posNow.y)/10.0 ;
	posNow.z += (pos.z-posNow.z)/20.0 ;
	focusNow.x += (focus.x-focusNow.x)/20.0 ;
	focusNow.y += (focus.y-focusNow.y)/10.0 ;
	focusNow.z += (focus.z-focusNow.z)/20.0 ;
	camera->glMoveTo( posNow );
	camera->glFocus( focusNow );
}

/*
 J猩vC[̊pxɐݒ肷
 */
void CStageCamera::setFocusToEnemy( fk_Vector playerPos , fk_Vector enemyPos )
{
	angle = atan2( playerPos.z-enemyPos.z , playerPos.x-enemyPos.x )+(90.0*PI/180.0) ;
	height = enemyPos.y-playerPos.y ;
}

/*
 J猩vC[̊pxɉZ
 */
void CStageCamera::addAngle( double a )
{
	angle += a ;
}

/*
 J̍ɉZ
 */
void CStageCamera::addHeight( double h )
{
	height += h ;
}

/*
 J猩vC[̊pxݒ肷
 */
void CStageCamera::setAngle( double a )
{
	angle = a ;
}

/*
 J̍ݒ肷
 */
void CStageCamera::setHeight( double h )
{
	height = h ;
}

/*
 J猩vC[̊px擾
 */
double CStageCamera::getAngle()
{
	return angle ;
}

/*
 J̍擾
 */
double CStageCamera::getHeight()
{
	return height ;
}
