//---------------------------------------------------
// Xe[WGfB^
//---------------------------------------------------

#include "stageEditor.h"

CStageEditor::CStageEditor()
{
	x = y = z = menuSelecter = fileNum = 1 ;
	settingFlag = 0 ;
	isMenu = false ;
	b.makeBlock( 20.0 , 20.0 , 20.0 );
	f.makeBlock( 20.0*FIELD_X_MAX , 20.0*FIELD_Y_MAX , 20.0*FIELD_Z_MAX );
	cursolBlock.setShape( &b );
	cursolBlock.setDrawMode( FK_LINEMODE );
	cursolBlock.setWidth( 2.0 );
	frameBlock.setShape( &f );
	frameBlock.setDrawMode( FK_LINEMODE );
	frameBlock.setWidth( 4.0 );
	normal.setDiffuse( 0.0 , 1.0 , 0.0 );
	alpha.setDiffuse( 0.0 , 1.0 , 0.0 );
	alpha.setAlpha( 0.3 );
	p[0].setDiffuse( 1.0 , 0.0 , 0.0 );
	p[0].setAlpha( 0.4 );
	p[1].setDiffuse( 0.0 , 0.0 , 1.0 );
	p[1].setAlpha( 0.4 );
	for( int i=0 ; i<2 ; i++ )
	{
		pModel[i].x = pModel[i].y = pModel[i].z = -9999 ;
		pModel[i].model = new fk_Model ;
		pModel[i].model->setShape( &b );
		pModel[i].model->setMaterial( p[i] );
		pModel[i].model->glMoveTo( (pModel[i].x-((double)FIELD_X_MAX-1.0)/2-1)*20.0 , (pModel[i].y-1)*20.0 , (pModel[i].z-((double)FIELD_Z_MAX-1.0)/2-1)*20.0 );
	}
}

CStageEditor::~CStageEditor()
{
	deleteField();
	delete pModel[0].model ;
	delete pModel[1].model ;
	DB->systemDB.getScene()->removeModel( &cursolBlock );
	DB->systemDB.getScene()->removeModel( &frameBlock );
	DB->systemDB.getScene()->removeModel( pModel[0].model );
	DB->systemDB.getScene()->removeModel( pModel[1].model );
	DB->graphDB.deleteImage( "menu" );
	DB->graphDB.deleteImage( "cursol" );
	DB->graphDB.deleteImage( "number" );
	DB->soundDB.deleteBGM( "battle2" );
	for( int i=0 ; i<6 ; i++ )
	{
		DB->systemDB.getScene()->removeModel( &bgModel[i] );
	}
}

void CStageEditor::init()
{
	//loadBG();
	DB->systemDB.getCamera()->glMoveTo( cursolBlock.getPosition() + fk_Vector( 0.0 , 250.0 , -125.0 ) );
	DB->systemDB.getCamera()->glFocus( cursolBlock.getPosition() );
	DB->systemDB.getScene()->entryModel( &cursolBlock );
	DB->systemDB.getScene()->entryModel( &frameBlock );
	DB->systemDB.getScene()->entryModel( pModel[0].model );
	DB->systemDB.getScene()->entryModel( pModel[1].model );
	DB->graphDB.setImage( "menu" , "dat/graph/editor/menu.png" );
	DB->graphDB.removeImage( "menu" );
	DB->graphDB.setImage( "cursol" , "dat/graph/editor/cursol.png" );
	DB->graphDB.removeImage( "cursol" );
	DB->graphDB.setImage( "number" , "dat/graph/number.png" );
	DB->graphDB.removeImage( "number" );
	DB->soundDB.loadBGM( "battle2" , "dat/bgm/battle2.ogg" );
}

bool CStageEditor::onPeriod()
{
	if( !isMenu )
	{	// j[JĂȂ
		if( input->checkDown( INPUT_DOWN ) )
		{	// O
			if( z != 1 )	z -- ;
		}
		if( input->checkDown( INPUT_UP ) )
		{	// 
			if( z != FIELD_Z_MAX )	z ++ ;
		}
		if( input->checkDown( INPUT_RIGHT ) )
		{	// E
			if( x != 1 )	x -- ;
		}
		if( input->checkDown( INPUT_LEFT ) )
		{	// 
			if( x != FIELD_X_MAX )	x ++ ;
		}
		if( input->checkDown( INPUT_2 ) )
		{	// j[
			menuSelecter = 1 ;
			isMenu = true ;
			settingFlag = 0 ;
			DB->graphDB.entryImage( "menu" );
			DB->graphDB.entryImage( "cursol" );
		}
		if( input->checkDown( INPUT_1 ) )
		{	// ubNzu
			changeBlock( x , y , z );
			entryBlock();
			if( settingFlag != 0 )
			{
				settingFlag = 0 ;
				isMenu = true ;
				DB->graphDB.entryImage( "menu" );
				DB->graphDB.entryImage( "cursol" );
			}
		}
	}
	else
	{	// j[JĂ鎞
		if( menuSelecter <= 9 )
		{
			if( input->checkDown( INPUT_DOWN ) )
			{	// 
				if( menuSelecter != 5 )	menuSelecter ++ ;
			}
			if( input->checkDown( INPUT_UP ) )
			{	// 
				if( menuSelecter != 1 )	menuSelecter -- ;
			}
		}
		else
		{
			if( input->checkDown( INPUT_RIGHT ) )
			{	// t@CԍvX
				if( fileNum != 5 )	fileNum ++ ;
			}
			if( input->checkDown( INPUT_LEFT ) )
			{	// t@Cԍ}CiX
				if( fileNum != 1 )	fileNum -- ;
			}
		}
		if( input->checkDown( INPUT_1 ) )
		{	// 
			switch( menuSelecter )
			{
			case 1:	// P1zu
				settingFlag = 1 ;
				entryBlock();
				DB->graphDB.removeImage( "menu" );
				DB->graphDB.removeImage( "cursol" );
				isMenu = false ;
				break ;
			case 2:	// P2zu
				settingFlag = 2 ;
				entryBlock();
				DB->graphDB.removeImage( "menu" );
				DB->graphDB.removeImage( "cursol" );
				isMenu = false ;
				break ;
			case 3:	// Z[u
				menuSelecter = 30 ;
				DB->graphDB.entryImage( "number" );
				break ;
			case 30: // Z[ũt@CI
				saveEditorFile( fileNum );
				fl_alert( "saved" );
				break ;
			case 4:	// [h
				menuSelecter = 40 ;
				DB->graphDB.entryImage( "number" );
				break ;
			case 40: // [h̃t@CI
				deleteField();
				loadEditorFile( fileNum );
				entryBlock();
				fl_alert( "loaded" );
				break ;
			case 5: // ^Cg֖߂
				*scene = S_TITLE ;
				return true ;
			}
		}
		if( input->checkDown( INPUT_2 ) )
		{
			if( menuSelecter <= 9 )
			{	// j[o
				isMenu = false ;
				DB->graphDB.removeImage( "menu" );
				DB->graphDB.removeImage( "cursol" );
			}
			else
			{	// Z[uE[h̃LZ
				menuSelecter /= 10 ;
				DB->graphDB.removeImage( "number" );
			}
		}
	}
	if( input->checkDown( INPUT_3 ) )
	{	// 
		if( y != 1 )	y -- ;
		entryBlock();
	}
	if( input->checkDown( INPUT_4 ) )
	{	// 
		if( y != FIELD_Y_MAX )	y ++ ;
		entryBlock();
	}

	if( settingFlag != 0 )
	{
		pModel[settingFlag-1].model->glMoveTo( (x-((double)FIELD_X_MAX-1.0)/2-1)*20.0 , (y-1)*20.0 , (z-((double)FIELD_Z_MAX-1.0)/2-1)*20.0 );
	}
	cursolBlock.glMoveTo( (x-((double)FIELD_X_MAX-1.0)/2-1)*20.0 , (y-1)*20.0 , (z-((double)FIELD_Z_MAX-1.0)/2-1)*20.0 );
	frameBlock.glMoveTo( 0.0 , ((FIELD_Y_MAX-1)/2.0)*20.0 , 0.0 );
	DB->systemDB.getCamera()->glMoveTo( cursolBlock.getPosition() + fk_Vector( 0.0 , 250.0 , -125.0 ) );
	DB->systemDB.getCamera()->glFocus( cursolBlock.getPosition() );
	DB->graphDB.setPositionLT( "menu" , -WINDOW_WIDTH/2.0 , WINDOW_HEIGHT/2.0 );
	DB->graphDB.setPositionLT( "cursol" , -WINDOW_WIDTH/2.0+5.0 , WINDOW_HEIGHT/2.0+30.0-62.0*menuSelecter );
	DB->graphDB.setSpriteArea( "number" , fileNum*20.0 , 0.0 , 20.0 , 30.0 );
	DB->graphDB.setPositionLT( "number" , -WINDOW_WIDTH/2.0+200.0 , WINDOW_HEIGHT/2.0+30.0-62.0*(menuSelecter/10) );
	DB->soundDB.playBGM( "battle2" );

	return false ;
}

void CStageEditor::initEditor()
{
	unsigned int	vecSize = block.size();

	for( unsigned int i=0 ; i<vecSize ; i++ )
	{
		DB->systemDB.getScene()->removeModel( block[i]->model );
		delete block[i]->model ;
		delete block[i] ;
	}
	block.clear();
	x = y = z = 1 ;
}

void CStageEditor::changeBlock( int argX , int argY , int argZ )
{
	unsigned int	vecSize = block.size();

	if( settingFlag != 0 )
	{
		pModel[settingFlag-1].x = argX ;
		pModel[settingFlag-1].y = argY ;
		pModel[settingFlag-1].z = argZ ;
		pModel[settingFlag-1].model->glMoveTo( (argX-((double)FIELD_X_MAX-1.0)/2-1)*20.0 , (argY-1)*20.0 , (argZ-((double)FIELD_Z_MAX-1.0)/2-1)*20.0 );
		return ;
	}
	for( unsigned int i=0 ; i<vecSize ; i++ )
	{
		if( block[i]->x == argX && block[i]->y == argY && block[i]->z == argZ )
		{
			DB->systemDB.getScene()->removeModel( block[i]->model );
			delete block[i]->model ;
			block.erase( block.begin()+i );
			return ;
		}
	}
	if( (signed int)block.size() < FIELD_BLOCK_MAX )
	{
		block.push_back( new blockBase );
		block.back()->model = new fk_Model ;
		block.back()->model->setShape( &b );
		block.back()->model->setMaterial( normal );
		block.back()->model->glMoveTo( (argX-((double)FIELD_X_MAX-1.0)/2-1)*20.0 , (argY-1)*20.0 , (argZ-((double)FIELD_Z_MAX-1.0)/2-1)*20.0 );
		block.back()->x = argX ;
		block.back()->y = argY ;
		block.back()->z = argZ ;
		DB->systemDB.getScene()->entryModel( block.back()->model );
	}
}

void CStageEditor::entryBlock()
{
	unsigned int	vecSize = block.size();

	for( unsigned int i=0 ; i<vecSize ; i++ )
	{
		if( block[i]->y == y )
		{
			block[i]->model->setMaterial( normal );
			DB->systemDB.getScene()->entryModel( block[i]->model );
		}
	}
	for( unsigned int i=0 ; i<vecSize ; i++ )
	{
		if( block[i]->y != y )
		{
			block[i]->model->setMaterial( alpha );
			DB->systemDB.getScene()->entryModel( block[i]->model );
		}
	}
}

void CStageEditor::deleteField()
{
	unsigned int	vecSize = block.size();

	for( unsigned int i=0 ; i<vecSize ; i++ )
	{
		DB->systemDB.getScene()->removeModel( block[i]->model );
		delete block[i]->model ;
		delete block[i] ;
	}
	block.clear();
}

void CStageEditor::loadBG()
{
	//if( !bgTex[0].readPNG( "dat/graph/maingame/bg/bg_under.png" ) )	fl_alert( "error read[bg_under.png]" );
	if( !bgTex[0].readPNG( "dat/graph/maingame/bg/bg_side.png" ) )	fl_alert( "error read[bg_under.png]" );
	bgTex[0].setTextureSize( 4096.0 , 4096.0 );
	bgTex[0].setTexRendMode( FK_TEX_REND_NORMAL );
	bgTex[0].setTextureMode( FK_TEX_REPLACE );
	bgModel[0].setShape( &bgTex[0] );
	bgModel[0].glMoveTo( 0.0 , -1010.0 , 0.0 );
	bgModel[0].glFocus( 0.0 , -1025.0 , 0.0 );
	if( !bgTex[5].readPNG( "dat/graph/maingame/bg/bg_over.png" ) )	fl_alert( "error read[bg_over.png]" );
	bgTex[5].setTextureSize( 4096.0 , 4096.0 );
	bgTex[5].setTexRendMode( FK_TEX_REND_NORMAL );
	bgTex[5].setTextureMode( FK_TEX_REPLACE );
	bgModel[5].setShape( &bgTex[5] );
	bgModel[5].glMoveTo( 0.0 , 3060.0 , 0.0 );
	bgModel[5].glFocus( 0.0 , 3080.0 , 0.0 );
	for(int i=1 ; i<5 ; i++)
	{
		if( !bgTex[i].readPNG( "dat/graph/maingame/bg/bg_side.png" ) )
		{
			fl_alert( "error read[bg_side.png]" );
		}
		else
		{
			bgTex[i].setTextureSize( 4096.0 , 4096.0 );
			bgTex[i].setTexRendMode( FK_TEX_REND_SMOOTH );
			bgTex[i].setTextureMode( FK_TEX_REPLACE );
			bgModel[i].setShape( &bgTex[i] );
			if( i == 4 )
			{
				bgModel[1].glMoveTo( 2048.0 , 1024.0 , 0.0 );
				bgModel[2].glMoveTo( 0.0 , 1024.0 , 2048.0 );
				bgModel[3].glMoveTo( -2048.0 , 1024.0 , 0.0 );
				bgModel[4].glMoveTo( 0.0 , 1024.0 , -2048.0 );
				bgModel[1].glFocus( 2050.0 , 1024.0 , 0.0 );
				bgModel[2].glFocus( 0.0 , 1024.0 , 2050.0 );
				bgModel[3].glFocus( -2050.0 , 1024.0 , 0.0 );
				bgModel[4].glFocus( 0.0 , 1024.0 , -2050.0 );
			}
		}
	}

	for(int i =0; i<5; i++ )
	{
		DB->systemDB.getScene()->entryModel( &bgModel[i] );
	}
}

bool CStageEditor::loadEditorFile( int num )
{
	char			fileName[64] ;
	int				txtX , txtY , txtZ ;

	if( !findEditorFile( num ) )
	{
		return false ;
	}
	sprintf_s( fileName , 64 , "StageEditField%d.dat" , num );
	std::ifstream txt( fileName );
	if( txt.fail() )
	{
		return false ;
	}
	txt >> pModel[0].x ;
	txt >> pModel[0].y ;
	txt >> pModel[0].z ;
	settingFlag = 1 ;
	changeBlock( pModel[0].x , pModel[0].y , pModel[0].z );
	txt >> pModel[1].x ;
	txt >> pModel[1].y ;
	txt >> pModel[1].z ;
	settingFlag = 2 ;
	changeBlock( pModel[1].x , pModel[1].y , pModel[1].z );
	settingFlag = 0 ;
	while( !txt.eof() )
	{
		txt >> txtX ;
		txt >> txtY ;
		txt >> txtZ ;
		changeBlock( txtX , txtY , txtZ );
	}
	txt.close();
	return true ;
}

bool CStageEditor::saveEditorFile( int num )
{
	char			fileName[64] ;
	unsigned int	vecSize = block.size();

	sprintf_s( fileName , 64 , "StageEditField%d.dat" , num );
	std::ofstream txt( fileName );
	if( txt.fail() )
	{
		return false ;
	}
	txt << pModel[0].x << " " << pModel[0].y << " " << pModel[0].z << std::endl ;
	txt << pModel[1].x << " " << pModel[1].y << " " << pModel[1].z ;
	for( unsigned int i=0 ; i<vecSize ; i++ )
	{
		txt << std::endl ;
		txt << block[i]->x << " " << block[i]->y << " " << block[i]->z ;
	}
	txt.close();
	return true ;
}

bool CStageEditor::findEditorFile( int num )
{
	char	fileName[64] ;

	sprintf_s( fileName , 64 , "StageEditField%d.dat" , num );
	std::ifstream txt( fileName );
	if( txt.fail() )
	{
		return false ;
	}
	txt.close();
	return true ;
}
