//---------------------------------------------------
// VXef[^x[X
//---------------------------------------------------

#include "systemDB.h"

CSystemDB::CSystemDB()
{
	alphaPoint = 0.0 ;
	beforeTime = 0 ;
	stageNum = 0 ;
	difficulty = 1 ;
}

CSystemDB::~CSystemDB()
{
}

/*
 
 */
void CSystemDB::init( Fl_Window *lw , fk_Window *kw , fk_Scene *s , fk_Model *c )
{
	window = kw ;
	scene = s ;
	camera = c ;
	initCameraPos();
	if( fadeModel.readPNG( "dat/graph/black.png" ) )
	{
		alphaPoint = 0.0 ;
		alphaMat.setAlpha( alphaPoint );
		fadeModel.setMaterial( alphaMat );
		fadeModel.entryFirst( window , scene );
	}
	else
	{
		fl_alert( "read error [dat/graph/black.png]" );
	}
	fullscreen.init( lw , kw );
}

/*
 fk_Window|C^擾
 */
fk_Window* CSystemDB::getWindow()
{
	return window ;
}

/*
 fk_Scene|C^擾
 */
fk_Scene* CSystemDB::getScene()
{
	return scene ;
}

/*
 camera|C^擾
 */
fk_Model* CSystemDB::getCamera()
{
	return camera ;
}

/*
 Jʒuʒuɖ߂
 */
void CSystemDB::initCameraPos()
{
	camera->glMoveTo( 0.0 , 100.0 , 100.0 );
	camera->glFocus( 0.0 , 0.0 , 0.0 );
	camera->glUpvec( 0.0 , 1.0 , 0.0 );
}

/*
 tF[hAEgAtF[hC
 */
void CSystemDB::fade( double addPoint )
{
	alphaPoint += addPoint ;
	if( alphaPoint < 0.0 )
	{
		alphaPoint = 0.0 ;
	}
	else if( alphaPoint > 1.0 )
	{
		alphaPoint = 1.0 ;
	}
	alphaMat.setAlpha( alphaPoint );
	fadeModel.setMaterial( alphaMat );
	scene->entryOverlayModel( &fadeModel );
}

/*
 ʓxitF[h̋j擾
 */
double CSystemDB::getAlphaPoint()
{
	return alphaPoint ;
}

/*
 VO[hAVS[h̃Xe[Wԍݒ肷
 */
void CSystemDB::setStageNum( int num )
{
	stageNum = num ;
}

/*
 VO[hAVS[h̃Xe[Wԍ擾
 */
int CSystemDB::getStageNum()
{
	return stageNum ;
}

/*
 Փxݒ肷
 */
void CSystemDB::setDifficulty( int num )
{
	difficulty = num ;
}

/*
 Փx擾
 */
int CSystemDB::getDifficulty()
{
	return difficulty ;
}

/*
 tXN[
 */
void CSystemDB::fullscreenMode()
{
	fullscreen.changeToFullscreen();
}

/*
 EBhE[h
 */
void CSystemDB::windowMode()
{
	fullscreen.changeToWindow();
}

/*
 Pt[̌oߎԎZo
 */
void CSystemDB::frameTime()
{
	window->printf( "%d\n" , window->getNow() - beforeTime );
	beforeTime = window->getNow();
}
