//---------------------------------------------------
// VXef[^x[X
//---------------------------------------------------

#pragma once

#include "common.h"
#include "../FKUT/Fullscreen.h"

class CSystemDB
{
private:
	fk_Window	*window ;
	fk_Scene	*scene ;
	fk_Model	*camera ;

	double					alphaPoint ;
	fk_Material				alphaMat ;
	fkut_SpriteModel		fadeModel ;
	CFullscreenControler	fullscreen ;
	long					beforeTime ;
	int						stageNum ;
	int						difficulty ;

public:
	CSystemDB();
	~CSystemDB();

	void		init( Fl_Window *lw , fk_Window *kw , fk_Scene *s , fk_Model *c );
	fk_Window*	getWindow();
	fk_Scene*	getScene();
	fk_Model*	getCamera();
	void		initCameraPos();
	void		fade( double addPoint );
	double		getAlphaPoint();
	void		setStageNum( int num );
	int			getStageNum();
	void		setDifficulty( int num );
	int			getDifficulty();
	void		fullscreenMode();
	void		windowMode();
	void		frameTime();

};
