//---------------------------------------------------
// ^Cg
//---------------------------------------------------

#include "title.h"

CTitle::CTitle()
{
	cursorNum = 0 ;
	stageNum = 1 ;
}

CTitle::~CTitle()
{
	DB->graphDB.deleteImage( "titleimage" );
	DB->graphDB.deleteImage( "singlemode" );
	DB->graphDB.deleteImage( "vsmode" );
	DB->graphDB.deleteImage( "option" );
	DB->graphDB.deleteImage( "ranking" );
	DB->graphDB.deleteImage( "endgame" );
	DB->graphDB.deleteImage( "cursor" );
	DB->graphDB.deleteImage( "number" );

	sound.deleteSound(DB);
}

void CTitle::init()
{
	DB->graphDB.setImage( "titleimage", "dat/graph/title/titleimage.png" );
	DB->graphDB.setPositionLT( "titleimage", -WINDOW_WIDTH/2.0, WINDOW_HEIGHT/2.0);
	DB->graphDB.setImage( "singlemode", "dat/graph/title/singlemode.png" );
	DB->graphDB.setPositionLT( "singlemode", -72.5 , -70.0);
	DB->graphDB.setImage( "vsmode", "dat/graph/title/vsmode.png" );
	DB->graphDB.setPositionLT( "vsmode", -72.5 , -100.0);
	DB->graphDB.setImage( "option", "dat/graph/title/option.png" );
	DB->graphDB.setPositionLT( "option", -72.5 , -130.0);
	DB->graphDB.setImage( "ranking", "dat/graph/title/ranking.png" );
	DB->graphDB.setPositionLT( "ranking", -72.5 , -160.0);	
	DB->graphDB.setImage( "endgame", "dat/graph/title/endgame.png" );
	DB->graphDB.setPositionLT( "endgame", -72.5 , -190.0);
	DB->graphDB.setImage( "cursor", "dat/graph/interface/cursor.png" );
	DB->graphDB.setPositionLT( "cursor", -120.0, -70.0);
	DB->graphDB.setImage( "number", "dat/graph/number.png" );
	DB->graphDB.setPositionLT( "number", 0.0, -100.0);
	DB->graphDB.removeImage( "number" );

	sound.init(DB);
	sound.playMainBGM(DB);
}

bool CTitle::onPeriod()
{
	/*
	//vZ
	*/
	if( input->checkDown( INPUT_UP ) )
	{
		cursorNum --;
		sound.playSelectSE(DB);
	}
	if( input->checkDown( INPUT_DOWN ) )
	{
		cursorNum ++;
		sound.playSelectSE(DB);
	}

	if( cursorNum < 0)
	{
		cursorNum = 4;
	}
	if( cursorNum > 4)
	{
		cursorNum = 0;
	}

	if( cursorNum == 1 )
	{
		if( input->checkDown( INPUT_LEFT ) )
		{
			if( stageNum > 1 ) stageNum -- ;
			sound.playSelectSE(DB);
		}
		if( input->checkDown( INPUT_RIGHT ) )
		{
			if( stageNum < 5 ) stageNum ++ ;
			sound.playSelectSE(DB);
		}
	}

	if( input->checkDown( INPUT_4 ) )
	{
		sound.stopMainBGM(DB);
		switch( cursorNum )
		{
		case 0:
			DB->systemDB.setStageNum( 6 );
			*scene = S_SINGLEMODE;
			return true ;
		case 1:
			DB->systemDB.setStageNum( stageNum );
			*scene = S_VSMODE;
			return true ;
		case 2:
			*scene = S_OPTION;
			return true ;
		case 3:
			*scene = S_STAGEEDITOR;
			return true ;
		case 4:
			*scene = S_END;
			return true ;
		}
	}

	

	/*
	//`揈
	*/
	DB->graphDB.setPositionLT( "cursor", -120.0, -70.0 + -(30*cursorNum));
	DB->graphDB.setSpriteArea( "number", 20.0*stageNum , 0.0 , 20.0 , 30.0 );
	if( cursorNum != 1 )
	{
		DB->graphDB.removeImage( "number" );
	}
	else
	{
		DB->graphDB.entryImage( "number" );
	}

	if(sound.getMainBGMStatus() == true )
	{
		sound.playMainBGM(DB);
	}

	return false ;
}
