#include "common.h"

CDraw::CDraw()
{
	if( !titlelogo.readPNG("image/titlelogo.png") )	fl_alert( "error read[titlelogo.png]" );
	if( !gamestart.readPNG("image/gamestart.png") )	fl_alert( "error read[gamestart.png]" );
	if( !quit.readPNG("image/quit.png") )	fl_alert( "error read[quit.png]" );
	if( !cursol.readPNG("image/cursol.png") )	fl_alert( "error read[cursol.png]" );
	
	for(int j = 0; j < 8; j++) 
	{
			if( !number[0][j].readPNG("image/0.png") )	fl_alert( "error read[0.png]" );
			if( !number[1][j].readPNG("image/1.png") )	fl_alert( "error read[1.png]" );
			if( !number[2][j].readPNG("image/2.png") )	fl_alert( "error read[2.png]" );
			if( !number[3][j].readPNG("image/3.png") )	fl_alert( "error read[3.png]" );
			if( !number[4][j].readPNG("image/4.png") )	fl_alert( "error read[4.png]" );
			if( !number[5][j].readPNG("image/5.png") )	fl_alert( "error read[5.png]" );
			if( !number[6][j].readPNG("image/6.png") )	fl_alert( "error read[6.png]" );
			if( !number[7][j].readPNG("image/7.png") )	fl_alert( "error read[7.png]" );
			if( !number[8][j].readPNG("image/8.png") )	fl_alert( "error read[8.png]" );
			if( !number[9][j].readPNG("image/9.png") )	fl_alert( "error read[9.png]" );
	}
	
	for(int i=0 ; i<2 ; i++)
	{
		if( !coron[i].readPNG("image/coron.png") )	fl_alert( "error read[coron.png]" );
	}
	
	if( !p_life.readPNG("image/p_life.png") )	fl_alert( "error read[p_life.png]" );
	if( !e_life.readPNG("image/e_life.png") )	fl_alert( "error read[e_life.png]" );

	if( !combo.readPNG("image/combo.png") )	fl_alert( "error read[combo.png]" );

	if( !gameover.readPNG("image/gameover.png") )	fl_alert( "error read[gameover.png]" );
	
	if( !stageclear.readPNG("image/stageclear.png") )	fl_alert( "error read[stageclear.png]" );
	if( !cleartime.readPNG("image/cleartime.png") )	fl_alert( "error read[cleartime.png]" );

	if( !bg_black.readPNG("image/bg_black.png") )	fl_alert( "error read[bg_black.png]" );


	minute = 0;
	prevPHP = 1.0;
	nowPHP = 0;
	prevEHP = 1.0;
	nowEHP = 0;

	prevCombo = false;
	moveCombo = 0;
	posXCombo = 0;

	return;
}

CDraw::~CDraw()
{
}

void CDraw::entryScene(fk_Scene *argScene, fk_Window *window)
{
	argScene->entryOverlayModel(&titlelogo);
	titlelogo.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&gamestart);
	gamestart.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&quit);
	quit.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&cursol);
	cursol.MakePixelBase(window, argScene);

	for(int i = 0; i < 10; i++)
	{
		for(int j = 0; j < 8; j++) 
		{
			argScene->entryOverlayModel(&number[i][j]);
			number[i][j].MakePixelBase(window, argScene);
		}
	}

	for(int i = 0; i < 2 ; i++ )
	{
		argScene->entryOverlayModel(&coron[i]);
		coron[i].MakePixelBase(window, argScene);
	}

	argScene->entryOverlayModel(&p_life);
	p_life.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&e_life);
	e_life.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&combo);
	combo.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&gameover);
	gameover.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&stageclear);
	stageclear.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&cleartime);
	cleartime.MakePixelBase(window, argScene);		

	argScene->entryOverlayModel(&bg_black);
	bg_black.MakePixelBase(window, argScene);

	return;
}


void CDraw::removeScene(fk_Scene *argScene)
{
	argScene->removeOverlayModel(&titlelogo);
	argScene->removeOverlayModel(&gamestart);
	argScene->removeOverlayModel(&quit);
	argScene->removeOverlayModel(&cursol);

	for(int i = 0; i < 10; i++)
	{
		for(int j = 0; j < 8; j++) 
		{
			argScene->removeOverlayModel(&number[i][j]);
		}
	}

	for(int i = 0; i < 2 ; i++ )
	{
		argScene->removeOverlayModel(&coron[i]);
	}

	argScene->removeOverlayModel(&combo);

	argScene->removeOverlayModel(&gameover);

	argScene->removeOverlayModel(&stageclear);
	argScene->removeOverlayModel(&cleartime);

	argScene->removeOverlayModel(&bg_black);
	return;	
}

//^Cg`
void CDraw::drawTitle(int num, fk_Scene *argScene)
{
	bg_black.setPositionLT( -400.0 , 250.0 );
	argScene->entryOverlayModel( &bg_black );

	titlelogo.setPositionLT( -300.0 , 200.0 );
	argScene->entryOverlayModel( &titlelogo );

	gamestart.setPositionLT( -72.5 , -100.0 );
	argScene->entryOverlayModel( &gamestart );

	quit.setPositionLT( -72.5 , -150.0 );
	argScene->entryOverlayModel( &quit );

	cursol.setPositionLT( -120.0 , -100.0 + -50*num );
	argScene->entryOverlayModel( &cursol );
	return;
}

//o߃^C`
void CDraw::drawTime( int num , fk_Scene *argScene)
{
	minute = 0 ;
	while( num >= 6000 && minute < 9 )
	{
		num -= 6000 ;
		minute ++ ;
	}
	if( num >= 6000 )
	{
		num = 5999 ;
	}
	for(int i=0 ; i<10 ; i++)
	{
		for(int j=0 ; j<5 ; j++)
		{
			argScene->removeOverlayModel( &number[i][j] );
		}
	}

	for(int i=0 ; i<5 ; i++)
	{
		if( i == 4 )
		{
			number[minute][i].setPositionLT( 376.0-i*20-(i/2)*10 , 225.0 );
			argScene->entryOverlayModel( &number[minute][i] );
		}
		else
		{
			number[num%10][i].setPositionLT( 376.0-i*20-(i/2)*10 , 225.0 );
			argScene->entryOverlayModel( &number[num%10][i] );
			num /= 10 ;
		}
	}
	coron[0].setPositionLT( 298.0 , 225.0 );
	argScene->entryOverlayModel( &coron[0] );
	coron[1].setPositionLT( 348.0 , 225.0 );
	argScene->entryOverlayModel( &coron[1] );

	return;
}

//Cto[`
void CDraw::drawLife(double p_hp, double e_hp, fk_Scene *argScene)
{
	nowPHP = p_hp;
	nowEHP = e_hp;

	if(prevPHP > nowPHP)
	{
		prevPHP -= 0.01;
		if(prevPHP < 0 )
		{
			prevPHP = 0;
		}
	}
	if(prevEHP > nowEHP)
	{
		prevEHP -= 0.01;
		if(prevEHP < 0 )
		{
			prevEHP = 0;
		}
	}


	p_life.setSpriteSize( -1.0, 400.0*prevPHP);
	e_life.setSpriteSize( 600.0*prevEHP, -1.0);

	p_life.setPositionLT( -380, 175.0);
	argScene->entryOverlayModel( &p_life );
	e_life.setPositionLT( -330, 225.0);
	argScene->entryOverlayModel( &e_life );
	return;
}

//R{`
void CDraw::drawCombo(int num, fk_Scene *argScene)
{
	if(num>99)
	{
		num = 99;
	}

	if( num > 1)//R{QȏɂȂ
	{
		if(prevCombo == false)
		{
			if(moveCombo < 20)
			{
				posXCombo = moveCombo;
			}
			else
			{
				prevCombo = true;
				moveCombo = 0;
			}
			moveCombo += 4;
		}
		else
		{
			posXCombo = 20;
		}
		combo.setPositionLT(318-posXCombo, 125.0);
		argScene->entryOverlayModel( &combo );
		if(num > 9)
		{
			number[num%10][6].setPositionLT( 298.0-posXCombo , 140.0 );
			argScene->entryOverlayModel( &number[num%10][6] );
			num = num/10;
		}
		
		number[num][7].setPositionLT( 278.0-posXCombo , 140.0 );
		argScene->entryOverlayModel( &number[num][7] );
	}
	else
	{
		prevCombo = false;
	}

	return;
}

//Q[I[o[ʕ`
void CDraw::drawGameOver(fk_Scene *argScene)
{
	bg_black.setPositionLT( -400.0 , 250.0 );
	argScene->entryOverlayModel( &bg_black );

	gameover.setPositionLT(-145.0, 70.0);
	argScene->entryOverlayModel( &gameover);
	return;
}

//Q[NAʕ`
void CDraw::drawGameClear(int num, fk_Scene *argScene)
{
	bg_black.setPositionLT( -400.0 , 250.0 );
	argScene->entryOverlayModel( &bg_black );

	stageclear.setPositionLT(-145.0, 70.0);
	argScene->entryOverlayModel( &stageclear);

	cleartime.setPositionLT(-140.0, -80.0);
	argScene->entryOverlayModel( &cleartime);

	minute = 0 ;
	while( num >= 6000 && minute < 9 )
	{
		num -= 6000 ;
		minute ++ ;
	}
	if( num >= 6000 )
	{
		num = 5999 ;
	}
	for(int i=0 ; i<10 ; i++)
	{
		for(int j=0 ; j<5 ; j++)
		{
			argScene->removeOverlayModel( &number[i][j] );
		}
	}

	for(int i=0 ; i<5 ; i++)
	{
		if( i == 4 )
		{
			number[minute][i].setPositionLT( 120.0-i*20-(i/2)*10 , -80.0 );
			argScene->entryOverlayModel( &number[minute][i] );
		}
		else
		{
			number[num%10][i].setPositionLT( 120.0-i*20-(i/2)*10 , -80.0 );
			argScene->entryOverlayModel( &number[num%10][i] );
			num /= 10 ;
		}
	}
	coron[0].setPositionLT( 42.0 , -80.0 );
	argScene->entryOverlayModel( &coron[0] );
	coron[1].setPositionLT( 92.0 , -80.0 );
	argScene->entryOverlayModel( &coron[1] );

	return;
}

//`̏ݒ̏
void CDraw::initDraw()
{
	minute = 0;
	prevPHP = 1.0;
	nowPHP = 0;
	prevEHP = 1.0;
	nowEHP = 0;

	prevCombo = false;
	moveCombo = 0;
	posXCombo = 0;

	return;
}

//fobOp
void CDraw::debug()
{
	printf( "%d\n", 1);
	return;
}