#include "common.h"

CEnemyAttack::CEnemyAttack(fk_Vector pos)
{
	for(int i=0 ; i < bulletNum; i++ )
	{
		bulletModel[i].glMoveTo(pos);
		
		bulletObb[i].setBlockSize(5.0, 5.0, 5.0);
		bulletObb[i].setModel(&bulletModel[i]);
		bullet[i].setSize(5.0, 5.0, 5.0);
		bulletModel[i].setMaterial(DarkPurple);
		bulletModel[i].setShape(&bullet[i]);

		isHitBullet[i] = false;
		isMoveBullet[i] = false;
		bulletCount[i] = 0;
		bulletVecXPlus[i] = 1;
		bulletVecYPlus[i] = 1;
	}

	return;
};

CEnemyAttack::~CEnemyAttack(void)
{
};

void CEnemyAttack::entryScene(fk_Scene *argScene)
{
	for(int i=0; i< bulletNum; i++)
	{
		argScene->entryModel(&bulletModel[i]);
	}
	return;
}

//vC[ƒeƂ̏Փˏ
bool CEnemyAttack::checkBulletCollision(fkut_OBB &playerOBB, fk_Vector *spd)
{
	static fk_Vector back, refV;
	bool hitFlag = false;


	for(int i=0; i< bulletNum ; i++ )
	{
		if(isHitBullet[i] == true )
		{
			// Փ˔̊Jn
			back.init();
			if(bulletObb[i].checkVSMovingOBB(playerOBB, (*spd)/*+back*/, refV)) 
			{
				back += -refV*30; //ubN葽߂ɔ	]
				isHitBullet[i] = false;
				hitFlag = true;
			}
			(*spd) += back;
		}
	}
	return hitFlag;
}

//GĂ邩ǂ̒l̓
void CEnemyAttack::setEnemyAlive(bool isAlive)
{
	isEnemyAlive = isAlive;
	return;
}

//ȇxA̐ݒ菈
void CEnemyAttack::setBulletVec()
{
	for(int i=0; i< bulletNum; i++ )
	{
		if(isMoveBullet[i] == false)
		{
			if( rand()%2 == 1 )	bulletVecXPlus[i] = 1;
			else 
			{
				bulletVecXPlus[i] = -1;
			}

			if( rand()%2 == 1 )	bulletVecYPlus[i] = 1;
			else 
			{
				bulletVecYPlus[i] = -1;
			}

			bulletModel[i].glVec(rand()%100 * bulletVecXPlus[i], 0, rand()%100 * bulletVecYPlus[i]);
			isMoveBullet[i] = true;
			isHitBullet[i] = true;

			if(i < bulletNum/2)
			{
				bulletModel[i+ bulletNum/2].glVec(bulletModel[i].getVec().x * -1, 0, bulletModel[i].getVec().z * -1);
				isMoveBullet[i+ bulletNum/2] = true;
				isHitBullet[i+ bulletNum/2] = true;
			}
			break;
		}
	}
	return;
}

//ëړ
void CEnemyAttack::moveBullet()
{
	for(int i=0; i< bulletNum; i++ )
	{
		if(isMoveBullet[i] == true)
		{
			bulletModel[i].loTranslate(0, 0, -0.5);
			bulletCount[i] ++;
			if(bulletCount[i] > 300 )
			{
				bulletModel[i].loTranslate(0, 0, 151);
				isMoveBullet[i] = false;
				bulletCount[i] = 0;
			}
		}
	}
	return;
}

//ëʒȕ
void CEnemyAttack::initBulletPos(fk_Vector pos)
{
	for(int i=0; i< bulletNum; i++ )
	{
		if(isHitBullet[i] == false )
		{
			bulletModel[i].glMoveTo(pos);
			isMoveBullet[i] = false;
			isHitBullet[i] = false;
			bulletCount[i] = 0;
		}
	}
	return;
}



//e̕`
void CEnemyAttack::drawBullet()
{
	if( isEnemyAlive == true )//GĂƂf`
	{
		for( int i=0; i< bulletNum; i++ )
		{
			bulletModel[i].setDrawMode(FK_POINTMODE | FK_LINEMODE | FK_POLYMODE);
		}
	}
	else
	{
		for( int i=0; i< bulletNum; i++ )
		{
			bulletModel[i].setDrawMode(FK_NONEMODE);	
		}
	}
	return;
}

//G̍UNX̏ݒ̏
void CEnemyAttack::initEnemyAttack()
{
	for(int i=0 ; i < bulletNum; i++ )
	{
		isHitBullet[i] = false;
		isMoveBullet[i] = false;
		bulletCount[i] = 0;
		bulletVecXPlus[i] = 1;
		bulletVecYPlus[i] = 1;
	}

	return;
}

//fobOp
void CEnemyAttack::debug()
{
	printf( "%d\n", 1);
	return;
}