#include "common.h"

CField::CField(void)
{
	fk_Material::initDefault();

	for(int i = 0; i < blockNum; i++) {
		obb[i].setBlockSize(30.0, 10.0, 30.0);
		obb[i].setModel(&blockModel[i]);
		block[i].setSize(30.0, 10.0, 30.0);
		blockModel[i].setMaterial(Yellow);
	}
	
	for(int i = 0; i < blockNum; i++ )
	{
		judgeCatch[i] = 2;
	}


	blockModel[0].glMoveTo(0.0, -5.0, 0.0);		judgeCatch[0] = 1;	
	blockModel[1].glMoveTo(0.0, -5.0, -30.0);	judgeCatch[1] = 1;
	blockModel[2].glMoveTo(0.0, -5.0, -60.0);
	blockModel[3].glMoveTo(0.0, -5.0, -90.0);	judgeCatch[3] = 1;
	blockModel[4].glMoveTo(0.0, -5.0, -120.0);	judgeCatch[4] = 1;
	blockModel[5].glMoveTo(0.0, -5.0, -150.0);	judgeCatch[5] = 1;
	blockModel[6].glMoveTo(0.0, -5.0, -180.0);
	blockModel[7].glMoveTo(0.0, -5.0, -210.0);	//judgeCatch[7] = 1;
	blockModel[8].glMoveTo(0.0, -5.0, -240.0);

	blockModel[9].glMoveTo(30.0, -5.0, -30.0);
	blockModel[10].glMoveTo(30.0, -5.0, -60.0);		judgeCatch[10] = 1;
	blockModel[11].glMoveTo(30.0, -5.0, -90.0);
	blockModel[12].glMoveTo(30.0, -5.0, -120.0);	judgeCatch[12] = 1;
	blockModel[13].glMoveTo(30.0, -5.0, -150.0);
	blockModel[14].glMoveTo(30.0, -5.0, -180.0);	judgeCatch[14] = 1;
	blockModel[15].glMoveTo(30.0, -5.0, -210.0);
	
	blockModel[16].glMoveTo(-30.0, -5.0, -30.0);
	blockModel[17].glMoveTo(-30.0, -5.0, -60.0);	judgeCatch[17] = 1;
	blockModel[18].glMoveTo(-30.0, -5.0, -90.0);
	blockModel[19].glMoveTo(-30.0, -5.0, -120.0);	judgeCatch[19] = 1;
	blockModel[20].glMoveTo(-30.0, -5.0, -150.0);
	blockModel[21].glMoveTo(-30.0, -5.0, -180.0);	judgeCatch[21] = 1;
	blockModel[22].glMoveTo(-30.0, -5.0, -210.0);

	blockModel[23].glMoveTo(60.0, -5.0, -60.0);
	blockModel[24].glMoveTo(60.0, -5.0, -90.0);		judgeCatch[24] = 1;
	blockModel[25].glMoveTo(60.0, -5.0, -120.0);
	blockModel[26].glMoveTo(60.0, -5.0, -150.0);	judgeCatch[26] = 1;
	blockModel[27].glMoveTo(60.0, -5.0, -180.0);

	blockModel[28].glMoveTo(-60.0, -5.0, -60.0);
	blockModel[29].glMoveTo(-60.0, -5.0, -90.0);	judgeCatch[29] = 1;
	blockModel[30].glMoveTo(-60.0, -5.0, -120.0);
	blockModel[31].glMoveTo(-60.0, -5.0, -150.0);	judgeCatch[31] = 1;
	blockModel[32].glMoveTo(-60.0, -5.0, -180.0);

	blockModel[33].glMoveTo(90.0, -5.0, -90.0);
	blockModel[34].glMoveTo(90.0, -5.0, -120.0);
	blockModel[35].glMoveTo(90.0, -5.0, -150.0);

	blockModel[36].glMoveTo(-90.0, -5.0, -90.0);
	blockModel[37].glMoveTo(-90.0, -5.0, -120.0);
	blockModel[38].glMoveTo(-90.0, -5.0, -150.0);

	blockModel[39].glMoveTo(120.0, -5.0, -120.0);
	blockModel[40].glMoveTo(-120.0, -5.0, -120.0);

	for(int i = 0; i < blockNum; i++) {
		blockModel[i].setShape(&block[i]);
		blockModel[i].setSmoothMode(true);
	}

		
	return;
}

CField::~CField(void)
{
}

void CField::entryScene(fk_Scene *argScene)
{
	for(int i = 0; i < blockNum; i++) {
		argScene->entryModel(&blockModel[i]);
	}

	return;
}

//vCƂ̏Փˏ
bool CField::checkCollision(fkut_OBB &playerOBB, fk_Vector *spd)
{
	static fk_Vector back, refV;
	bool standFlag = false;

	//ubNɐGĂȂ
	judgeStand = -9999;

	// Փ˔̊Jn
	for(int i = 0; i < blockNum; i++) {
		blockModel[i].setMaterial(Green);
	}
	do {
		back.init();
		for(int i = 0; i < blockNum; i++) {
			if(obb[i].checkVSMovingOBB(playerOBB, (*spd)+back, refV)) 
			{
				if( judgeCatch[i] > 0 )
				{
					back += -refV;
					blockModel[i].setMaterial(Red); 
					judgeStand = i;
				}
			}
		}
		if(abs(back.y) > 0.0)
		{
			standFlag = true;
		}
		(*spd) += back;
	} while(!back.isZero());
	// Փ˂̔͂𑬓xɉďI

	return standFlag;
}

//vC̉eƂ̏Փˏ
int CField::checkShadowCollision(fkut_OBB &shadowOBB, fk_Vector *spd)
{
	static fk_Vector back, refV;

	// Փ˔̊Jn
	back.init();
	for(int i = 0; i < blockNum; i++) {
		if(obb[i].checkVSMovingOBB(shadowOBB, (*spd)+back, refV)) 
		{
			if( judgeCatch[i] > 0 )
			{
				return i;
			}
		}
	}
	(*spd) += back;
	
	return -9999;
}

//͂߂鑫ꂩǂ
int CField::getJudgeCatch()
{
	return judgeCatch[judgeStand];
}

//񂾃ubÑtO
void CField::setBlockCatch()
{
	if( judgeCatch[judgeStand] == 2 )	{
		judgeCatch[judgeStand] = 0;
	}
	return;
}

//ubN`攻菈
void CField::drawBlock()
{
	for(int i = 0; i < blockNum; i++ )
	{
		if( judgeCatch[i] > 0 )
		{
			blockModel[i].setDrawMode(FK_POLYMODE);
			if( judgeCatch[i] == 1 )
			{
				blockModel[i].setMaterial(Yellow);
			}
		}
		else
		{
			blockModel[i].setDrawMode(FK_NONEMODE);	
		}
	}
	return;
}

//tB[h̏ݒ菉
void CField::initField()
{
	for(int i = 0; i < blockNum; i++ )
	{
		judgeCatch[i] = 2;
	}

	judgeCatch[0] = 1;
	judgeCatch[1] = 1;
	judgeCatch[3] = 1;
	judgeCatch[4] = 1;
	judgeCatch[5] = 1;
	judgeCatch[10] = 1;
	judgeCatch[12] = 1;
	judgeCatch[14] = 1;
	judgeCatch[17] = 1;
	judgeCatch[19] = 1;
	judgeCatch[21] = 1;
	judgeCatch[24] = 1;
	judgeCatch[26] = 1;
	judgeCatch[29] = 1;
	judgeCatch[31] = 1;

	return;
}

void CField::debug()
{
	//printf( "[1]size:%d\n", block[1].getBlockSize() );
	return;
}
