#include "common.h"

CPlayer::CPlayer()
{
	player.setSize(10.0, 25.0, 10.0);
	playerModel.setShape(&player);
	playerModel.setMaterial(Blue);
	playerModel.setSmoothMode(true);

	playerModel.glMoveTo(0.0, 30.0, 0.0);//vCW
	playerOBB.setBlockSize(10.0, 25.0, 10.0);
	playerOBB.setModel(&playerModel);

	rotMat.makeRot(FK_PI/2.0, fk_Y);

	parentAttackModel.glMoveTo(playerModel.getPosition());	
	attackModel.glMoveTo(parentAttackModel.getPosition().x, parentAttackModel.getPosition().y, parentAttackModel.getPosition().z-(20.0));

	attack.setSize(5.0, 1.0, 20.0);
	attackModel.setParent( &parentAttackModel, true);
	attackModel.setShape(&attack);
	attackModel.setMaterial(White);
	attackOBB.setBlockSize(5.0, 1.0, 20.0);
	attackOBB.setModel(&attackModel);

	shadow.setDivide(20);
	shadow.setTopRadius(5.0);
	shadow.setBottomRadius(5.0);
	shadow.setHeight(0.1);
	shadowModel.setShape(&shadow);
	shadowModel.setMaterial(MatBlack);
	shadowModel.glVec(0, 1, 0);
	shadowOBB.setBlockSize(10.0, 0.1, 10.0);
	shadowOBB.setModel(&shadowModel);

	shadowSpd = (0, -20, 0);

	isJump = false;
	isDash = false;
	dashCount = 0;
	isDamage = false;
	isCanMove = true;
	invCount = 0;
	MaxHP = 5;
	HP = MaxHP;
	isAlive = true;

	isInputAttack = false;
	stepAttack = 0;
	attackCount = 0;
	isHitAttack = false;

	comboNum = 0;
	comboCount = 0;
	comboBonus = 1.0;
	attackDamage = 0;

	return;
};

CPlayer::~CPlayer(void)
{
};

void CPlayer::entryScene(fk_Scene *argScene)
{
	argScene->entryModel(&playerModel);
	argScene->entryModel(&attackModel);
	argScene->entryModel(&shadowModel);
	
	return;
}

//ʒuW擾
fk_Vector CPlayer::getPos()
{
	return playerModel.getPosition();
}

//is菈
void CPlayer::setView(fk_Vector cameraVec)
{
	view = cameraVec;
	view.y = 0.0;
	view.normalize();
	return;
}

// n㎞͓x^A󒆂ł͉x
void CPlayer::initSpd()
{
	spd.init();
	return;
}

//OBB擾
fkut_OBB CPlayer::getOBB()
{
	return playerOBB;
}

//*spd擾
fk_Vector * CPlayer::getPSpd()
{
	return &spd;
}

//spd擾
fk_Vector CPlayer::getSpd()
{
	return spd;
}

//isJump̎擾
bool CPlayer::getIsJump()
{
	return isJump;
}

//Wv̍sitgǂɂƂ
void CPlayer::jumpAction(bool isLift)
{
	acc.x = spd.x;
	acc.z = spd.z;
	acc.y = 2.0;
	if(isLift == false )
	{
		isJump = true;
	}
	return;
}

//isCanMove̎擾
bool CPlayer::getIsCanMove()
{
	return isCanMove;
}

//ړ̍siL[{[ĥ݁H
void CPlayer::moveAction(int direct)
{
	switch(direct)
	{
	//
	case 2:
		if(abs(acc.y) > 0.0)
		{
			acc -= view*0.2;
		}
		else
		{
			spd -= view*1.0;
		}
		break;
	//
	case 4:
		if(abs(acc.y) > 0.0) 
		{
			acc += rotMat*view*0.2;
		}
		else
		{
			spd += rotMat*view*1.0;
		}
		break;
	//E
	case 6:
		if(abs(acc.y) > 0.0) 
		{
			acc -= rotMat*view*0.2;
		}
		else
		{
			spd -= rotMat*view*1.0;
		}
		break;
	//
	case 8:
		if(abs(acc.y) > 0.0)
		{
			acc += view*0.2;
		}
		else
		{
			spd += view*1.0;
		}
		break;

	default:
		break;
	}	
	return;
}

//Xs[hʏ퉻̒l̐ݒ
void CPlayer::normSpd()
{
	if(spd.normalize() ) 
	{
		spd *= 1.0;
	}
	vec = spd;	//擾
	return;
}

//d͂̉e
void CPlayer::setGravity()
{
	acc.y -= 0.098;
	if(acc.x*acc.x + acc.z*acc.z > 1.0*1.0) {
		double tmpSpdLen = sqrt(acc.x*acc.x + acc.z*acc.z);
		acc.x *= 1.0/tmpSpdLen;
		acc.z *= 1.0/tmpSpdLen;
	} else {
		acc.x *= 0.9;
		acc.z *= 0.9;
	}
	return;
}

//x𑬓xɏ悹
void CPlayer::addAcc()
{
	spd += acc;
	if(spd.y < -3.0 )
	{
		spd.y = -3.0;
	}
	return;
}

//isDash̎擾
bool CPlayer::getIsDash()
{
	return isDash;
}

//_bV֐ݒ
void CPlayer::setIsDash()
{
	isDash = true;
	return;
}

//_bV̍s
void CPlayer::dashAction()
{
	if(isDash == true )
	{
		//20t[_bV
		if(dashCount > 20 )
		{
			isDash = false;
			dashCount = 0;
		}
		while(acc.y < 0 )
		{
			acc.y += 0.098;
		}
		spd += acc*2;

		dashCount ++;
	}
	return;
}

//Փˎ̂YWvXCiԂh~
void CPlayer::setPosY(bool isPlus)
{
	if(isPlus == true)
	{
		playerModel.glTranslate(0, 1.0, 0);
	}
	else
	{
		playerModel.glTranslate(0, -1.0, 0);
	}
	return;
}

//ՓˎxAWvtO
void CPlayer::initAcc()
{
	acc.init();
	isJump = false;
	return;
}

//_[W󂯂Ă邩̔ƃ_[W̏
bool CPlayer::getDamageState()
{
	if(isDamage == true )
	{
		//60t[ŏI
		if(invCount > 60 )
		{
			isDamage = false;
			invCount = 0;
		}
		//40t[瓮悤ɂȂ
		else if(invCount > 40)
		{
			isCanMove = true;
		}
	
		//_[WHĂ邱ƂL̓_
		if(invCount % 20 == 0)
		{
			playerModel.setMaterial(Blue);
		}
		else if(invCount % 10 == 0)
		{
			playerModel.setMaterial(DarkRed);
		}
		invCount ++;
	}
	return isDamage;
}

//_[WԂ̐ݒ菈
void CPlayer::setDamageState(int num)
{
	acc.init();
	isDamage = true;	//_[WԂ
	isCanMove = false;	//ȂȂԂ
	HP -= num;
	return;
}

// x𑀍샂fɉĎۂɓiY
void CPlayer::translatePlayerY()
{
	playerModel.glTranslate(0.0, spd.y, 0.0);
	//Ufꏏɓ
	parentAttackModel.glTranslate(0.0, spd.y, 0.0);
	return;
}

// x𑀍샂fɉĎۂɓiXZ
void CPlayer::translatePlayerXZ()
{
	playerModel.glTranslate(spd.x, 0.0, spd.z);
	playerModel.glVec(vec);	//␳
	//Ufꏏɓ
	parentAttackModel.glTranslate(spd.x, 0.0, spd.z);
	return;
}

//vČ擾
fk_Vector CPlayer::getPlayerVec()
{
	return playerModel.getVec();
}

//GɌČύX
void CPlayer::setVecEnemy(fk_Vector pos)
{
	playerModel.glFocus(pos.x, playerModel.getPosition().y + vec.y, pos.z);
	return;
}

//ǂ̍U^Cv̔
int CPlayer::getIsAttack()
{
	return stepAttack;
}

//Uf̌ύX
void CPlayer::setAttackVec(fk_Vector vec)
{
	parentAttackModel.glFocus(playerModel.getPosition() + vec);
	return;
}

//ߐڍU̐ݒ
void CPlayer::setAttack()
{
	//stepAttack == 0@UĂȂ
	if(stepAttack == 0 )
	{
		stepAttack = 1;
		isHitAttack = true;
		for(int i = 0; i < 10; i++)
		{	
			parentAttackModel.loFocus(-0.07, 0.0, -0.8);
		}
	}
	//stepAttack == 1 Piڂ̍U
	else if(stepAttack == 1)
	{
		if(attackCount > 0 )
		{
			isInputAttack = true;
		}
	}
	//stepAttack == 2 Qiڂ̍U
	else if(stepAttack == 2)
	{
		if(attackCount > 0 )
		{
			isInputAttack = true;
		}
	}
	return;
}

//ߐڍȔ
void CPlayer::attackAction()
{
	switch(stepAttack)
	{
	//io[ɂĉiڂ̍U𕪂
	//Piڂ̍U
	case 1:
		//30t[o߂ōUI
		if(attackCount > 30 )
		{
			if( isInputAttack == false)
			{
				stepAttack = 0;
				attackCount = 0;
				isHitAttack = false;
			}
			else
			{
				isInputAttack = false;
				isHitAttack = true;
				stepAttack = 2;	
				attackCount = 0;
			}
		}
		//Uf̈ړ
		if(	attackCount < 21 )
		{
			parentAttackModel.loFocus(0.1, 0.0, -0.8);
			attackDamage = 1;	//_[Wlݒ
		}
		else
		{
			attackDamage = 0;
			isHitAttack = false;
		}

		attackCount ++;
		break;
	//Qiڂ̍U
	case 2:
		//20t[o߂ōUI
		if(attackCount > 30 )
		{
			if( isInputAttack == false)
			{
				stepAttack = 0;
				attackCount = 0;
				isHitAttack = false;
				isInputAttack = false;
			}
			else
			{
				isInputAttack = false;
				isHitAttack = true;
				stepAttack = 3;	
				attackCount = 0;
			}
		}
		//Uf̈ړ
		if(attackCount < 21)
		{
			parentAttackModel.loFocus(-0.1, 0.0, -0.8);
			attackDamage = 1;	//_[Wlݒ
		}
		else
		{
			attackDamage = 0;
			isHitAttack = false;
		}

		attackCount ++;
		break;

		//Riڂ̍U
	case 3:
		//30t[o߂ōUI
		if(attackCount > 30 )
		{
			stepAttack = 0;
			attackCount = 0;
			isHitAttack = false;
			isInputAttack = false;
		}
		//Uf̈ړ
		parentAttackModel.loFocus(0.25, 0.0, -0.8);
		attackDamage = 2;	//_[Wlݒ
		attackCount ++;
		break;

	default :
		break;
	};
	return;
}

//UՓ˔菈
bool CPlayer::checkAttackCollision(fkut_OBB &hitOBB, fk_Vector *spd)
{
	bool judge = false;

	static fk_Vector refV;

	// Փ˔̊Jn
	if(isHitAttack == true )//蔻肪cĂȂ
	{
		if(attackOBB.checkVSMovingOBB(hitOBB, (*spd), refV )) 
		{
			judge = true;
			isHitAttack = false;//蔻
			if(comboNum == 0 )
			{
				comboNum ++;
				comboCount = 60;
			}
			else if(comboNum > 0 && comboCount != 0)
			{
				comboNum ++;
				comboCount = 60;
			}
		}
	}
		
	return judge;
}

//vC̏
bool CPlayer::setFallState()
{
	bool isDrop = false;
	if(playerModel.getPosition().y < -200)
	{
		playerModel.glMoveTo(0.0, 30.0, 0.0);//vCW
		parentAttackModel.glMoveTo(0.0, 30.0, 0.0);//Uf
		isDrop= true;
	}
	return isDrop;
}

//R{֘Ȁ
void CPlayer::setCombo()
{
	if(comboCount > 0)
	{
		comboCount --;
	}

	if(comboCount <= 0)
	{
		comboCount = 0;
		comboNum = 0;
	}

	//R{{[iX_[W{ݒ
	if(comboNum > 1 )
	{
		comboBonus = 1.0 + 0.1*comboNum;
	}
	else
	{
		comboBonus = 1.0;
	}
	
	return;
}

//ɂR{
void CPlayer::addLifThrowCombo()
{
	if(comboNum == 0)
	{
		comboCount = 60;
		comboNum ++;
	}
	else if(comboCount > 0)
	{
		comboCount = 60;
		comboNum ++;
	}
	return;
}

//R{擾
int CPlayer::getComboNum()
{
	return comboNum;
}

//R{{[iX{擾
double CPlayer::getComboBonus()
{
	return comboBonus;
}

//_[Wl̎擾
double  CPlayer::getAttackDamage()
{
	double returnDamage = attackDamage*comboBonus;
	attackDamage = 0;
	return returnDamage;
}

//ëړ
void CPlayer::moveShadow()
{

	shadowModel.glMoveTo(playerModel.getPosition().x, 0, playerModel.getPosition().z);
	return;
}

//HP̊擾
double CPlayer::getHPrate()
{
	double rate = 0;
	rate = HP / MaxHP;
	debugNum = rate;
	return rate;
}

//Ԃ̐ݒ菈
void CPlayer::setAliveFlag()
{
	isAlive = true;
	if(HP <= 0)
	{
		isAlive = false;
	}
	return;
}

//Ԃ̎擾
bool CPlayer::getAliveFlag()
{
	return isAlive;
}

//vC̕`攻
void CPlayer::drawPlayer()
{
	if( isAlive == true )//ĂƂvC[f`
	{
		playerModel.setDrawMode(FK_POINTMODE | FK_LINEMODE | FK_POLYMODE);
		if( stepAttack > 0)//UsĂ鎞Uf`
		{
			attackModel.setDrawMode(FK_POINTMODE | FK_LINEMODE | FK_POLYMODE);
		}
		else
		{
			attackModel.setDrawMode(FK_NONEMODE);
		}
	}
	else
	{
		playerModel.setDrawMode(FK_NONEMODE);	
		attackModel.setDrawMode(FK_NONEMODE);
	}
	return;
}

//vCNX̏ݒ̏
void CPlayer::initPlayer()
{
	playerModel.glMoveTo(0.0, 30.0, 0.0);//vCW
	parentAttackModel.glMoveTo(playerModel.getPosition());

	isJump = false;
	isDash = false;
	dashCount = 0;
	isDamage = false;
	isCanMove = true;
	invCount = 0;
	MaxHP = 5;
	HP = MaxHP;
	isAlive = true;

	isInputAttack = false;
	stepAttack = 0;
	attackCount = 0;
	isHitAttack = false;

	comboNum = 0;
	comboCount = 0;
	attackDamage = 0;
	return;
}

//fobOp
void CPlayer::debug()
{
	printf( "%d\n", comboNum);
	return;
}