#include "common.h"

#include "Anima.h"

CAnima::CAnima()
{
	liveFlag = false;
	actionType = -1;

	anima.setSize(15.0, 55.0, 15.0);
	animaModel.setShape(&anima);
	animaModel.setMaterial(Red);
	animaModel.setSmoothMode(true);

	animaOBB.setBlockSize(15.0, 45.0, 15.0);
	animaOBB.setModel(&animaModel);

	if(!animaThrowObj.loadObjectData("anima/anima_ball.mqo")) fl_alert("[anima_ball.mqo] Read Error.");
	if(!animaThrowObj.loadJointData("anima/anima_ball.fkc")) fl_alert("[anima_ball.fkc] Read Error.");

	throwBlock.setSize( 8.0, 8.0, 8.0);
	throwBlockModel.setShape(&throwBlock);
	throwBlockModel.setMaterial(Green);
	throwBlockModel.setSmoothMode(true);

	throwBlockOBB.setBlockSize(8.0, 8.0, 8.0);
	throwBlockOBB.setModel(&throwBlockModel);

	blockFlag = false;
	throwFlag = false;
	throwLV = 1;
	countToBoot = 60;

	throwBlockDistance = 0;

	attackDamage = 2;	//Aj}X[̃_[Wl

	animaSpd = (0, 0, 0);
	animaThrowBlockSpd = (0, 0, 0);

	return;
}

CAnima::~CAnima()
{
}

//Aj}̃Gg[ƃ[u
void CAnima::entryAnima(fk_Scene *argScene)
{
	if(liveFlag == true)
	{
		argScene->entryModel(&animaModel);
	}
	else
	{
		argScene->removeModel(&animaModel);
	}

	if(throwFlag == true)
	{
	  animaThrowObj.entryScene(argScene);
	}
	else
	{
		animaThrowObj.removeScene(argScene);
	}

	return;
}

//ʒu擾
fk_Vector CAnima::getPos()
{
	return animaModel.getPosition();
}

//擾
fk_Vector CAnima::getVec()
{
	return animaModel.getVec();
}

//OBB擾
fkut_OBB CAnima::getOBB()
{
	return animaOBB;
}

//Aj}X[pubNij̃Gg[ƃ[u
void CAnima::entryAnimaThrowBlock(fk_Scene *argScene)
{
	if(blockFlag == true)
	{
		argScene->entryModel(&throwBlockModel);
	}
	else
	{
		argScene->removeModel(&throwBlockModel);
	}
	
	return;
}

//Aj}̏
void CAnima::summonAnima(fk_Vector pos)
{
	if(liveFlag == false)
	{
		liveFlag = true;
		animaModel.glMoveTo(pos);
		animaModel.loTranslate( -10.0, -10.0, 0.0);
		
		nowCount = 0;

	}
	return;
}

//Aj}ANV̎ސݒ
void CAnima::setActionType(int num)
{
	actionType = num;
	return;
}

//Aj}݂ꍇAAj}X[܂ł̎Ԃ̏
void CAnima::decCountToBoot()
{
	if(liveFlag == true)
	{
		nowCount ++;
	}

	return;
}

//Aj}̌̐ݒ
void CAnima::setAnimaVec(fk_Vector pos)
{
	animaModel.glFocus(pos.x, animaModel.getPosition().y + animaModel.getVec().y, pos.z);
	animaModel.loFocus(0, 0, 1);
	return;
}

//Aj}X[̐ݒ
void CAnima::setAnimaThrow(fk_Scene *argScene)
{
	blockFlag = true;
	throwBlockModel.glMoveTo(animaModel.getPosition());
	throwBlockModel.loTranslate( 15.0, 30.0, 0.0);

	actionType = 2;
	throwLV = 6;
	attackDamage = 30;
	countToBoot = 30;
	animaThrowObj.entryScene(argScene);
	return;
}

//Aj}X[̔
void CAnima::bootAnimaThrow(fk_Vector pos)
{
	if(liveFlag == true )
	{
		if(countToBoot <= nowCount)
		{
			nowCount = 0;
			throwBlockModel.glFocus(pos);		//G̕
			throwFlag = true;
		}
	}
}

//Aj}X[̌o߁iubN̈ړj
void CAnima::procAnimaThrow()
{
	if(throwFlag == true)
	{
		throwBlockModel.loTranslate(0.0, 0.0, -3.0);
		throwBlockDistance += 3;					//ubNׂ̏̈ɃubN̈ړZ
		animaThrowObj.getBaseModel()->glMoveTo(throwBlockModel.getPosition().x, throwBlockModel.getPosition().y, throwBlockModel.getPosition().z );
		animaThrowObj.getBaseModel()->glVec(throwBlockModel.getVec());
	}

	return;
}

//_[Wl̎擾
double CAnima::getAttackDamage(double comboBonus)
{
	double returnDamage = attackDamage*comboBonus;
	attackDamage = 2;
	return returnDamage;
}

//Aj}yA̐ݒ
void CAnima::setAnimaRepair()
{
	actionType = 3;
	countToBoot = 40;
	return;
}

//Aj}yA̔
void CAnima::bootAnimaRepair()
{
	if(liveFlag == true )
	{
		if(countToBoot <= nowCount)
		{
			nowCount = 0;
			liveFlag = false;
		}
	}
	return;
}

//Aj}̑݃tO擾
bool CAnima::getLiveFlag()
{
	return liveFlag;
}

//Aj}̑݃tO擾
int CAnima::getActionType()
{
	return actionType;
}

//ubN̉x̃AhX擾
fk_Vector * CAnima::getPSpd()
{
	return &animaSpd;
}

//ubN̉x̃AhX擾
fk_Vector * CAnima::getAnimaThrowBlockSpdAddress()
{
	return &animaThrowBlockSpd;
}

//Փ˔菈iՓˎ̓ubN܂
bool CAnima::checkCollision(fkut_OBB &hitOBB, fk_Vector *spd)
{
	bool judge = false;

	static fk_Vector refV;

	throwBlockModel.setMaterial(Gray1);	

	// Փ˔̊Jn
	if(blockFlag == true)
	{
		if(throwBlockOBB.checkVSMovingOBB(hitOBB, (*spd), refV )) 
		{
			throwBlockModel.setMaterial(Red); 
			judge = true;

			//uOėꂷubN̏tOvƓl̏s
			blockFlag = false;
			throwFlag = false;
			liveFlag = false;
			throwBlockDistance = 0;
		}
	}
		
	return judge;
}

//ubN̏tO
void CAnima::setAnimaThrowBlock(bool isHit, fk_Scene *argScene)
{
	for(int i = 0; i < 6; i++ )
	{
		if(isHit == true )
		{
			liveFlag = false;
			throwFlag = false;										//蔻
			blockFlag = false;									//݂Ȃɐݒ
			throwBlockDistance = 0;										//ړZbg
			animaThrowObj.removeScene(argScene);
		}

		if(throwBlockDistance > 400)	//ubN̈ړ400ȏ̎
		{
			liveFlag = false;
			throwFlag = false;										//蔻
			blockFlag = false;									//݂Ȃɐݒ
			throwBlockDistance = 0;										//ړZbg
			animaThrowObj.removeScene(argScene);
		}
	}
	return;
}