#include "common.h"

#include "Draw.h"

CDraw::CDraw()
{
	if( !titleImage.readPNG("image/titleimage.png") )	fl_alert( "error read[titleimage.png]" );
	if( !gamestart.readPNG("image/gamestart.png") )	fl_alert( "error read[gamestart.png]" );
	if( !quit.readPNG("image/quit.png") )	fl_alert( "error read[quit.png]" );
	if( !cursol.readPNG("image/cursol.png") )	fl_alert( "error read[cursol.png]" );

	
	//^C\p
	if( !timeNumberBase.readPNG("image/interface/number_time.png") )	fl_alert( "error read[number_time.png]" );
	for(int j = 0; j < 6; j++) 
	{
		timeNumber[j].setImage( *timeNumberBase.getImage() );
	}


	//XRA\p
	/*
	if( !scoreNumberBase.readPNG("image/interface/number_score.png") )	fl_alert( "error read[number_score.png]" );
	for(int i = 0; i < 10; i++)
	{
		for(int j = 0; j < 8; j++) 
		{
			p_scoreNumber[i][j].setImage( *scoreNumberBase.getImage() );
			e_scoreNumber[i][j].setImage( *scoreNumberBase.getImage() );
			p_scoreNumber[i][j].setSpriteArea(0+(i*15), 0, 15, 20);
			e_scoreNumber[i][j].setSpriteArea(0+(i*15), 0, 15, 20);
		}
	}
	*/

	//R{p
	if( !comboNumberBase.readPNG("image/interface/number_combo.png") )	fl_alert( "error read[number_combo.png]" );
	for(int j = 0; j < 2; j++) 
	{
		comboNumber[j].setImage( *comboNumberBase.getImage() );
	}

	//R
	for(int i=0 ; i<2 ; i++)
	{
		if( !coron[i].readPNG("image/coron.png") )	fl_alert( "error read[coron.png]" );
	}

	//ACRwi
	if( !p_icon_bg.readPNG("image/interface/p_icon_bg.png") )	fl_alert( "error read[p_icon_bg.png]" );
	if( !e_icon_bg.readPNG("image/interface/e_icon_bg.png") )	fl_alert( "error read[e_icon_bg.png]" );

	//LN^[ACR
	if( !nageru_icon.readPNG("image/interface/nageru_icon.png") )	fl_alert( "error read[nageru_icon.png]" );
	if( !rockking_icon.readPNG("image/interface/rockking_icon.png") )	fl_alert( "error read[rockking_icon.png]" );

	//ACRƃo[uĂt[
	if( !p_gray_flame.readPNG("image/interface/glayflame.png") )	fl_alert( "error read[glayflame.png]" );
	if( !e_gray_flame.readPNG("image/interface/glayflame.png") )	fl_alert( "error read[glayflame.png]" );

	//vC[Cto[
	if( !p_life.readPNG("image/interface/HPgauge.png") )	fl_alert( "error read[HPgauge.png]" );
	if( !p_life_flame.readPNG("image/interface/HPgauge_flame.png") )	fl_alert( "error read[HPgauge_flame.png]" );
	if( !e_life.readPNG("image/interface/HPgauge.png") )	fl_alert( "error read[HPgauge.png]" );
	if( !e_life_flame.readPNG("image/interface/HPgauge_flame.png") )	fl_alert( "error read[HPgauge_flame.png]" );

	//XgbNQ[W
	if( !p_stockGauge.readPNG("image/interface/stockgauge.png") )	fl_alert( "error read[stockgauge.png]" );
	if( !p_stockGauge_flame.readPNG("image/interface/stockgauge_flame.png") )	fl_alert( "error read[stockgauge_flame.png]" );
	if( !e_stockGauge.readPNG("image/interface/stockgauge.png") )	fl_alert( "error read[stockgauge.png]" );
	if( !e_stockGauge_flame.readPNG("image/interface/stockgauge_flame.png") )	fl_alert( "error read[stockgauge_flame.png]" );

	//Aj}Q[W
	if( !p_animaGauge.readPNG("image/interface/animagauge.png") )	fl_alert( "error read[animagauge.png]" );
	if( !p_animaGauge_flame.readPNG("image/interface/animagauge_flame.png") )	fl_alert( "error read[animagauge_flame.png]" );
	if( !e_animaGauge.readPNG("image/interface/animagauge.png") )	fl_alert( "error read[animagauge.png]" );
	if( !e_animaGauge_flame.readPNG("image/interface/animagauge_flame.png") )	fl_alert( "error read[animagauge_flame.png]" );
	
	if( !combo.readPNG("image/combo.png") )	fl_alert( "error read[combo.png]" );

	if( !gameover.readPNG("image/gameover_nageru.png") )	fl_alert( "error read[gameover_nageru.png]" );

	if( !stageclear.readPNG("image/stageclear.png") )	fl_alert( "error read[stageclear.png]" );
	if( !cleartime.readPNG("image/cleartime.png") )	fl_alert( "error read[cleartime.png]" );

	if( !pause.readPNG("image/pause.png") )	fl_alert( "error read[pause.png]" );

	if( !bg_black.readPNG("image/bg_black.png") )	fl_alert( "error read[bg_black.png]" );

	if( !help_act.readPNG("image/interface/help_act.png") )	fl_alert( "error read[help_act.png]" );
	if( !help_anima.readPNG("image/interface/help_act.png") )	fl_alert( "error read[help_act.png]" );//摜Ƃactǂݍ

	isDrawHelp = true;

	minute = 0;
	prevPHP = 1.0;
	nowPHP = 0;
	prevEHP = 1.0;
	nowEHP = 0;

	prevCombo = false;
	moveCombo = 0;
	posXCombo = 0;

	return;
}

CDraw::~CDraw()
{
}

void CDraw::entryScene(fk_Scene *argScene, fk_Window *window)
{
	argScene->entryOverlayModel(&titleImage);
	titleImage.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&gamestart);
	gamestart.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&quit);
	quit.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&cursol);
	cursol.MakePixelBase(window, argScene);

	for(int j = 0; j < 6; j++) 
	{
		argScene->entryOverlayModel(&timeNumber[j]);
		timeNumber[j].MakePixelBase(window, argScene);
	}

	/*
	for(int i = 0; i < 10; i++)
	{
		for(int j = 0; j < 8; j++) 
		{
			argScene->entryOverlayModel(&p_scoreNumber[i][j]);
			p_scoreNumber[i][j].MakePixelBase(window, argScene);
			argScene->entryOverlayModel(&e_scoreNumber[i][j]);
			e_scoreNumber[i][j].MakePixelBase(window, argScene);
		}
	}
	*/

	for(int j = 0; j < 2; j++) 
	{
		argScene->entryOverlayModel(&comboNumber[j]);
		comboNumber[j].MakePixelBase(window, argScene);
	}


	for(int i = 0; i < 2 ; i++ )
	{
		argScene->entryOverlayModel(&coron[i]);
		coron[i].MakePixelBase(window, argScene);
	}

	argScene->entryOverlayModel(&p_icon_bg);
	p_icon_bg.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&e_icon_bg);
	e_icon_bg.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&nageru_icon);
	nageru_icon.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&rockking_icon);
	rockking_icon.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&p_gray_flame);
	p_gray_flame.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&e_gray_flame);
	e_gray_flame.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&p_life);
	p_life.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&p_life_flame);
	p_life_flame.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&e_life);
	e_life.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&e_life_flame);
	e_life_flame.MakePixelBase(window, argScene);

	p_stockGauge.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&p_stockGauge);
	p_stockGauge_flame.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&p_stockGauge_flame);
	e_stockGauge.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&e_stockGauge);
	e_stockGauge_flame.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&e_stockGauge_flame);
	
	p_animaGauge.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&p_animaGauge);
	p_animaGauge_flame.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&p_animaGauge_flame);
	e_animaGauge.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&e_animaGauge);
	e_animaGauge_flame.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&e_animaGauge_flame);

	argScene->entryOverlayModel(&combo);
	combo.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&gameover);
	gameover.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&stageclear);
	stageclear.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&cleartime);
	cleartime.MakePixelBase(window, argScene);		

	argScene->entryOverlayModel(&pause);
	pause.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&bg_black);
	bg_black.MakePixelBase(window, argScene);

	argScene->entryOverlayModel(&help_act);
	help_act.MakePixelBase(window, argScene);
	argScene->entryOverlayModel(&help_anima);
	help_anima.MakePixelBase(window, argScene);

	return;
}


void CDraw::removeScene(fk_Scene *argScene)
{
	argScene->removeOverlayModel(&titleImage);
	argScene->removeOverlayModel(&gamestart);
	argScene->removeOverlayModel(&quit);
	argScene->removeOverlayModel(&cursol);

		for(int j = 0; j < 6; j++) 
		{
			argScene->removeOverlayModel(&timeNumber[j]);
		}

	/*
	for(int i = 0; i < 10; i++)
	{
		for(int j = 0; j < 8; j++) 
		{
			argScene->removeOverlayModel(&p_scoreNumber[i][j]);
			argScene->removeOverlayModel(&e_scoreNumber[i][j]);
		}
	}
	*/

		for(int j = 0; j < 2; j++) 
		{
			argScene->removeOverlayModel(&comboNumber[j]);
		}


	for(int i = 0; i < 2 ; i++ )
	{
		argScene->removeOverlayModel(&coron[i]);
	}

	argScene->removeOverlayModel(&p_icon_bg);
	argScene->removeOverlayModel(&e_icon_bg);

	argScene->removeOverlayModel(&nageru_icon);
	argScene->removeOverlayModel(&rockking_icon);

	argScene->removeOverlayModel(&p_gray_flame);
	argScene->removeOverlayModel(&e_gray_flame);

	argScene->removeOverlayModel(&p_life);
	argScene->removeOverlayModel(&p_life_flame);
	argScene->removeOverlayModel(&e_life);
	argScene->removeOverlayModel(&e_life_flame);

	argScene->removeOverlayModel(&p_stockGauge);
	argScene->removeOverlayModel(&p_stockGauge_flame);
	argScene->removeOverlayModel(&e_stockGauge);
	argScene->removeOverlayModel(&e_stockGauge_flame);

	argScene->removeOverlayModel(&p_animaGauge);
	argScene->removeOverlayModel(&p_animaGauge_flame);
	argScene->removeOverlayModel(&e_animaGauge);
	argScene->removeOverlayModel(&e_animaGauge_flame);

	argScene->removeOverlayModel(&combo);

	argScene->removeOverlayModel(&gameover);

	argScene->removeOverlayModel(&stageclear);
	argScene->removeOverlayModel(&cleartime);

	argScene->removeOverlayModel(&pause);

	argScene->removeOverlayModel(&bg_black);

	argScene->removeOverlayModel(&help_act);
	argScene->removeOverlayModel(&help_anima);
	return;	
}

//^Cg`
void CDraw::drawTitle(int num, fk_Scene *argScene)
{
	bg_black.setPositionLT( -400.0 , 250.0 );
	argScene->entryOverlayModel( &titleImage );

	gamestart.setPositionLT( -72.5 , -100.0 );
	argScene->entryOverlayModel( &gamestart );

	quit.setPositionLT( -72.5 , -150.0 );
	argScene->entryOverlayModel( &quit );

	cursol.setPositionLT( -120.0 , -100.0 + -50*num );
	argScene->entryOverlayModel( &cursol );
	return;
}

//o߃^C`
void CDraw::drawTime( int num , fk_Scene *argScene)
{
	minute = 0 ;
	while( num >= 6000 && minute < 9 )
	{
		num -= 6000 ;
		minute ++ ;
	}
	if( num >= 6000 )
	{
		num = 5999 ;
	}
	
		for(int j=0 ; j<5 ; j++)
		{
			argScene->removeOverlayModel( &timeNumber[j] );
		}
	
	for(int i=0 ; i<6 ; i++)
	{
		if( i > 4 )
		{
			timeNumber[i].setSpriteArea(0+((minute%10)*20), 0, 20, 30);
			timeNumber[i].setPositionLT( 60-i*20-(i/2)*20 , -225.0+45 );
			argScene->entryOverlayModel( &timeNumber[i] );
			minute /= 10;
		}
		else
		{
			timeNumber[i].setSpriteArea(0+((num%10)*20), 0, 20, 30);
			timeNumber[i].setPositionLT( 60-i*20-(i/2)*20 , -225.0+45 );
			argScene->entryOverlayModel( &timeNumber[i] );
			num /= 10 ;
		}
	}
	coron[0].setPositionLT( -15.0-20.0 , -225.0+45 );
	argScene->entryOverlayModel( &coron[0] );
	coron[1].setPositionLT( 5.0+20.0 , -225.0+45 );
	argScene->entryOverlayModel( &coron[1] );

	return;
}

//XRA`
/*
void CDraw::drawScore(int p_scoreNum, int e_scoreNum, fk_Scene *argScene)
{
	//vC[̃XRA
	for(int i=0 ; i<10 ; i++)
	{
		for(int j=0 ; j<8 ; j++)
		{
			argScene->removeOverlayModel( &p_scoreNumber[i][j] );
		}
	}

	for(int i=0 ; i<8 ; i++)
	{
		p_scoreNumber[p_scoreNum%10][i].setPositionLT( -400+90+150-i*15 , -225.0 + 25 );
		argScene->entryOverlayModel( &p_scoreNumber[p_scoreNum%10][i] );
		p_scoreNum /= 10 ;
	}

	//G̃XRA
	for(int i=0 ; i<10 ; i++)
	{
		for(int j=0 ; j<8 ; j++)
		{
			argScene->removeOverlayModel( &e_scoreNumber[i][j] );
		}
	}

	for(int i=0 ; i<8 ; i++)
	{
		e_scoreNumber[e_scoreNum%10][i].setPositionLT( 400-150-i*15 , -225.0 + 25 );
		argScene->entryOverlayModel( &e_scoreNumber[p_scoreNum%10][i] );
		e_scoreNum /= 10 ;
	}

	return;
}
*/

//R{`
void CDraw::drawCombo(int num, fk_Scene *argScene)
{
	if(num>99)
	{
		num = 99;
	}

	if( num > 1)//R{QȏɂȂ
	{
		if(prevCombo == false)
		{
			if(moveCombo < 20)
			{
				posXCombo = moveCombo;
			}
			else
			{
				prevCombo = true;
				moveCombo = 0;
			}
			moveCombo += 4;
		}
		else
		{
			posXCombo = 20;
		}
		combo.setPositionLT(318-posXCombo, 55.0);
		argScene->entryOverlayModel( &combo );
		if(num > 9)
		{
			comboNumber[0].setSpriteArea(0+((num%10)*20), 0, 20, 30);
			comboNumber[0].setPositionLT( 298.0-posXCombo , 60.0 );
			argScene->entryOverlayModel( &comboNumber[0] );
			num = num/10;

			comboNumber[1].setSpriteArea(0+(num*20), 0, 20, 30);
			comboNumber[1].setPositionLT( 278.0-posXCombo , 60.0 );
			argScene->entryOverlayModel( &comboNumber[1] );
		}
		else
		{
			comboNumber[1].setSpriteArea(0+((num%10)*20), 0, 20, 30);
			comboNumber[1].setPositionLT( 298.0-posXCombo , 60.0 );
			argScene->entryOverlayModel( &comboNumber[1] );
		}

	}
	else
	{
		prevCombo = false;
	}

	return;
}

//LN^[ACRADFt[`
void CDraw::drawCharacterIcon(fk_Scene *argScene)
{
	
	p_icon_bg.setPositionLT( -400, -25);
	argScene->entryOverlayModel( &p_icon_bg );
	e_icon_bg.setPositionLT( 400-350, -25);
	argScene->entryOverlayModel( &e_icon_bg );

	nageru_icon.setPositionLT( -400, -105);
	argScene->entryOverlayModel( &nageru_icon);
	rockking_icon.setPositionLT( 400-210, -105);
	argScene->entryOverlayModel( &rockking_icon);

	p_gray_flame.setPositionLT( -400+85, -225+95);
	argScene->entryOverlayModel( &p_gray_flame );
	e_gray_flame.setPositionLT( 400-85-15, -225+95);
	argScene->entryOverlayModel( &e_gray_flame );

	return;
}

//Cto[`
void CDraw::drawLife(double p_hp, double e_hp, fk_Scene *argScene)
{
	nowPHP = p_hp;
	nowEHP = e_hp;

	if(prevPHP > nowPHP)
	{
		prevPHP -= 0.01;
		if(prevPHP < 0 )
		{
			prevPHP = 0;
		}
	}
	if(prevEHP > nowEHP)
	{
		prevEHP -= 0.01;
		if(prevEHP < 0 )
		{
			prevEHP = 0;
		}
	}

	
	p_life_flame.setPositionLT( -400+100, -225+80);
	argScene->entryOverlayModel( &p_life_flame );
	e_life_flame.setPositionLT( 400-100-180, -225+80);
	argScene->entryOverlayModel( &e_life_flame );

	p_life.setSpriteSize( 180.0*prevPHP, -1.0);
	e_life.setSpriteSize( 180.0*prevEHP, -1.0);

	p_life.setPositionLT( -400+100, -225+80);
	argScene->entryOverlayModel( &p_life );
	e_life.setPositionLT( 400-100-(180.0*prevEHP), -225+80);
	argScene->entryOverlayModel( &e_life );
	return;
}

//XgbNQ[W`
void CDraw::drawStockGauge(int p_stockNum, int e_stockNum, fk_Scene *argScene)
{
	p_stockGauge_flame.setPositionLT( -400+100, -225+55);
	argScene->entryOverlayModel( &p_stockGauge_flame );
	e_stockGauge_flame.setPositionLT( 400-100-180, -225+55);
	argScene->entryOverlayModel( &e_stockGauge_flame );


	p_stockGauge.setSpriteArea(0, 0, p_stockNum*(180.0/6)+(p_stockNum==0 ? 8.1 : 0.0), 30);
	e_stockGauge.setSpriteArea(0, 0, e_stockNum*(180.0/6)+(e_stockNum==0 ? 8.1 : 0.0), 30);
	
	
	p_stockGauge.setPositionLT( -400+100, -225+55);
	argScene->entryOverlayModel( &p_stockGauge );
	e_stockGauge.setPositionLT( 400-100-180, -225+55);
	argScene->entryOverlayModel( &e_stockGauge );

	return;
}

//Aj}Q[W`
void CDraw::drawAnimaGauge(double p_animaNum, double e_animaNum, fk_Scene *argScene)
{
	p_animaGauge_flame.setPositionLT( -400+100, -225+20);
	argScene->entryOverlayModel( &p_animaGauge_flame );
	e_animaGauge_flame.setPositionLT( 400-100-180, -225+20);
	argScene->entryOverlayModel( &e_animaGauge_flame );

	p_animaGauge.setSpriteArea(0, 0, 180*p_animaNum+(p_animaNum==0 ? 8.1 : 0.0), 15);
	e_animaGauge.setSpriteArea(0, 0, 180*e_animaNum+(e_animaNum==0 ? 8.1 : 0.0), 15);

	p_animaGauge.setPositionLT( -400+100, -225+20);
	argScene->entryOverlayModel( &p_animaGauge );
	e_animaGauge.setPositionLT( 400-100-180-(180.0*e_animaNum), -225+20);
	argScene->entryOverlayModel( &e_animaGauge );
	return;
}

//Q[I[o[ʕ`
void CDraw::drawGameOver(fk_Scene *argScene)
{
	gameover.setPositionLT(-400.0, 250.0);
	argScene->entryOverlayModel( &gameover);
	return;
}

//Q[NAʕ`
void CDraw::drawGameClear(int num, fk_Scene *argScene)
{
	bg_black.setPositionLT( -400.0 , 250.0 );
	argScene->entryOverlayModel( &bg_black );

	stageclear.setPositionLT(-145.0, 70.0);
	argScene->entryOverlayModel( &stageclear);

	cleartime.setPositionLT(-140.0, -80.0);
	argScene->entryOverlayModel( &cleartime);

	minute = 0 ;
	while( num >= 6000 && minute < 9 )
	{
		num -= 6000 ;
		minute ++ ;
	}
	if( num >= 6000 )
	{
		num = 5999 ;
	}
	
		for(int j=0 ; j<5 ; j++)
		{
			argScene->removeOverlayModel( &timeNumber[j] );
		}
	
	for(int i=0 ; i<5 ; i++)
	{
		if( i == 4 )
		{
			timeNumber[i].setSpriteArea(0+(minute*20), 0, 20, 30);
			timeNumber[i].setPositionLT( 120.0-i*20-(i/2)*10 , -80.0 );
			argScene->entryOverlayModel( &timeNumber[i] );
		}
		else
		{
			timeNumber[i].setSpriteArea(0+((num%10)*20), 0, 20, 30);
			timeNumber[i].setPositionLT( 120.0-i*20-(i/2)*10 , -80.0 );
			argScene->entryOverlayModel( &timeNumber[i] );
			num /= 10 ;
		}
	}
	coron[0].setPositionLT( 42.0 , -80.0 );
	argScene->entryOverlayModel( &coron[0] );
	coron[1].setPositionLT( 92.0 , -80.0 );
	argScene->entryOverlayModel( &coron[1] );

	return;
}

//|[Yʕ`
void CDraw::drawPause(fk_Scene *argScene)
{
	pause.setPositionLT(-145.0, 70.0);
	argScene->entryOverlayModel( &pause);
	return;
}

//wṽIIt̐؂ւ
void CDraw::switchHelp()
{
	if(isDrawHelp == true ) isDrawHelp = false;
	else isDrawHelp = true;
	return;
}


//wvACR`
void CDraw::drawHelp(fk_Scene *argScene)
{
	if(isDrawHelp == true ){
	help_act.setPositionLT(-400.0, 225.0);
	argScene->entryOverlayModel( &help_act);
	help_anima.setPositionLT(400.0-200.0, 225.0);
	argScene->entryOverlayModel( &help_anima);
	}
	return;
}

//`̏ݒ̏
void CDraw::initDraw()
{
	minute = 0;
	prevPHP = 1.0;
	nowPHP = 0;
	prevEHP = 1.0;
	nowEHP = 0;

	prevCombo = false;
	moveCombo = 0;
	posXCombo = 0;

	return;
}

//fobOp
void CDraw::debug()
{
	printf( "%d\n", 1);
	return;
}