#include "common.h"

#include "Enemy.h"

CEnemy::CEnemy(void)
{
	enemyObb.setBlockSize(120.0, 120.0, 120.0);
	enemyObb.setModel(&enemyModel);
	enemy.setSize(120.0, 120.0, 120.0);
	enemyModel.glMoveTo(0.0, 60.1, -180.0);
	enemyModel.setMaterial(Purple);
	enemyModel.setShape(&enemy);
	enemyModel.setSmoothMode(true);

	shadow.setDivide(20);
	shadow.setTopRadius(60.0);
	shadow.setBottomRadius(60.0);
	shadow.setHeight(0.1);
	shadowModel.setShape(&shadow);
	shadowModel.setMaterial(MatBlack);
	shadowModel.glVec(0, 1, 0);
	shadowOBB.setBlockSize(120.0, 0.1, 120.0);
	shadowOBB.setModel(&shadowModel);
	shadowSpd = (0, -20, 0);

	spd = (0.0, 0.0, 0.0);

	MaxHP = 200;	//őHP
	HP = MaxHP;
	isAlive = true;
	isDamage = false;
	damageCount = 0;
	invCount = 0;

	enemyAI = 0;
	attackPattern = 0;	//U@
	movePattern = 0;	//ړ@

	actCount = 0;

	judgeTurnToPlayer = true;
	isDamageBody = false;
	hitFlagToBlock = false;	//ubNƂԂĂ邩

	// [Vp̕ϐ(gpȂ̂ŕK{ł͂Ȃ)
	motionID = ENEMY_STOP;

	debugNum = 1;

	return;
};

CEnemy::~CEnemy(void)
{
};

void CEnemy::entryScene(fk_Scene *argScene)
{
	argScene->entryModel(&enemyModel);
	argScene->entryModel(&shadowModel);

	return;
}

//*spd擾
fk_Vector * CEnemy::getPSpd()
{
	return &spd;
}

//G̈ʒu擾
fk_Vector CEnemy::getPos()
{
	return enemyModel.getPosition();
}

//Gf擾
fkut_OBB CEnemy::getEnemyObb()
{
	return enemyObb;
}

//Ǧ擾
fk_Vector CEnemy::getVec()
{
	return enemyModel.getVec();
}

//vC[Ƃ̏Փˏ
bool CEnemy::checkCollisionToPlayer(fkut_OBB &playerOBB, fk_Vector *spd)
{
	static fk_Vector back, refV;
	bool hitFlagToPlayer = false;

	judgeTurnToPlayer = true;

	// Փ˔̊Jn
	if(isDamageBody == false)
	{
		do{
			back.init();
			if(enemyObb.checkVSMovingOBB(playerOBB, (*spd)+back, refV)) 
			{
				//back += -refV;
				back += fk_Vector(-refV.x, 0.0, -refV.z);
				hitFlagToPlayer = true;
				judgeTurnToPlayer = false;
			}

			(*spd) += back;
		}
		while(!back.isZero());
	}
	else
	{
		do{
			back.init();
			if(enemyObb.checkVSMovingOBB(playerOBB, (*spd)+back, refV)) 
			{	
				back += fk_Vector(0.0, 0.0, -refV.z*1.5);
				hitFlagToPlayer = true;
				judgeTurnToPlayer = false;
			}
			(*spd) += back;
		}
		while(!back.isZero());
	}

	return hitFlagToPlayer;
}


//Gւ̃_[W
void CEnemy::damageEnemy(double num)
{
	if(invCount < 1 )//GԂǂ
	{
		HP -= num;
		if(HP < 0)
		{
			HP = 0;
		}
		isDamage = true;
	}
	return;
}

//G̔_[W̉\
void CEnemy::setDamageState()
{
	if(isDamage == true )//_[W󂯂ĂƂ
	{
		if(damageCount > 10 )//10t[Ōɖ߂
		{
			isDamage = false;
			damageCount = 0;
		}

		//_[W󂯂Ă邱Ƃ\_ŏ
		if(damageCount % 4 == 0)
		{
			enemyModel.setMaterial(Purple);
		}
		else if(damageCount % 2 == 0)
		{
			enemyModel.setMaterial(DarkRed);
		}
		damageCount ++;
	}
	return;
}

//Gւ̖GԂ̐ݒ菈
void CEnemy::setInv()
{
	if(isDamage == true )//_[W󂯂Ă鎞
	{
		//80t[ŖGԏI
		if(invCount > 80 )
		{
			isDamage = false;
			invCount = 0;
		}

		//GԂ\_ŏccǃ_[WHĂ鎞ƈꏏ̕\
		if(invCount % 20 == 0)
		{
			enemyModel.setMaterial(Purple);
		}
		else if(invCount % 10 == 0)
		{
			enemyModel.setMaterial(DarkRed);
		}
		invCount ++;
	}
	return;
}	

//G̐S菈
void CEnemy::setAliveFlag()
{
	isAlive = true;
	if(HP <= 0)//łfalse
	{
		isAlive = false;
	}
	return;
}

//G̐S擾
bool CEnemy::getAliveFlag()
{
	return isAlive;
}

//ƓĂ邩̔
void CEnemy::judgeHitToBlock()
{
	hitFlagToBlock = true;
	return;
}

//vC[̕֌
void CEnemy::focusToPlayer(fk_Vector pos)
{
	if(judgeTurnToPlayer == true)
	{
		enemyModel.glFocus(pos.x, getPos().y, pos.z);
		enemyModel.loFocus(0, 0, 1);
	}
	return;
}

//G̑̂ɍU肪邩ǂ̎擾
bool CEnemy::getIsDamageBody()
{
	return isDamageBody;
}

//GAIJEg̑ƍsp^[̌
void CEnemy::plusAICount()
{
	if(motionID == ENEMY_STOP )
	{
		enemyAI ++;
		judgeTurnToPlayer = false;
		if(enemyAI > 240 )
		{	
			enemyAI = 0;
			motionID = ENEMY_WARP;
		}
		return;
	}

	if(motionID == ENEMY_WARP)
	{
		isDamageBody = false;
		motionID = ENEMY_MOVE;
		return;
	}

	if(motionID == ENEMY_MOVE)
	{
		enemyAI ++;

		if(enemyAI > 225 )
		{	
			enemyAI = 0;
			isDamageBody = true;
			motionID = ENEMY_FALL_S;
		}
		return;
	}

	if(motionID == ENEMY_FALL_S)
	{
		enemyAI ++;

		if(enemyAI > 15 )
		{
			enemyAI = 0;
			motionID = ENEMY_FALL;
		}
		return;
	}

	if(motionID == ENEMY_FALL )
	{
		judgeTurnToPlayer = false;

		if(hitFlagToBlock == true )
		{
			hitFlagToBlock = false;
			spd = fk_Vector(0.0, 0.0, 0.0);
			switch(attackPattern)
			{
			case 0:
				motionID = ENEMY_ATTACK_W;
				isDamageBody = true;
				attackPattern = 1;
				break;

			case 1:
				motionID = ENEMY_ATTACK_H;
				isDamageBody = true;
				attackPattern = 2;
				break;

			case 2:
				motionID = ENEMY_ATTACK_M;
				isDamageBody = true;
				attackPattern = 0;
				break;

			default:
				break;
			}
			return;
		}

		if(getPos().y <= -30.0 )
		{
			damageEnemy(100);
			motionID = ENEMY_WARP;
		}

		return;
	}

	if(motionID == ENEMY_ATTACK_W || motionID == ENEMY_ATTACK_H || motionID == ENEMY_ATTACK_M)
	{
		judgeTurnToPlayer = false;
		hitFlagToBlock = false;
		isDamageBody = false;
		motionID = ENEMY_STOP;	
		return ;
	}

	return;
}

//肳ꂽsp^[ɂčs
void CEnemy::actAI()
{
	actCount ++;

	switch(motionID)
	{
	case ENEMY_STOP:
		spd = fk_Vector(0.0, 0.0, 0.0);
		break;

	case ENEMY_WARP:
		enemyModel.glMoveTo(getPos().x, 180.0, getPos().z );
		spd = fk_Vector(0.0, 0.2, 0.3);
		motionID = ENEMY_MOVE;
		break;

	case ENEMY_MOVE:
		if(actCount % 30 == 0 )
		{
			spd.y *= -1.0;
		}

		if( actCount > 60 )
		{
			actCount = 0;
		}

		break;

	case ENEMY_FALL_S:	
		break;

	case ENEMY_FALL:
		spd = fk_Vector(0.0, -4.0, 0.0);

		break;

	case ENEMY_ATTACK_W:
		break;

	case ENEMY_ATTACK_H:
		break;

	case ENEMY_ATTACK_M:
		break;

	default:
		break;
	}

	enemyModel.loTranslate(spd);	

	if(hitFlagToBlock == true )
	{
		enemyModel.glTranslate(0.0, 0.1, 0.0);
	}

	return;
}

//ëړ
void CEnemy::moveShadow()
{

	shadowModel.glMoveTo(getPos().x, 4.0, getPos().z);
	return;
}

//Ƃ̏Փˊm
void CEnemy::initHitFlagToBlock()
{
	hitFlagToBlock = false;
	return;
}

//GAIp^[̎擾
int CEnemy::getAIPattern()
{
	return motionID;
}		

//G`攻菈
void CEnemy::drawEnemy()
{
	if( isAlive == true )//ĂΕ`
	{
		if(debugNum != 0)
		{
			enemyModel.setDrawMode(FK_POINTMODE | FK_LINEMODE | FK_POLYMODE);
		}
		else
		{
			enemyModel.setDrawMode(FK_NONEMODE);
		}
	}
	else
	{
		enemyModel.setDrawMode(FK_NONEMODE);	
	}
	return;
}

//HP̊擾
double CEnemy::getHPrate()
{
	double rate = 0;
	rate = HP / MaxHP;
	return rate;
}


//G̏ݒ̏
void CEnemy::initEnemy()
{
	enemyModel.glMoveTo(0.0, 60.1, -180.0);
	HP = MaxHP;
	isAlive = true;
	isDamage = false;
	damageCount = 0;
	invCount = 0;

	enemyAI = 0;
	attackPattern = 0;	//U@
	movePattern = 0;	//ړ@

	actCount = 0;

	//hitFlagToBlock = false;	//ubNƂԂĂ邩

	// [Vp̕ϐ(gpȂ̂ŕK{ł͂Ȃ)
	motionID = ENEMY_STOP;

	return;
}

//fobOp
void CEnemy::debugHitCheck()
{
	if(debugNum != 0 )
	{
		//蔻
		debugNum = 0;
	}
	else
	{
		//蔻o
		debugNum = 1;
	}
	return;
}

//fobOp
void CEnemy::debug()
{
	printf( "%d\n", motionID);
	//printf( "%d\n", hitFlagToBlock);
	return;
}