#include "common.h"

#include "EnemyAttack.h"

CEnemyAttack::CEnemyAttack(fk_Vector pos)
{
	for(int i=0 ; i < bulletNum; i++ )
	{
		bulletModel[i].glMoveTo(pos.x, pos.y-12.5, pos.z);
		
		bulletObb[i].setBlockSize(60.0, 10.0, 25.0);
		bulletObb[i].setModel(&bulletModel[i]);
		bullet[i].setSize(60.0, 10.0, 25.0);
		bulletModel[i].setMaterial(DarkPurple);
		bulletModel[i].setShape(&bullet[i]);

		if(!shockWaveObj[i].loadObjectData("rocking/shockwave.mqo")) fl_alert("[shockwave.mqo] Read Error.");
		if(!shockWave_wObj[i].loadObjectData("rocking/shockwave_w.mqo")) fl_alert("[shockwave_w.mqo] Read Error.");

		if(!shockWaveObj[i].loadJointData("rocking/shockwave.fkc")) fl_alert("[shockwave.fkc] Read Error.");
		if(!shockWave_wObj[i].loadJointData("rocking/shockwave_w.fkc")) fl_alert("[shockwave_w.fkc] Read Error.");

		isHitBullet[i] = false;
		isMoveBullet[i] = false;
		bulletCount[i] = 0;
	}

	AIcount = 4;

	debugNum = 1;

	return;
};

CEnemyAttack::~CEnemyAttack(void)
{
};

void CEnemyAttack::entryScene(fk_Scene *argScene)
{
	for(int i=0; i< bulletNum; i++)
	{
		argScene->entryModel(&bulletModel[i]);
	}
	return;
}

//vC[ƒeƂ̏Փˏ
bool CEnemyAttack::checkBulletCollision(fkut_OBB &playerOBB, fk_Vector *spd, fk_Vector pos)
{
	static fk_Vector back, refV;
	bool hitFlag = false;


	for(int i=0; i< bulletNum ; i++ )
	{
		if(isHitBullet[i] == true )
		{
			// Փ˔̊Jn
			back.init();
			if(bulletObb[i].checkVSMovingOBB(playerOBB, (*spd), refV)) 
			{
				hitFlag = true;
				back += -refV*2.0; //ubN葽߂ɔ	]
				isMoveBullet[i] = false;
				isHitBullet[i] = false;
			}
			(*spd) += back;
		}
	}
	return hitFlag;
}

//Se̎擾
int CEnemyAttack::getBulletNum()
{
	return bulletNum;
}

//GĂ邩ǂ̒l̓
void CEnemyAttack::setEnemyAlive(bool isAlive)
{
	isEnemyAlive = isAlive;
	return;
}

//^ɓG̒ě`ύX
void CEnemyAttack::setBulletWideSize(fk_Scene *argScene)
{
	for(int i=0 ; i < bulletNum; i++ )
	{
		bulletObb[i].setBlockSize(60.0, 10.0, 15.0);
		bulletObb[i].setModel(&bulletModel[i]);
		bullet[i].setSize(60.0, 10.0, 15.0);
		shockWave_wObj[i].entryScene(argScene);
	}
	return;
}

//c^ɓG̒ě`ύX
void CEnemyAttack::setBulletHeightSize(fk_Scene *argScene)
{
	for(int i=0 ; i < bulletNum; i++ )
	{
		bulletObb[i].setBlockSize(10.0, 60.0, 15.0);
		bulletObb[i].setModel(&bulletModel[i]);
		bullet[i].setSize(10.0, 60.0, 15.0);

		bulletModel[i].loTranslate(0.0, 1.0, 0.0);

		shockWaveObj[i].entryScene(argScene);
	}
	return;
}
	
//^ɓG̒ě`ύX
void CEnemyAttack::setBulletMultiSize(fk_Scene *argScene)
{
	for(int i=0 ; i < bulletNum; i++ )
	{
		if( i %2 == 1)
		{
			bulletObb[i].setBlockSize(60.0, 10.0, 25.0);
			bulletObb[i].setModel(&bulletModel[i]);
			bullet[i].setSize(60.0, 10.0, 25.0);

			shockWave_wObj[i].entryScene(argScene);
		}
		else
		{
			bulletObb[i].setBlockSize(10.0, 60.0, 15.0);
			bulletObb[i].setModel(&bulletModel[i]);
			bullet[i].setSize(10.0, 60.0, 15.0);

			shockWaveObj[i].entryScene(argScene);

			bulletModel[i].loTranslate(0.0, 1.0, 0.0);
		}
	}
	return;
}


//ȇxA̐ݒ菈
void CEnemyAttack::setBulletVec(fk_Scene *argScene)
{
	for(int i=0; i< bulletNum; i++ )
	{
		if(isMoveBullet[i] == false)
		{
			switch(AIcount)
			{
			case 4:
				setBulletWideSize(argScene);
				break;

			case 5:
				setBulletHeightSize(argScene);
				break;

			case 6:
				setBulletMultiSize(argScene);
				break;

			default:
				break;
			}

			if( i == 0 )
			{
				bulletModel[i].loFocus(0, 0, 1);
				bulletModel[i].loTranslate(0.0, 0.0, -30.0);
			}
			else
			{
				bulletModel[i].glVec(bulletModel[i-1].getVec());
				bulletModel[i].loFocus(-0.37, 0.0, -1.0);
				bulletModel[i].loTranslate(0.0, 0.0, -30.0);
			}
			

			isMoveBullet[i] = true;
			isHitBullet[i] = true;

		}
		else
		{
			break;
		}
	}
	return;
}

//ëړ
void CEnemyAttack::moveBullet(fk_Vector pos)
{
	for(int i=0; i< bulletNum; i++ )
	{
		if(isMoveBullet[i] == true)
		{
			bulletModel[i].loTranslate(0, 0, -3.0);
			bulletCount[i] ++;

			shockWaveObj[i].getBaseModel()->glMoveTo(bulletModel[i].getPosition() );
			shockWaveObj[i].getBaseModel()->loTranslate(0.0, 0.0, 7.0 );
			shockWaveObj[i].getBaseModel()->glAngle(bulletModel[i].getAngle() );
			shockWaveObj[i].getBaseModel()->loFocus(0, 0, 1);
			shockWave_wObj[i].getBaseModel()->glMoveTo(bulletModel[i].getPosition() );
			shockWave_wObj[i].getBaseModel()->loTranslate(0.0, 0.0, 7.0 );
			shockWave_wObj[i].getBaseModel()->glAngle(bulletModel[i].getAngle() );
			shockWave_wObj[i].getBaseModel()->loFocus(0, 0, 1);
			if(bulletCount[i] > 200 )
			{
				isMoveBullet[i] = false;
				isHitBullet[i] = false;
			}
		}
	}
	return;
}

//ëʒȕ
void CEnemyAttack::initBulletPos(fk_Vector pos, fk_Scene *argScene)
{
	for( int i=0; i< bulletNum ; i++ )
	{
		if(isMoveBullet[i] == false || isHitBullet[i] == false)
		{
			bulletModel[i].glMoveTo(pos.x, pos.y-52.5, pos.z);
			bulletCount[i] = 0;
			shockWaveObj[i].removeScene(argScene);
			shockWave_wObj[i].removeScene(argScene);
		}
	}
}


//e̕`
void CEnemyAttack::drawBullet()
{
	if( isEnemyAlive == true )//GĂƂf`
	{
		for( int i=0; i< bulletNum; i++ )
		{
			if( isMoveBullet[i] == true && isHitBullet[i] == true )
			{
				bulletModel[i].setDrawMode(FK_POINTMODE | FK_LINEMODE | FK_POLYMODE);
			}
			else
			{
				bulletModel[i].setDrawMode(FK_NONEMODE);	
			}

			if(debugNum == 0)
			{
				bulletModel[i].setDrawMode(FK_NONEMODE);
			}
		}
	}
	else
	{
		for( int i=0; i< bulletNum; i++ )
		{
			bulletModel[i].setDrawMode(FK_NONEMODE);	
		}
	}

	return;
}

//GAIp^[I
void CEnemyAttack::choiceEnemyAI(int aiNum, fk_Scene *argScene)
{
	switch(aiNum)
	{
	case -1:
		
		break;
	
	case 4://e
		AIcount = 4;
		setBulletVec(argScene);
		break;

	case 5://ce
		AIcount = 5;
		setBulletVec(argScene);
		break;

	case 6://e
		AIcount = 6;
		setBulletVec(argScene);
		break;

	default:
		break;
	}
	return;
}

//G̍UNX̏ݒ̏
void CEnemyAttack::initEnemyAttack()
{
	for(int i=0 ; i < bulletNum; i++ )
	{
		isHitBullet[i] = false;
		isMoveBullet[i] = false;
		bulletCount[i] = 0;
	}

	return;
}

//蔻fobOp
void CEnemyAttack::debugHitCheck()
{
	if(debugNum != 0 )
	{
		//蔻
		debugNum = 0;
	}
	else
	{
		//蔻o
		debugNum = 1;
	}
	return;
}

//fobOp
void CEnemyAttack::debug()
{
	printf( "%d\n", isHitBullet[0]);
	return;
}