#include "common.h"

#include "Sound.h"

CSound::CSound(void)
{
	if( !titleBGM.open( "music/INNOCENT_FLIER.ogg" ) )	fl_alert( "error read[INNOCENT_FLIER.ogg]" );
	titleBGM.setLoopMode(true);
	if( !stageBGM.open( "music/GET_OVER_THE_WALL!!.ogg" ) )	fl_alert( "error read[GET_OVER_THE_WALL!!.ogg]" );
	stageBGM.setLoopMode(true);
	if( !rivalBGM.open( "music/rival.ogg" ) )	fl_alert( "error read[rival.ogg]" );
	stageBGM.setLoopMode(true);
	
	isPlayTitleBGM = true;
	isPlayStageBGM = true;
	isPlayRivalBGM = true;

	if( !jumpSE.open( "music/jump.wav" ) )	fl_alert( "error read[jump.wav]" );
	if( !damageSE.open( "music/damage.wav" ) )	fl_alert( "error read[damage.wav]" );
	if( !liftSE.open( "music/get.wav" ) )	fl_alert( "error read[get.wav]" );
	if( !fallSE.open( "music/fall.wav" ) )	fl_alert( "error read[fall.wav]" );
	//if( !slashSE.open( "music/slash.wav" ) )	fl_alert( "error read[slash.wav]" );
	if( !slashSE.open( "music/tm2_slash000.wav" ) )	fl_alert( "error read[tm2_slash000.wav]" );
	if( !throwSE.open( "music/tm2_gun000.wav" ) )	fl_alert( "error read[tm2_gun000.wav]" );

	typeBGM = 0;

	return;
};

CSound::~CSound(void)
{
};

//^CgBGMĐ
void CSound::playTitleBGM()
{
	titleBGM.play();
	isPlayTitleBGM = true;
	return;
}

//^CgBGM~
void CSound::stopTitleBGM()
{
	titleBGM.stop();
	titleBGM.seek( 0.0 );
	isPlayTitleBGM = false;
	return;
}

//^CgBGM̍ĐԎ擾
bool CSound::getPlayTitleBGM()
{
	return isPlayTitleBGM;
}

//Xe[WBGMĐ
void CSound::playStageBGM()
{
	stageBGM.play();
	isPlayStageBGM = true;
	return;
}

//Xe[WBGM~
void CSound::stopStageBGM()
{
	stageBGM.stop();
	stageBGM.seek( 0.0 );
	isPlayStageBGM = false;
	return;
}

//Xe[WBGMĐԎ擾	
bool CSound::getPlayStageBGM()
{
	return isPlayStageBGM;
}

//CoBGMĐ
void CSound::playRivalBGM()
{
	rivalBGM.play();
	isPlayRivalBGM = true;
	return;
}

//CoBGM~
void CSound::stopRivalBGM()
{
	rivalBGM.stop();
	rivalBGM.seek( 0.0 );
	isPlayRivalBGM = false;
	return;
}

//CoBGMĐԎ擾
bool CSound::getPlayRivalBGM()
{
	return isPlayRivalBGM;
}

//ĐĂBGM̎ނ擾
int CSound::getTypeBGM()
{
	return typeBGM;
}

//ĐĂBGM̎ނύX
void CSound::changeTypeBGM()
{
	typeBGM ++;
	if(typeBGM > 3 )
	{
		typeBGM = 0;
	}
	return;
}

//WvSEĐ
void CSound::playJumpSE()
{
	jumpSE.seek( 0.0 );
	jumpSE.play();
	return;
}

//_[WSEĐ
void CSound::playDamageSE()
{
	damageSE.seek( 0.0 );
	damageSE.play();
	return;
}

//ubNグSEĐ
void CSound::playLiftSE()
{
	liftSE.seek( 0.0 );
	liftSE.play();
	return;
}

//SEĐ
void CSound::playFallSE()
{
	fallSE.seek( 0.0 );
	fallSE.play();
	return;
}

//ߐڍUSEĐ
void CSound::playSlashSE()
{
	slashSE.seek( 0.0 );
	slashSE.play();
	return;
}

//SEĐ
void CSound::playThrowSE()
{
	throwSE.seek( 0.0 );
	throwSE.play();
	return;
}

//TEhiS~
void CSound::initSound()
{
	isPlayStageBGM = true;

	stageBGM.stop();
	stageBGM.seek( 0.0 );
	jumpSE.stop();
	jumpSE.seek( 0.0 );
	damageSE.stop();
	damageSE.seek( 0.0 );
	liftSE.stop();
	liftSE.seek( 0.0 );
	fallSE.stop();
	fallSE.seek( 0.0 );
	return;
}

//fobO
void CSound::debug()
{
	printf( "%d\n", typeBGM);
	return;
}